// API.h : CAPI	̐錾

#ifndef	__API_H_
#define	__API_H_

#include "DonutPCP.h"

#include "MDIChildUserMessenger.h"
#include "CloseTitle.h"
#include "aboutdlg.h"
#include "ChildFrm.h"
#include "MainFrm.h"

extern CMainFrame* g_pMainWnd;

class CAPI;
extern CAPI* g_pAPI;

/////////////////////////////////////////////////////////////////////////////
// CAPI
class ATL_NO_VTABLE	CAPI :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CAPI, &CLSID_API>,
	public IConnectionPointContainerImpl<CAPI>,
	public IDispatchImpl<IAPI, &IID_IAPI, &LIBID_DONUTPLib>,
	public CProxyIDonutPEvents<	CAPI >
{
public:
	CAPI()
	{
	}

public:

DECLARE_REGISTRY_RESOURCEID(IDR_API)

DECLARE_PROTECT_FINAL_CONSTRUCT()


BEGIN_COM_MAP(CAPI)
	COM_INTERFACE_ENTRY(IAPI)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CAPI)
	CONNECTION_POINT_ENTRY(DIID_IDonutPEvents)
END_CONNECTION_POINT_MAP()

// IAPI
public:
	STDMETHOD(Advise)(IUnknown*	pUnk, DWORD* pdwCookie);
/*	{
		HRESULT	hr = CProxy_IDonutPEvents<CAPI>::Advise(pUnk, pdwCookie);
		if (SUCCEEDED(hr))
			g_pAPI = this;

		return hr;
	}
*/
	STDMETHOD(Unadvise)(DWORD dwCookie);
/*	{
		HRESULT	hr = CProxy_IDonutPEvents<CAPI>::Unadvise(dwCookie);
		if (SUCCEEDED(hr))
			g_pAPI = NULL;

		return hr;
	}
*/
	STDMETHOD(GetPanelWebBrowserObject)(/*[out,	retval]*/IDispatch*	*pVal)
	{
		if (!g_pMainWnd) return	S_OK;
		*pVal =	g_pMainWnd->ApiGetPanelWebBrowserObject();
		return S_OK;
	}
	STDMETHOD(GetPanelWindowObject)(/*[out,	retval]*/IDispatch*	*pVal)
	{
		if (!g_pMainWnd) return	S_OK;
		*pVal =	g_pMainWnd->ApiGetPanelWindowObject();
		return S_OK;
	}
	STDMETHOD(GetPanelDocumentObject)(/*[out, retval]*/IDispatch* *pVal)
	{
		if (!g_pMainWnd) return	S_OK;
		*pVal =	g_pMainWnd->ApiGetPanelDocumentObject();
		return S_OK;
	}
	STDMETHOD(GetTabState)(int nIndex, /*[out, retval]*/long *pVal)
	{
		if (!g_pMainWnd) return	S_OK;
		*pVal =	g_pMainWnd->GetTabState(nIndex);
		return S_OK;
	}
	STDMETHOD(ShowPanelBar)()
	{
		if (!g_pMainWnd) return	S_OK;
		g_pMainWnd->ApiShowPanelBar();
		return S_OK;
	}

	STDMETHOD(MessageBox)(BSTR bstrText, BSTR bstrCaption, UINT	uType, /*[out, retval]*/ long *pVal)
	{
		if (!g_pMainWnd) return	S_OK;
		CString	strText(bstrText);
		CString	strCaption(bstrCaption);
		*pVal =	::MessageBox(g_pMainWnd->m_hWnd, strText, strCaption, uType);
		return S_OK;
	}

	STDMETHOD(NewWindow)(BSTR bstrURL, BOOL	bActive, /*[out, retval]*/ long	*pVal)
	{
		if (!g_pMainWnd) return	S_OK;
		*pVal =	g_pMainWnd->ApiNewWindow(bstrURL, bActive);
		return S_OK;
	}

	STDMETHOD(MoveToTab)(WORD wBefor, WORD wAfter)
	{
		if (!g_pMainWnd) return	S_OK;
		g_pMainWnd->ApiMoveToTab(wBefor, wAfter);
		return S_OK;
	}

	STDMETHOD(GetTabCount)(/*[out, retval]*/ long *pVal)
	{
		if (!g_pMainWnd) return	S_OK;
		*pVal =	g_pMainWnd->ApiGetTabCount();
		return S_OK;
	}
	STDMETHOD(get_TabIndex)(/*[out,	retval]*/ long *pVal)
	{
		if (!g_pMainWnd) return	S_OK;
		*pVal =	g_pMainWnd->ApiGetTabIndex();
		return S_OK;
	}
	STDMETHOD(put_TabIndex)(/*[in]*/ long newVal)
	{
		if (!g_pMainWnd) return	S_OK;
		g_pMainWnd->ApiSetTabIndex(newVal);
		return S_OK;
	}
	STDMETHOD(GetWindowObject)(int nIndex, /*[out, retval]*/IDispatch* *pVal)
	{
		if (!g_pMainWnd) return	S_OK;
		*pVal =	g_pMainWnd->ApiGetWindowObject(nIndex);
		return S_OK;
	}
	STDMETHOD(GetDocumentObject)(int nIndex, /*[out, retval]*/IDispatch* *pVal)
	{
		if (!g_pMainWnd) return	S_OK;
		*pVal =	g_pMainWnd->ApiGetDocumentObject(nIndex);
		return S_OK;
	}
	STDMETHOD(GetWebBrowserObject)(int nIndex, /*[out, retval]*/IDispatch* *pVal)
	{
		if (!g_pMainWnd) return	S_OK;
		*pVal =	g_pMainWnd->ApiGetWebBrowserObject(nIndex);
		return S_OK;
	}
	STDMETHOD(Close)(int nIndex)
	{
		if (!g_pMainWnd) return	S_OK;
		g_pMainWnd->ApiClose(nIndex);
		return S_OK;
	}
};

#endif //__API_H_
