#ifndef	__ACCELMANAGER_H__
#define	__ACCELMANAGER_H__

#if	_MSC_VER > 1000
#pragma	once
#endif // _MSC_VER > 1000

class CKeyHelper
{
public:
	CKeyHelper():m_lpAccel(NULL){};
	CKeyHelper(LPACCEL lpAccel):m_lpAccel(lpAccel){};
	~CKeyHelper(){};

// Operations:
public:
	void Format	(CString& str) const
	{
		str.Empty ();

		if (m_lpAccel==NULL) return;
		if (m_lpAccel->fVirt&FCONTROL)	AddVirtKeyStr (str,	VK_CONTROL);
		if (m_lpAccel->fVirt&FSHIFT)	AddVirtKeyStr (str,	VK_SHIFT);
		if (m_lpAccel->fVirt&FALT)		AddVirtKeyStr (str,	VK_MENU);
		if (m_lpAccel->fVirt&FVIRTKEY)	AddVirtKeyStr (str,	m_lpAccel->key,	TRUE);
		else							str	+= (char) m_lpAccel->key;
	}

protected:
	void AddVirtKeyStr (CString& str, UINT uiVirtKey, BOOL bLast = FALSE) const
	{
		#define	BUFFER_LEN 50
		TCHAR szBuffer [BUFFER_LEN + 1];
		szBuffer[0]	= 0;					//+++ unDonut+modf. G[Ԃꂽꍇ̑΍.

		UINT nScanCode = ::MapVirtualKeyEx (uiVirtKey, 0,
			::GetKeyboardLayout	(0)) <<16 |	0x1;

		if (uiVirtKey >= VK_PRIOR && uiVirtKey <= VK_HELP)
		{
			nScanCode |= 0x01000000;
		}

		int	l =								//+++ unDonut+modf. G[Ԃꂽꍇ̑΍.
		::GetKeyNameText (nScanCode, szBuffer, BUFFER_LEN);

		if (l >	0 && szBuffer[0] !=	0) {	//+++ unDonut+modf. G[Ԃꂽꍇ̑΍.
			CString	strKey(szBuffer);
			strKey.MakeLower();

			//--------------------------------------
			// The first letter	should be uppercase:
			//--------------------------------------
			for	(int nCount	= 0; nCount	< strKey.GetLength(); nCount++)
			{
				TCHAR c	= strKey[nCount];
				if (IsCharLower	(c))
				{
					// Convert single character	JY 4-Dec-99
					c =	(TCHAR)	toupper	(c);
					strKey.SetAt (nCount, c);
					break;
				}
			}

			str	+= strKey;

			if (!bLast)
			{
				str	+= '+';
			}
		}
	}

// Atttributes:
public:
	void SetAccelerator	(LPACCEL lpAccel)
	{
		m_lpAccel =	lpAccel;
	}

protected:
	LPACCEL	m_lpAccel;
};

class CAccelerManager
{
	HACCEL	m_hAccel;
	LPACCEL	m_lpAccel;
	int		m_nAccelSize;

public:
	CAccelerManager(HACCEL hAccel)
	{
		m_hAccel = hAccel;
		m_nAccelSize = ::CopyAcceleratorTable(m_hAccel,	NULL, 0);
		m_lpAccel =	new	ACCEL [m_nAccelSize];
		::CopyAcceleratorTable(m_hAccel, m_lpAccel,	m_nAccelSize);
	}

	~CAccelerManager()
	{
		if (m_lpAccel) delete m_lpAccel;
	}

public:
	int	GetCount(){return m_nAccelSize;};
	LPACCEL	GetAt(int index){return	 &m_lpAccel[index];};

	BOOL FindAccelerator(UINT uiCmd, CString& str)
	{
		BOOL bFound=FALSE;
		for	(int ii=0; ii<m_nAccelSize && !bFound; ii++)
		{
			if (m_lpAccel[ii].cmd == uiCmd)
			{
				CKeyHelper helper (&m_lpAccel[ii]);
				helper.Format(str);

				bFound = TRUE;
			}
		}

		return bFound;
	}

	UINT FindCommandID(ACCEL* pAccel)
	{
		UINT uiCmd=0;
		BOOL bFound=FALSE;
		for	(int ii=0; ii<m_nAccelSize && !bFound; ii++)
		{
			if ((pAccel->fVirt&FALT) !=	(m_lpAccel[ii].fVirt&FALT))				continue;
			if ((pAccel->fVirt&FCONTROL) !=	(m_lpAccel[ii].fVirt&FCONTROL))		continue;
			if ((pAccel->fVirt&FSHIFT) != (m_lpAccel[ii].fVirt&FSHIFT))			continue;

			if (pAccel->key		!= m_lpAccel[ii].key)	continue;

			uiCmd =	m_lpAccel[ii].cmd;
			break;
		}

		return uiCmd;
	}

	HACCEL DeleteAccelerator(UINT uCmd)
	{
		ACCEL* lpAccel = new ACCEL[m_nAccelSize-1];

		BOOL bFound=FALSE;
		int	iNewIndex =	0;
		for	(int ii=0; ii<m_nAccelSize;	ii++)
		{
			if (uCmd !=	m_lpAccel[ii].cmd)
				lpAccel	[iNewIndex ++] = m_lpAccel[ii];
			else
				bFound = TRUE;
		}

		if (bFound==FALSE)
		{
			delete lpAccel;
			return m_hAccel;
		}
		else
		{
			m_nAccelSize--;
			delete m_lpAccel;
			m_lpAccel =	lpAccel;
			::DestroyAcceleratorTable (m_hAccel);
		}

		m_hAccel = ::CreateAcceleratorTable(m_lpAccel, m_nAccelSize);
		return m_hAccel;
	}

	HACCEL AddAccelerator(ACCEL* lpAccel)
	{
		ACCEL* lpAccelList = new ACCEL[m_nAccelSize+1];
		memcpy(lpAccelList,	m_lpAccel, m_nAccelSize*sizeof(ACCEL));
		lpAccelList[m_nAccelSize] =	*lpAccel;

		m_nAccelSize++;
		delete m_lpAccel;
		m_lpAccel =	lpAccelList;
		::DestroyAcceleratorTable (m_hAccel);
		m_hAccel = ::CreateAcceleratorTable(m_lpAccel, m_nAccelSize);
		return m_hAccel;
	}

	HACCEL LoadAccelaratorState(HACCEL hAccel)
	{
		CIniSection	pr;
		pr.Open(_GetFilePath(_T("KeyBoard.ini")), _T("KEYBOARD"));

		DWORD dwMax=0;
		pr.QueryValue((DWORD)dwMax,	_T("MAX"));
		m_nAccelSize = dwMax;
		if (m_nAccelSize==0) return	hAccel;

		delete m_lpAccel;
		m_lpAccel =	new	ACCEL[m_nAccelSize];
		for	(int ii=0; ii<m_nAccelSize;	ii++)
		{
			CString	strVirt, strKey, strCmd;
			strVirt.Format(_T("fVirt%02d"),	ii);
			strKey.Format(_T("key%02d"), ii);
			strCmd.Format(_T("cmd%02d"), ii);

			DWORD dwVirt=0,	dwKey=0, dwCmd=0;
			pr.QueryValue(dwVirt, strVirt);
			pr.QueryValue(dwKey, strKey);
			pr.QueryValue(dwCmd, strCmd);

			m_lpAccel[ii].fVirt	= dwVirt;
			m_lpAccel[ii].key =	dwKey;
			m_lpAccel[ii].cmd =	dwCmd;
		}

		pr.Close();

		::DestroyAcceleratorTable (hAccel);
		m_hAccel = ::CreateAcceleratorTable(m_lpAccel, m_nAccelSize);
		return m_hAccel;
	}

	BOOL SaveAccelaratorState()
	{
		CIniSection	pr;
		pr.Open(_GetFilePath(_T("KeyBoard.ini")), _T("KEYBOARD"));

		pr.SetValue((DWORD)m_nAccelSize, _T("MAX"));
		for	(int ii=0; ii<m_nAccelSize;	ii++)
		{
			CString	strVirt, strKey, strCmd;
			strVirt.Format(_T("fVirt%02d"),	ii);
			strKey.Format(_T("key%02d"), ii);
			strCmd.Format(_T("cmd%02d"), ii);

			pr.SetValue((DWORD)m_lpAccel[ii].fVirt,	strVirt);
			pr.SetValue((DWORD)m_lpAccel[ii].key, strKey);
			pr.SetValue((DWORD)m_lpAccel[ii].cmd, strCmd);
		}

		pr.Close();
		return TRUE;
	}
};

class CEditAccel : public CContainedWindowT<CEdit>
{
protected:
	BOOL		m_bKeyDefined;
	CKeyHelper	m_Helper;
	ACCEL		m_Accel;

public:
	CEditAccel():m_Helper(&m_Accel)
	{
		m_bKeyDefined =	FALSE;
		ResetKey();
	}

	ACCEL const* GetAccel () const
	{
		return &m_Accel;
	}

	void ResetKey()
	{
		memset (&m_Accel, 0, sizeof	(ACCEL));
		m_bKeyDefined =	FALSE;

		if (m_hWnd != NULL)
		{
			SetWindowText (_T(""));
		}
	}

	BOOL OnTranslateAccelerator(MSG* pMsg)
	{
		if (pMsg->hwnd!=m_hWnd)
			return FALSE;

		if (pMsg->message == WM_LBUTTONDOWN	||
			pMsg->message == WM_MBUTTONDOWN	||
			pMsg->message == WM_RBUTTONDOWN)
		{
			SetFocus ();
			return TRUE;
		}

		BOOL bPressed;
		if ((bPressed=(pMsg->message==WM_KEYDOWN)) || pMsg->message==WM_KEYUP ||
			(bPressed =	(pMsg->message == WM_SYSKEYDOWN)) || pMsg->message==WM_SYSKEYUP)
		{
			if (bPressed &&	m_bKeyDefined && !((1 << 30) & pMsg->lParam))
				ResetKey();
			if (pMsg->wParam==VK_SHIFT && !m_bKeyDefined)
				SetAccelFlag (FSHIFT, bPressed);
			else if	(pMsg->wParam==VK_CONTROL &&!m_bKeyDefined)
				SetAccelFlag (FCONTROL,	bPressed);
			else if	(pMsg->wParam==VK_MENU && !m_bKeyDefined)
				SetAccelFlag (FALT,	bPressed);
			else
			{
				if (!m_bKeyDefined)
				{
					m_Accel.key	= (WORD) pMsg->wParam;
					if (bPressed)
					{
						m_bKeyDefined =	TRUE;
						SetAccelFlag (FVIRTKEY,	TRUE);
					}
				}
			}

			BOOL bDefaultProcess = FALSE;

			if ((m_Accel.fVirt & FCONTROL) == 0	&&
				(m_Accel.fVirt & FSHIFT) ==	0 &&
				(m_Accel.fVirt & FALT) == 0	&&
				(m_Accel.fVirt & FVIRTKEY))
			{
				switch (m_Accel.key)
				{
				case VK_ESCAPE:
				case VK_TAB:
				case VK_BACK:
					bDefaultProcess	= TRUE;
				}
			}

//			if (!bDefaultProcess)
			{
				CString	strKbd;
				m_Helper.Format	(strKbd);

				SetWindowText (strKbd);
				return TRUE;
			}

			ResetKey ();
		}
		return TRUE;

//		return baseClass::PreTranslateMessage(pMsg);
	}

protected:
	void SetAccelFlag(BYTE bFlag, BOOL bOn)
	{
		if (bOn)	m_Accel.fVirt |= bFlag;
		else		m_Accel.fVirt &= ~bFlag;
	}
};

#endif
