#include "stdafx.h"
#include "resource.h"

#include "WtlFixed/atlmisc.h"
#include <atlframe.h>
#include <atlctrls.h>
#include <atlctrlw.h>
#include "WtlFixed/atlsplit.h"
#include <atldlgs.h>
#include <atlctrlx.h>
#include <atlcrack.h>
#include <atlddx.h>
#include <wininet.h>
#include <MsHTML.h>

#include "DonutDefine.h"
#include "ItemIDList.h"
#include "mtl.h"

#include "DonutPFunc.h"

#include "ScriptErrorCommandTargetImpl.h"
#include "AtlifaceEx.h"
#include "AtlhostEx.h"

// drafts
#include "DialogKiller.h"
#include "ReBarVerticalBorder.h"
#include "FileNotification.h"
#include "FlatComboBox.h"

// ENDED

#include "DonutFavoritesMenu.h"
#include "DonutOptions.h"
#include "DonutOptionsEx.h"
#include "DonutExecutablePropertyPage.h"
#include "DonutConfirmOption.h"
#include "DonutSecurityZone.h"

#include "Donut.h"
#include "DonutView.h"
#include "DonutClipboardBar.h"
#include "FavTreeViewCtrl.h"
#include "DonutPanelBar.h"

#include "DonutExplorerBar.h"
#include "DonutLinksBarCtrl.h"
#include "DonutToolBar.h"
#include "DonutStatusBarCtrl.h"

#include "AddressBar.h"
#include "SearchBar.h"
#include "MDITabCtrl.h"

#include "FavoriteMenu.h"

#include "initguid.h"
#include "DonutP.h"

#include "MDIChildUserMessenger.h"
#include "CloseTitle.h"
#include "aboutdlg.h"
#include "ChildFrm.h"
#include "MainFrm.h"

#include "API.h"
extern CAPI* g_pAPI;

CChildFrame::CChildFrame(CMDITabCtrl& MDITab, CDonutAddressBar&	addressbar,	bool bNewWindow2, DWORD	dwDefaultDLControlFlags)
:	m_bNavigateBack(FALSE),	m_bNavigateForward(FALSE),
	m_MDITab(MDITab), m_AddressBar(addressbar),
	m_bNewWindow2(bNewWindow2),
	m_wndBrowser(this, 7), m_FavMenu(this, ID_INSERTPOINT_CHILDFAVORITEMENU),
	m_nProgress(-1), m_nProgressMax(0),	m_bMozilla(false), m_bPageFocusInitialized(false),
	m_bClosing(false), m_bWaitNavigateLock(true), m_hWndFocus(NULL), m_view(dwDefaultDLControlFlags)
{
	m_bNowHilight =	FALSE;
	m_hWndF	= NULL;
	m_hWndA	= NULL;

	m_strBookmark	= BSTR(NULL);
	m_nPainBookmark	= 0;

	m_nSecureLockIcon =	secureLockIconUnsecure;
	m_bPrivacyImpacted = TRUE;
}

CChildFrame::~CChildFrame()
{
	dcfTRACE(_T("CChildFrame::~CChildFrame\n"));

	if (m_wndBrowser.IsWindow()) //	scary
		m_wndBrowser.UnsubclassWindow();

	ATLASSERT(m_hMenu == NULL);	// no menu
}

void CChildFrame::OnDocumentComplete(IDispatch*	pDisp, const CString& strURL)
{
	if (IsPageIWebBrowser(pDisp)) {	// it means	a page complete	downloading
		dcfTRACE(_T("CChildFrame::OnDocumentComplete\n"));
		m_bWaitNavigateLock	= false;// you are allowed!

		if (MDIGetActive() == m_hWnd &&	DonutBrowserCanSetFocus(m_hWnd)) {
			_SetPageFocus();
		}
	}
}

void CChildFrame::PreDocumentComplete(/*[in]*/ IDispatch* pDisp, /*[in]*/ VARIANT* URL)
{
	if ( !g_pAPI ) return;

	int	nTabIndex =	m_MDITab.GetTabIndex(m_hWnd);
	g_pAPI->Fire_DocumentComplete( nTabIndex, pDisp, V_BSTR(URL) );
}
