#ifndef	__CMBBOXPRXY_H__
#define	__CMBBOXPRXY_H__

#if	_MSC_VER > 1000
#pragma	once
#endif // _MSC_VER > 1000
#include <time.h>

class CComboBoxPrxy	: public CWindowImpl<CComboBoxPrxy,	CComboBox>,
	public CTrackMouseLeave<CComboBoxPrxy>
{
public:
	UINT m_nIDEvent;
	BOOL m_bUseIE;

// Constants
	enum { s_kcxyBorder	= 2	};
	enum _ComboState { _comboNormal, _comboHot,	_comboPressed };

// Data	members
	_ComboState	m_state;

	CComboBoxPrxy()
	{
		m_nIDEvent = 0;
		m_bUseIE = UseIE();
	}

	bool FlatComboBox_Install(HWND hWndCombo)
	{
		MTLVERIFY( SubclassWindow(hWndCombo) );
//		MTLVERIFY( m_wndEdit.SubclassWindow(CComboBoxEx(GetParent()).GetEditCtrl())	);

		return true;
	}

	void FlatComboBox_Uninstall()
	{
		if (IsWindow())
			UnsubclassWindow();
	}

private:
	BEGIN_MSG_MAP(CComboBoxPrxy)
		MESSAGE_HANDLER(WM_PAINT, OnPaint)

		MESSAGE_HANDLER(WM_COMMAND,	OnCommand)

		MSG_WM_TIMER(OnTimer)
		CHAIN_MSG_MAP(CTrackMouseLeave<CComboBoxPrxy>)
	END_MSG_MAP()

	LRESULT	OnPaint(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		CRect rc;
		GetUpdateRect(&rc, FALSE);

		ValidateRect(NULL);// validate the whole

		// invaldate only the internal rect
		CRect rcCombo =	_GetFlatComboInvalidateRect();
		CRect rcThumb =	_GetFlatThumbInvalidateRect();

		CRect rcUpdate = rc	& rcCombo;
		InvalidateRect(&rcUpdate, FALSE);
		rcUpdate = rc &	rcThumb;
		InvalidateRect(&rcUpdate, FALSE);

		LRESULT	lRet = DefWindowProc();

		CClientDC dc(m_hWnd);
		_DoComboPaint(dc.m_hDC);

		return lRet;
	}

	void _DoComboPaint(CDCHandle dc)
	{
		_DrawFlatCombo(dc);
		_DrawFlatThumb(dc);
	}

	void _DrawFlatThumb(CDCHandle& dc)
	{
		CRect rc = _GetOriginalThumbRect();
		dc.DrawEdge(rc,	BDR_RAISEDINNER, BF_RECT);

		rc.DeflateRect(1, 1);

		COLORREF clrBtnFace	= ::GetSysColor(COLOR_BTNFACE);
		dc.Draw3dRect(rc, clrBtnFace, clrBtnFace);
	}

	CRect _GetOriginalThumbRect()
	{
		CRect rc;
		GetClientRect(&rc);
		rc.right -=	s_kcxyBorder;
		rc.left	= rc.right - ::GetSystemMetrics(SM_CXHTHUMB);
		rc.top += s_kcxyBorder;
		rc.bottom -= s_kcxyBorder;
		return rc;
	}

	CRect _GetFlatThumbInvalidateRect()
	{
		CRect rc = _GetOriginalThumbRect();
		rc.DeflateRect(2, 2);
		return rc;
	}

	CRect _GetFlatComboInvalidateRect()
	{
		CRect rc;
		GetClientRect(&rc);
		rc.DeflateRect(2, 2);
		rc.right -=	::GetSystemMetrics(SM_CXHTHUMB);
		return rc;
	}

	void _DrawFlatCombo(CDCHandle& dc)
	{
		COLORREF clrBtnFace	= ::GetSysColor(COLOR_BTNFACE);

		CRect rc;
		GetClientRect(&rc);

		dc.Draw3dRect(rc, clrBtnFace, clrBtnFace);
		rc.DeflateRect(1, 1);

		dc.DrawEdge(rc,	BDR_SUNKENOUTER, BF_RECT);
	}

	LRESULT	OnCommand(UINT uMsg, WPARAM	wParam,	LPARAM lParam, BOOL& bHandled)
	{
		bHandled = FALSE;
		WORD wNotifyCode = HIWORD(wParam);
		if (wNotifyCode==CBN_SELCHANGE)
			OnSelectChange();
		return 1;
	}

	void OnSelectChange()
	{
		int	nIndex = GetCurSel();
		ChangeProxy(nIndex);
	}

	void ChangeProxy(int nIndex)
	{
		if (m_bUseIE) return;

		TCHAR cBuff[MAX_PATH];
		memset(cBuff, 0, MAX_PATH);

		GetLBText(nIndex, cBuff);
		CString	str(cBuff);
		CString	strBypass;

		INTERNET_PROXY_INFO	proxyinfo;
		if (!str.IsEmpty())
		{
			proxyinfo.dwAccessType = INTERNET_OPEN_TYPE_PROXY;
			proxyinfo.lpszProxy	= str;

			strBypass =	GetBypass();
			if (strBypass.IsEmpty())
				proxyinfo.lpszProxyBypass =	NULL;
			else
				proxyinfo.lpszProxyBypass =	strBypass;
		}
		else
		{
			proxyinfo.dwAccessType = INTERNET_OPEN_TYPE_DIRECT;
			proxyinfo.lpszProxy	= NULL;
			proxyinfo.lpszProxyBypass =	NULL;
		}

		UrlMkSetSessionOption(INTERNET_OPTION_PROXY, &proxyinfo, sizeof(proxyinfo),	0);

		// vLVt@CpX
		CString	strFile;
		strFile	= _GetFilePath(_T("Proxy.ini"));

		CIniSection	pr;
		pr.Open(strFile, _T("PROXY"));
		pr.SetValue((DWORD)nIndex, _T("TARGET"));
		pr.Close();

		// ^C}[w
		ResetTimer();
	}
	//+++ void OnTimer(UINT	wTimerID, TIMERPROC)
	void OnTimer(UINT wTimerID,	TIMERPROC* dmy=0)
	{
		ATLTRACE2(atlTraceUser,	4, _T("CComboBoxPrxy::OnTimer\n"));
		if (wTimerID ==	m_nIDEvent)
		{
			int	nCount = GetCount()-1;
			if (nCount==0) return;

			time_t nTime;
			::time(&nTime);

			int	nRand =	abs(::rand()) *	abs(nTime);
			nRand =	nRand%nCount;
			nRand =	abs(nRand) + 1;

			SetCurSel(nRand);
			ChangeProxy(nRand);
		}
		else
			SetMsgHandled(FALSE);
	}

public:

	void SetProxy()
	{
		// vLVt@CpX
		CString	strFile;
		strFile	= _GetFilePath(_T("Proxy.ini"));

		// vLVԍ
		DWORD dwIndex =	0;
		CIniSection	pr;
		pr.Open(strFile, _T("PROXY"));
		pr.QueryValue(dwIndex, _T("TARGET"));
		pr.Close();

		// wԍɂ
		int	nIndex = SetCurSel((int)dwIndex);
		ChangeProxy(nIndex);
	}

	void ResetProxyList()
	{
		if (m_bUseIE)
		{
			EnableWindow(FALSE);
			return;
		}

		ResetContent();
		AddString(_T(""));

		// vLVt@CpX
		CString	strFile;
		strFile	= _GetFilePath(_T("Proxy.ini"));

		CIniSection	pr;
		pr.Open(strFile, _T("PROXY"));

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// vLV
		DWORD dwLineCnt	= 0;
		pr.QueryValue(dwLineCnt, _T("MAX"));
		for	(int ii=0; ii<dwLineCnt; ii++)
		{
			CString	strKey;
			strKey.Format(_T("%d"),	ii);

			TCHAR cBuff[MAX_PATH];
			DWORD dwCount=MAX_PATH;
			pr.QueryValue(cBuff, strKey, &dwCount);

			CString	strProxy(cBuff);
			if (strProxy.IsEmpty())	continue;
			AddString(cBuff);
		}
		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

		// vLVݒ
		SetProxy();
	}

	void ResetTimer()
	{
		// vLVt@CpX
		CString	strFile;
		strFile	= _GetFilePath(_T("Proxy.ini"));

		CIniSection	pr;

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// _
		pr.Open(strFile, _T("RAND"));

		DWORD dwRandChk=0;
		pr.QueryValue(dwRandChk, _T("Enabel"));

		DWORD dwRandTimeMin	= 5;
		pr.QueryValue(dwRandTimeMin, _T("Min"));

		DWORD dwRandTimeSec	= 0;
		pr.QueryValue(dwRandTimeSec, _T("Sec"));

		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

		// _wȂ
		if (dwRandChk==0)
		{
			if (m_nIDEvent != 0)
			{
				MTLVERIFY(::KillTimer(m_hWnd, m_nIDEvent));
				m_nIDEvent = 0;
			}
			return;
		}

		// ^C}[ݒ
		int	nAutoChgTime = (dwRandTimeMin*60 + dwRandTimeSec)*1000;
		m_nIDEvent = ::SetTimer(m_hWnd,	1, nAutoChgTime, NULL);
	}

	// hdg
	BOOL UseIE()
	{
		// vLVt@CpX
		CString	strFile;
		strFile	= _GetFilePath(_T("Proxy.ini"));

		CIniSection	pr;
		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// [J
		pr.Open(strFile, _T("USE_IE"));
		DWORD dwUseIE=1;
		pr.QueryValue(dwUseIE, _T("Enabel"));
		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

		return (BOOL)dwUseIE;
	}

	// oCpX𓾂
	CString	GetBypass()
	{
		// vLVt@CpX
		CString	strFile;
		strFile	= _GetFilePath(_T("Proxy.ini"));

		CIniSection	pr;

		CString	strBypass;

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// vLV
		pr.Open(strFile, _T("NOPROXY"));
		DWORD dwLineCnt	= 0;
		pr.QueryValue(dwLineCnt, _T("MAX"));
		for	(int ii=0; ii<dwLineCnt; ii++)
		{
			CString	strKey;
			strKey.Format(_T("%d"),	ii);

			TCHAR cBuff[MAX_PATH];
			DWORD dwCount=MAX_PATH;
			pr.QueryValue(cBuff, strKey, &dwCount);

			CString	strProxy(cBuff);
			if (strProxy.IsEmpty())	continue;

			if (strBypass.IsEmpty()==FALSE)
				strBypass =	strBypass +	_T(";");
			strBypass =	strBypass +	strProxy;
		}
		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// [J
		pr.Open(strFile, _T("LOCAL"));
		DWORD dwLocalChk=0;
		pr.QueryValue(dwLocalChk, _T("Enabel"));
		if (dwLocalChk==TRUE)
			strBypass =	strBypass +	_T(";<local>");
		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
		return strBypass;
	}
};

#endif
