
#pragma	once

#define	DEB_EX_FAVBAR	0x00000001L
#define	DEB_EX_CLPBAR	0x00000002L
#define	DEB_EX_PNLBAR	0x00000004L

#define	CHAIN_COMMANDS_TO_EXPLORERBAR(x) CHAIN_COMMANDS_ALT_MEMBER(x, 1)

class CDonutExplorerBar	: public CPaneContainerImpl<CDonutExplorerBar>
{
public:
	DECLARE_WND_CLASS_EX(_T("Donut_ExplorerBar"), 0, -1)
	typedef	CPaneContainerImpl<CDonutExplorerBar> baseClass;

// Data	members
	CSplitterWindow& m_wndSplit;
	CDonutFavoritesBar m_FavBar;
	CDonutClipboardBar m_ClpBar;
	CDonutPanelBar<CDonutExplorerBar> m_PanBar;
	DWORD				m_dwExStyle;
	int					m_nBottomAria;
	int					m_nIndexAct;
	int					m_nPageCnt;
	std::vector<int>	m_aryID;
	CImageList			m_imgs;

// Ctor
	CDonutExplorerBar(CSplitterWindow& wndSplit):
		m_wndSplit(wndSplit),
		m_dwExStyle(DEB_EX_FAVBAR)
	{
		m_nBottomAria =	16;
		m_nPageCnt = 5;
		m_nIndexAct	= 0;

		//+++ static const ǉ
		static const int nID[]={ ID_VIEW_FAVEXPBAR,	ID_VIEW_FAVEXPBAR_GROUP, ID_VIEW_FAVEXPBAR_HIST,
			ID_VIEW_FAVEXPBAR_SCRIPT, ID_VIEW_CLIPBOARDBAR,	ID_VIEW_PANELBAR };
		for	( int ii=0;	ii<(sizeof(nID)/sizeof(int)); ii++ )
			m_aryID.push_back(nID[ii]);

		CBitmap	bmp;
		bmp.Attach(AtlLoadBitmapImage(GetSkinPath().GetBuffer(0), LR_LOADFROMFILE));
		m_imgs.Create(m_nBottomAria, m_nBottomAria,	ILC_COLOR8 | ILC_MASK, (sizeof(nID)/sizeof(int)), 1);
		m_imgs.Add(bmp,	RGB(255, 0,	255));
	}

	CString	GetSkinPath()
	{
		return _GetBtnSkinDir()+_T("\\ExpBar.bmp");
	}

	void DonutExplorerBar_Init(HWND	hWndMDIClient)
	{
		if (m_ClpBar.m_hWnd	== NULL)
		{
			m_ClpBar.Create(m_hWnd);
			m_ClpBar.SetWindowText(_T("Nbv{[h"));
		}

		_GetProfile(hWndMDIClient);

	}

	void UpdateLayout()
	{
		RECT rcClient;
		GetClientRect(&rcClient);
		UpdateLayout(rcClient.right, rcClient.bottom);
	}

	void UpdateLayout(int cxWidth, int cyHeight)
	{
		cyHeight -=	m_nBottomAria;
		baseClass::UpdateLayout(cxWidth, cyHeight);
	}

// Message map and handlers
	BEGIN_MSG_MAP(CDonutExplorerBar)
		MESSAGE_HANDLER(WM_DESTROY,	OnDestroy)
		MESSAGE_HANDLER(WM_PAINT, OnPaint)
		MESSAGE_HANDLER(WM_LBUTTONUP, OnLButtonUp)
		CHAIN_MSG_MAP(baseClass)
	ALT_MSG_MAP(1) // As CPaneContainer	has	FORWARD_NOTIFICATIONS, you have	to separate	a map.
		COMMAND_ID_HANDLER(ID_VIEW_FAVEXPBAR, OnViewFavExpBar)
		COMMAND_ID_HANDLER(ID_VIEW_FAVEXPBAR_HIST, OnViewFavExpBarHist)
		COMMAND_ID_HANDLER(ID_VIEW_FAVEXPBAR_GROUP,	OnViewFavExpBarGroup)
		COMMAND_ID_HANDLER(ID_VIEW_FAVEXPBAR_USER, OnViewFavExpBarUser)
		COMMAND_ID_HANDLER(ID_VIEW_EXPBAR_SETFOCUS,	OnViewExpBarSetFocus)
		COMMAND_ID_HANDLER(ID_VIEW_FAVEXPBAR_SCRIPT, OnViewFavExpBarScript)
		COMMAND_ID_HANDLER(ID_VIEW_CLIPBOARDBAR, OnViewClipboardBar)
		COMMAND_ID_HANDLER(ID_VIEW_PANELBAR, OnViewPanelBar)
		COMMAND_ID_HANDLER(ID_PANE_CLOSE, OnIDPaneClose)
	END_MSG_MAP()

	LRESULT	OnPaint(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		CPaintDC dc(m_hWnd);

		DrawPaneTitle(dc.m_hDC);

		if(m_wndClient.m_hWnd == NULL)	// no client window
			DrawPane(dc.m_hDC);

		DrawBottomTab( dc.m_hDC	);
		return S_OK;
	}

	void DrawBottomTab(CDCHandle dc)
	{
		RECT rcClient;
		GetClientRect(&rcClient);

		rcClient.top = rcClient.bottom - m_nBottomAria;
		dc.FillSolidRect( &rcClient, RGB(255,255,255) );


		int	nTabWidth =	int(m_nBottomAria*1.5);
		CRect rcTab(rcClient);
		rcTab.top -= 2;
		rcTab.left += 2;
		rcTab.right	= rcTab.left + nTabWidth;

		CPen penFace, penBlack;
		penFace.CreatePen(PS_SOLID,	0, ::GetSysColor(COLOR_3DSHADOW));
		penBlack.CreatePen(PS_SOLID, 0,	RGB(0,0,0));
		dc.SelectPen(penFace);
		for	( int nIndex=0;	nIndex<m_aryID.size(); nIndex++)
		{
			if (nIndex==m_nIndexAct)
			{
				dc.FillRect(&rcTab,	COLOR_3DFACE);

				dc.SelectPen(penBlack);
				dc.MoveTo(rcTab.left, rcTab.bottom-1);
				dc.LineTo(rcTab.right-1, rcTab.bottom-1);
				dc.LineTo(rcTab.right-1, rcTab.top);
				dc.SelectPen(penFace);
			}
			else
			{
				dc.FillSolidRect(&rcTab, RGB(255,255,255));

				dc.MoveTo(rcTab.right-1, rcTab.top+3);
				dc.LineTo(rcTab.right-1, rcTab.bottom-3);
			}
			::ImageList_Draw(m_imgs, nIndex, dc, rcTab.left+(rcTab.Width()-m_nBottomAria)/2, rcTab.top+1, ILD_TRANSPARENT);

			rcTab.left += nTabWidth;
			rcTab.right	+= nTabWidth;

		}
	}

	LRESULT	OnLButtonUp(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		POINT pt = { GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam)	};

		RECT rcClient;
		GetClientRect(&rcClient);

		int	nTabWidth =	m_nBottomAria*1.5;
		CRect rcTab(rcClient);
		rcTab.top -= 2;
		rcTab.left += 2;
		rcTab.right	= rcTab.left + nTabWidth;

		for	(int nIndex=0; nIndex<m_aryID.size(); nIndex++)
		{
			if (rcTab.PtInRect(pt))
			{
				if (m_nIndexAct	!= nIndex)
				{
					m_nIndexAct	= nIndex;

					Invalidate(FALSE);
					::PostMessage(GetTopLevelParent(), WM_COMMAND, m_aryID[nIndex],	0);
				}
				return 0;
			}
			rcTab.left += nTabWidth;
			rcTab.right	+= nTabWidth;
		}

		return 0;
	}

	LRESULT	OnDestroy(UINT uMsg, WPARAM	wParam,	LPARAM lParam, BOOL& bHandled)
	{
		bHandled = FALSE;
		_WriteProfile();
		return 0;
	}

	LRESULT	OnViewFavExpBar(WORD /*wNotifyCode*/, WORD /*wID*/,	HWND /*hWndCtl*/, BOOL&	/*bHandled*/)
	{
		if (IsExplorerBarHidden())
		{
			if ((CMainOption::s_dwExplorerBarStyle&MAIN_EXPLORER_AUTOSHOW)!=MAIN_EXPLORER_AUTOSHOW)
			{
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_STANDARD);
				ShowBar(DEB_EX_FAVBAR, true);
			}
			else
			{
				if ((m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_FAVORITES)==ETV_EX_FAVORITES)
				{
					HideBar();
					m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&=~ETV_EX_FAVORITES;
				}
				else
					SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_STANDARD);

			}
		}
		else if	(!IsFavBarVisible())
		{
			if ((m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_FAVORITES)!=ETV_EX_FAVORITES)
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_STANDARD);
			ShowBar(DEB_EX_FAVBAR);
		}
		else
		{
			if (m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_FAVORITES)
				HideBar();
			else
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_STANDARD);
		}

		return 0;
	}

	LRESULT	OnViewFavExpBarHist(WORD /*wNotifyCode*/, WORD /*wID*/,	HWND /*hWndCtl*/, BOOL&	/*bHandled*/)
	{
		if (IsExplorerBarHidden())
		{
			if ((CMainOption::s_dwExplorerBarStyle&MAIN_EXPLORER_AUTOSHOW)!=MAIN_EXPLORER_AUTOSHOW)
			{
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_HISTORY);
				ShowBar(DEB_EX_FAVBAR, true);
			}
			else
			{
				if ((m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_HISTORY)==ETV_EX_HISTORY)
				{
					HideBar();
					m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&=~ETV_EX_HISTORY;
				}
				else
					SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_HISTORY);

			}
		}
		else if	(!IsFavBarVisible())
		{
			if ((m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_HISTORY)!=ETV_EX_HISTORY)
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_HISTORY);
			ShowBar(DEB_EX_FAVBAR);
		}
		else {
			if (m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_HISTORY)
				HideBar();
			else
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_HISTORY);
		}

		return 0;
	}

	LRESULT	OnViewFavExpBarGroup(WORD /*wNotifyCode*/, WORD	/*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		if (IsExplorerBarHidden()) {
			if ((CMainOption::s_dwExplorerBarStyle&MAIN_EXPLORER_AUTOSHOW)!=MAIN_EXPLORER_AUTOSHOW)
			{
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_GROUP);
				ShowBar(DEB_EX_FAVBAR, true);
			}
			else
			{
				if ((m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_FAVORITEGROUP)==ETV_EX_FAVORITEGROUP)
				{
					HideBar();
					m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&=~ETV_EX_FAVORITEGROUP;
				}
				else
					SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_GROUP);
			}
		}
		else if	(!IsFavBarVisible())
		{
			if ((m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_FAVORITEGROUP)!=ETV_EX_FAVORITEGROUP)
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_GROUP);
			ShowBar(DEB_EX_FAVBAR);
		}
		else
		{
			if (m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_FAVORITEGROUP)
				HideBar();
			else
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_GROUP);
		}

		return 0;
	}

	LRESULT	OnViewFavExpBarUser(WORD /*wNotifyCode*/, WORD /*wID*/,	HWND /*hWndCtl*/, BOOL&	/*bHandled*/)
	{
		if (IsExplorerBarHidden())
		{
			if ((CMainOption::s_dwExplorerBarStyle&MAIN_EXPLORER_AUTOSHOW)!=MAIN_EXPLORER_AUTOSHOW)
			{
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_USER);
				ShowBar(DEB_EX_FAVBAR, true);
			}
			else
			{
				if ((m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_USERDEFINED)==ETV_EX_USERDEFINED)
				{
					HideBar();
					m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&=~ETV_EX_USERDEFINED;
				}
				else
					SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_USER);
			}
		}
		else if	(!IsFavBarVisible())
		{
			if ((m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_USERDEFINED)!=ETV_EX_USERDEFINED)
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_USER);
			ShowBar(DEB_EX_FAVBAR);
		}
		else
		{
			if (m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_USERDEFINED)
				HideBar();
			else
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_USER);
		}

		return 0;
	}

	LRESULT	OnViewFavExpBarScript(WORD /*wNotifyCode*/,	WORD /*wID*/, HWND /*hWndCtl*/,	BOOL& /*bHandled*/)
	{
		if (IsExplorerBarHidden())
		{
			if ((CMainOption::s_dwExplorerBarStyle&MAIN_EXPLORER_AUTOSHOW)!=MAIN_EXPLORER_AUTOSHOW)
			{
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_SCRIPT);
				ShowBar(DEB_EX_FAVBAR, true);
			}
			else
			{
				if (m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_SCRIPT)
				{
					HideBar();
					m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&=~ETV_EX_SCRIPT;
				}
				else
					SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_SCRIPT);
			}
		}
		else if	(!IsFavBarVisible())
		{
			if ((m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_SCRIPT)!=ETV_EX_SCRIPT)
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_SCRIPT);
			ShowBar(DEB_EX_FAVBAR);
		}
		else
		{
			if (m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_SCRIPT)
				HideBar();
			else
				SendMessage(WM_COMMAND,	ID_FAVTREE_BAR_SCRIPT);
		}

		return 0;
	}

	LRESULT	OnViewClipboardBar(WORD	/*wNotifyCode*/, WORD /*wID*/, HWND	/*hWndCtl*/, BOOL& /*bHandled*/)
	{
		if (IsExplorerBarHidden())
		{
			if ((CMainOption::s_dwExplorerBarStyle&MAIN_EXPLORER_AUTOSHOW)!=MAIN_EXPLORER_AUTOSHOW)
				ShowBar(DEB_EX_CLPBAR, true);
			else
			{
				if (m_dwExStyle==DEB_EX_CLPBAR)
					m_dwExStyle	= 0;
				else
					ShowBar(DEB_EX_CLPBAR, true);
			}
		}
		else if	(!IsClpBarVisible())
			ShowBar(DEB_EX_CLPBAR);
		else
			HideBar();

		return 0;
	}

	LRESULT	OnViewPanelBar(WORD	/*wNotifyCode*/, WORD /*wID*/, HWND	/*hWndCtl*/, BOOL& /*bHandled*/)
	{
		if (IsExplorerBarHidden())
		{
			if ((CMainOption::s_dwExplorerBarStyle&MAIN_EXPLORER_AUTOSHOW)!=MAIN_EXPLORER_AUTOSHOW)
				ShowBar(DEB_EX_PNLBAR, true);
			else
			{
				if (m_dwExStyle==DEB_EX_PNLBAR)
					m_dwExStyle	= 0;
				else
					ShowBar(DEB_EX_PNLBAR, true);
			}
		}
		else if	(!IsPnlBarVisible())
			ShowBar(DEB_EX_PNLBAR);
		else
			HideBar();

		return 0;
	}

	LRESULT	OnIDPaneClose(WORD /*wNotifyCode*/,	WORD /*wID*/, HWND /*hWndCtl*/,	BOOL& /*bHandled*/)
	{
		HideBar();
		return 0;
	}

	LRESULT	OnViewExpBarSetFocus(WORD /*wNotifyCode*/, WORD	/*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		SetFocus();
		return 0;
	}

// Methods
	BYTE PreTranslateMessage(MSG* pMsg)
	{
		if (IsFavBarVisible())
			return m_FavBar.PreTranslateMessage(pMsg);
		else if	(IsClpBarVisible())
			return m_ClpBar.PreTranslateMessage(pMsg);
		else if	(IsPnlBarVisible())
			return m_PanBar.PreTranslateMessage(pMsg);
		else
			return _MTL_TRANSLATE_PASS;
	}

// Attributes
	bool IsFavBarVisible()
	{
		return _check_flag(DEB_EX_FAVBAR, m_dwExStyle);
	}

	bool IsClpBarVisible()
	{
		return _check_flag(DEB_EX_CLPBAR, m_dwExStyle);
	}

	bool IsPnlBarVisible()
	{
		return _check_flag(DEB_EX_PNLBAR, m_dwExStyle);
	}

	bool IsExplorerBarHidden()
	{
		return (m_wndSplit.GetSinglePaneMode() == SPLIT_PANE_RIGHT);
	}

	void ShowBar(DWORD dwExStyle, bool bShowSplitter = false)
	{
		_CreateOnDemandBar(dwExStyle);

		_SwitchClient(dwExStyle);
		m_dwExStyle	= dwExStyle;

		if (dwExStyle&DEB_EX_FAVBAR)
		{
			if (m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_FAVORITES)
				SetTitle(_T("Cɓ"));
			else if	(m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_HISTORY)
				SetTitle(_T(""));
			else if	(m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_FAVORITEGROUP)
				SetTitle(_T("CɓO[v"));
			else if	(m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_USERDEFINED)
				SetTitle(_T("[U`"));
			else if	(m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_MYCOMPUTER)
				SetTitle(_T("fXNgbv"));
			else if	(m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_SCRIPT)
				SetTitle(_T("XNvg"));
		}

		if (bShowSplitter)
			m_wndSplit.SetSinglePaneMode();
	}

	void HideBar()
	{
		m_dwExStyle	= 0;
		m_wndSplit.SetSinglePaneMode(SPLIT_PANE_RIGHT);
	}

	void _SwitchClient(DWORD dwStyle)
	{
		if (_check_flag(DEB_EX_FAVBAR, dwStyle))
		{	// fav bar
			_HideOtherBars();
			m_FavBar.ShowWindow(SW_SHOW);
			SetClient(m_FavBar.m_hWnd);
			SetTitle(MtlGetWindowText(m_FavBar.m_hWnd));
		}
		else if	(_check_flag(DEB_EX_CLPBAR,	dwStyle))
		{	// clp bar
			_HideOtherBars();
			m_ClpBar.ShowWindow(SW_SHOW);
			SetClient(m_ClpBar.m_hWnd);
			SetTitle(MtlGetWindowText(m_ClpBar.m_hWnd));
		}
		else if	(_check_flag(DEB_EX_PNLBAR,	dwStyle))
		{	// Panel bar
			_HideOtherBars();
			m_PanBar.ShowWindow(SW_SHOW);
			SetClient(m_PanBar.m_hWnd);
			SetTitle(MtlGetWindowText(m_PanBar.m_hWnd));
		}
	}

	void _HideOtherBars()
	{
		if (m_FavBar.m_hWnd	!= NULL)
			m_FavBar.ShowWindow(SW_HIDE);
		if (m_ClpBar.m_hWnd	!= NULL)
			m_ClpBar.ShowWindow(SW_HIDE);
		if (m_PanBar.m_hWnd	!= NULL)
			m_PanBar.ShowWindow(SW_HIDE);
	}

	void _CreateOnDemandBar(DWORD dwExStyle)
	{
		if (_check_flag(DEB_EX_FAVBAR, dwExStyle))
		{	// on demand
			if (!m_FavBar.m_hWnd)
			{
				m_FavBar.Create(m_hWnd,	rcDefault, NULL, WS_CHILD |	WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,	0);
				m_FavBar.InitToolBar(ID_FAVORITE_ADD, ID_FAVORITE_ORGANIZE,	ID_FAVORITE_PLACEMENT, IDB_FAVBAR, IDB_FAVBAR_HOT, 16, 16, RGB(255,	0, 255));
				m_FavBar.SetWindowText(_T("Cɓ"));
			}
		}
		else if	(_check_flag(DEB_EX_PNLBAR,	dwExStyle))
		{
			if (!m_PanBar.m_hWnd)
			{
				CreatePanelBar(TRUE);
			}
		}
	}

	void CreatePanelBar(BOOL bInitNavi)
	{
		m_PanBar.m_bInitNavi = bInitNavi;
		m_PanBar.Create(m_hWnd,	rcDefault, NULL, WS_CHILD |	WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,	0);
		m_PanBar.InitToolBar(RGB(255, 0, 255));
		m_PanBar.m_pParent = this;

		if (bInitNavi==FALSE)
			m_PanBar.SetWindowText(_T("pl"));

	}

	void _WriteProfile()
	{
		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("Explorer_Bar"));

		pr.SetValue(m_dwExStyle, _T("Extended_Style"));

		pr.SetValue(m_wndSplit.GetSplitterPos(), _T("cxLeftSplitter"));

		DWORD dwSplitterVisible	= (m_wndSplit.GetSinglePaneMode() == SPLIT_PANE_RIGHT) ? FALSE : TRUE;
		pr.SetValue(dwSplitterVisible, _T("bLeftVisible"));
	}

	void _GetProfile(HWND hWndMDIClient)
	{
		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("Explorer_Bar"));

		DWORD dwcxLeftSplitter = 160;
		pr.QueryValue(dwcxLeftSplitter,	_T("cxLeftSplitter"));

		DWORD dwSplitterVisible	= FALSE;
		pr.QueryValue(dwSplitterVisible, _T("bLeftVisible"));

		DWORD dwExStyle	= DEB_EX_FAVBAR;
		pr.QueryValue(dwExStyle, _T("Extended_Style"));

		m_wndSplit.SetSplitterPanes(m_hWnd,	hWndMDIClient);
		m_wndSplit.SetSplitterPaneParents(NULL,	GetTopLevelParent());
		m_wndSplit.m_xySplitterPos = dwcxLeftSplitter;

		if (dwSplitterVisible == FALSE)	{
			HideBar();
			if (dwExStyle!=0)
				m_dwExStyle	= dwExStyle;
		}
		else {
			ShowBar(dwExStyle);
//			SetFocus();
		}
	}

// Update command UI and handlers
	BEGIN_UPDATE_COMMAND_UI_MAP(CDonutExplorerBar)
		for	(int ii=0; ii<m_aryID.size(); ii++)
		{
//			if (nID!=m_aryID[ii]) continue;
//
			int	nIndexAct =	m_nIndexAct;
			switch(m_aryID[ii])
			{
			case ID_VIEW_FAVEXPBAR:
				if (IsFavBarVisibleNormal())	m_nIndexAct	= ii; break;
			case ID_VIEW_FAVEXPBAR_HIST:
				if (IsFavBarVisibleHist())		m_nIndexAct	= ii; break;
			case ID_VIEW_FAVEXPBAR_GROUP:
				if (IsFavBarVisibleGroup())		m_nIndexAct	= ii; break;
			case ID_VIEW_FAVEXPBAR_USER:
				if (IsFavBarVisibleUser())		m_nIndexAct	= ii; break;
			case ID_VIEW_FAVEXPBAR_SCRIPT:
				if (IsFavBarVisibleScript())	m_nIndexAct	= ii; break;
			case ID_VIEW_CLIPBOARDBAR:
				if (IsClpBarVisible())			m_nIndexAct	= ii; break;
			case ID_VIEW_PANELBAR:
				if (IsPnlBarVisible())			m_nIndexAct	= ii; break;
			}

			if ( nIndexAct!=m_nIndexAct	)
			{
				Invalidate(FALSE);
				break;
			}
		}

		UPDATE_COMMAND_UI_SETCHECK_IF(ID_VIEW_FAVEXPBAR, IsFavBarVisibleNormal())
		UPDATE_COMMAND_UI_SETCHECK_IF(ID_VIEW_FAVEXPBAR_HIST, IsFavBarVisibleHist())
		UPDATE_COMMAND_UI_SETCHECK_IF(ID_VIEW_FAVEXPBAR_GROUP, IsFavBarVisibleGroup())
		UPDATE_COMMAND_UI_SETCHECK_IF(ID_VIEW_FAVEXPBAR_USER, IsFavBarVisibleUser())
		UPDATE_COMMAND_UI_SETCHECK_IF(ID_VIEW_FAVEXPBAR_SCRIPT,	IsFavBarVisibleScript())
		UPDATE_COMMAND_UI_SETCHECK_IF(ID_VIEW_CLIPBOARDBAR,	IsClpBarVisible())
		UPDATE_COMMAND_UI_SETCHECK_IF(ID_EXPLORERBAR, IsFavBarVisible()|IsClpBarVisible())
		UPDATE_COMMAND_UI_SETCHECK_IF(ID_VIEW_PANELBAR,	IsPnlBarVisible())
	END_UPDATE_COMMAND_UI_MAP()

	bool IsFavBarVisibleNormal()
	{
		if (IsFavBarVisible()==false)
			return false;

		_CreateOnDemandBar(m_dwExStyle);
		if (m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_FAVORITES)
			return true;
		else
			return false;
	}

	bool IsFavBarVisibleScript()
	{
		if (IsFavBarVisible()==false)
			return false;

		_CreateOnDemandBar(m_dwExStyle);
		if (m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_SCRIPT)
			return true;
		else
			return false;
	}

	bool IsFavBarVisibleHist()
	{
		if (IsFavBarVisible()==false)
			return false;

		_CreateOnDemandBar(m_dwExStyle);
		if (m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_HISTORY)
			return true;
		else
			return false;
	}

	bool IsFavBarVisibleGroup()
	{
		if (IsFavBarVisible()==false)
			return false;

		_CreateOnDemandBar(m_dwExStyle);
		if (m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_FAVORITEGROUP)
			return true;
		else
			return false;
	}

	bool IsFavBarVisibleUser()
	{
		if (IsFavBarVisible()==false)
			return false;

		_CreateOnDemandBar(m_dwExStyle);
		if (m_FavBar.m_view.m_dwExplorerTreeViewExtendedStyle&ETV_EX_USERDEFINED)
			return true;
		else
			return false;
	}

	IDispatch* GetPanelWebBrowserObject()
	{
		if (m_PanBar.m_hWnd==NULL)
			CreatePanelBar(FALSE);

		CWebBrowser2 browser = m_PanBar.m_spBrowser.p;

		IWebBrowser2* spBrowser;
		browser.m_spBrowser->QueryInterface(IID_IWebBrowser2, (void**)&spBrowser);
		return (IDispatch*)spBrowser;
	}

	IDispatch* GetPanelWindowObject()
	{
		if (m_PanBar.m_hWnd==NULL)
			CreatePanelBar(FALSE);

		CWebBrowser2 browser = m_PanBar.m_spBrowser.p;

		CComPtr<IDispatch> spDisp;
		HRESULT	hr = browser.m_spBrowser->get_Document(&spDisp);
		CComQIPtr<IHTMLDocument2> spDoc	= spDisp;

		IHTMLWindow2* spWnd;
		spDoc->get_parentWindow(&spWnd);
		return (IDispatch*)spWnd;
	}

	IDispatch* GetPanelDocumentObject()
	{
		if (m_PanBar.m_hWnd==NULL)
			CreatePanelBar(FALSE);

		CWebBrowser2 browser = m_PanBar.m_spBrowser.p;

		IDispatch* spDocument;
		browser.m_spBrowser->get_Document(&spDocument);
		return (IDispatch*)spDocument;
	}
};