
#pragma	once

#define	MAIN_EX_NEWWINDOW			0x00000001L
#define	MAIN_EX_NOACTIVATE			0x00000002L
// #define MAIN_EX_NOINITWND	0x00000004L	obsolete
#define	MAIN_EX_ONEINSTANCE			0x00000008L
#define	MAIN_EX_WINDOWLIMIT			0x00000010L
#define	MAIN_EX_NOCLOSEDFG			0x00000020L
#define	MAIN_EX_NOMDI				0x00000040L
// #define MAIN_EX_VIEWCLIPBOARD		0x00000080L
#define	MAIN_EX_FULLSCREEN			0x00000100L
#define	MAIN_EX_BACKUP				0x00000200L
#define	MAIN_EX_NOACTIVATE_NEWWIN	0x00000400L
#define	MAIN_EX_ADDFAVORITEOLDSHELL	0x00000800L
#define	MAIN_EX_ORGFAVORITEOLDSHELL	0x00001000L
#define	MAIN_EX_GLOBALOFFLINE		0x00002000L
#define	MAIN_EX_LOADGLOBALOFFLINE	0x00004000L
#define	MAIN_EX_KILLDIALOG			0x00008000L
#define	MAIN_EX_REGISTER_AS_BROWSER	0x00010000L
#define	MAIN_EX_INHERIT_OPTIONS		0x00020000L

#define	MAIN_EX2_NOCSTMMENU			0x00000001L
#define	MAIN_EX2_DEL_CASH			0x00000002L
#define	MAIN_EX2_DEL_COOKIE			0x00000004L
#define	MAIN_EX2_DEL_HISTORY		0x00000008L
#define	MAIN_EX2_MAKECASH			0x00000010L

#define	MAIN_EXPLORER_HSCROLL		0x00000001L
#define	MAIN_EXPLORER_NOSPACE		0x00000002L
#define	MAIN_EXPLORER_AUTOSHOW		0x00000004L
#define	MAIN_EXPLORER_FAV_ORGIMG	0x00000008L

#include "RecentDocumentListFixed.h"

class CMainOption
{
public:
	static DWORD s_dwMainExtendedStyle;
	static DWORD s_dwMainExtendedStyle2;
	static DWORD s_dwExplorerBarStyle;
	static DWORD s_dwMaxWindowCount;
	static DWORD s_dwBackUpTime;
	static DWORD s_dwAutoRefreshTime; // UDT DGSTR ( dai
	static bool	s_bTabMode;

	static bool	s_bAppClosing;
	static bool	s_bIgnoreUpdateClipboard;//	for	insane WM_DRAWCLIBOARD

	static CRecentDocumentListFixed* s_pMru;

	static bool	s_bNoCstmMenu;

	static void	GetProfile()
	{
		CIniSection	pr;

		pr.Open(_szIniFileName,	_T("Main"));
		pr.QueryValue(s_dwMainExtendedStyle, _T("Extended_Style"));
		pr.QueryValue(s_dwMainExtendedStyle2, _T("Extended_Style2"));
		pr.QueryValue(s_dwMaxWindowCount, _T("Max_Window_Count"));
		pr.QueryValue(s_dwBackUpTime, _T("BackUp_Time"));
		pr.QueryValue(s_dwAutoRefreshTime, _T("Auto_Refresh_Time")); //	UDT	DGSTR (	dai
		pr.QueryValue(s_dwExplorerBarStyle,	_T("ExplorerBar_Style")); // UH
		pr.Close();

		s_pMru = new CRecentDocumentListFixed;
		s_pMru->SetMaxEntries(9);
		s_pMru->ReadFromIniFile();

		if (s_dwMainExtendedStyle &	MAIN_EX_NOMDI)
			s_bTabMode = true;
		else
			s_bTabMode = false;

		if (s_dwMainExtendedStyle2 & MAIN_EX2_NOCSTMMENU)
			s_bNoCstmMenu =	true;
		else
			s_bNoCstmMenu =	false;

		// NOTE. If	all	the	Web	Browser	server on your desktop is unloaded,	some OS	automatically goes online.
		//		 And if	all	the	Web	Browser	server on you application is unloaded, some	OS automatically goes online.
		if (_check_flag(MAIN_EX_LOADGLOBALOFFLINE, s_dwMainExtendedStyle))
			MtlSetGlobalOffline(_check_flag(MAIN_EX_GLOBALOFFLINE, s_dwMainExtendedStyle));
	}

	static void	WriteProfile()
	{
		CIniSection	pr;

		if (MtlIsGlobalOffline())
			s_dwMainExtendedStyle |= MAIN_EX_GLOBALOFFLINE;
		else
			s_dwMainExtendedStyle &= ~MAIN_EX_GLOBALOFFLINE;

		pr.Open(_szIniFileName,	_T("Main"));
		pr.SetValue(s_dwMainExtendedStyle, _T("Extended_Style"));
		pr.SetValue(s_dwMainExtendedStyle2,	_T("Extended_Style2"));
		pr.SetValue(s_dwExplorerBarStyle, _T("ExplorerBar_Style"));	// UDT DGSTR ( dai
		pr.SetValue(s_dwMaxWindowCount,	_T("Max_Window_Count"));
		pr.SetValue(s_dwBackUpTime,	_T("BackUp_Time"));
		pr.SetValue(s_dwAutoRefreshTime, _T("Auto_Refresh_Time")); // UDT DGSTR	( dai
		pr.Close();

		s_pMru->WriteToIniFile();
		delete s_pMru;
	}

	static void	SetMRUMenuHandle(HMENU hMenu, int nPos)
	{
		HMENU hFileMenu	= ::GetSubMenu(hMenu, 0);
#ifdef _DEBUG
		// absolute	position, can change if	menu changes
		TCHAR szMenuString[100];
		::GetMenuString(hFileMenu, nPos, szMenuString, sizeof(szMenuString), MF_BYPOSITION);
		ATLASSERT(lstrcmp(szMenuString,	_T("ŋߕt@C(&F)")) == 0);
#endif //_DEBUG
		HMENU hMruMenu = ::GetSubMenu(hFileMenu, nPos);
		CMainOption::s_pMru->SetMenuHandle(hMruMenu);
		CMainOption::s_pMru->UpdateMenu();
	}

// Data	members

// Constructor
	CMainOption() {	}

	static bool	IsQualify(int nWindowCount)
	{
		if (!(s_dwMainExtendedStyle	& MAIN_EX_WINDOWLIMIT))
			return true;

		if (nWindowCount < s_dwMaxWindowCount)
			return true;
		else
			return false;
	}

// Message map and handlers
	BEGIN_MSG_MAP(CMainFrame)
		COMMAND_ID_HANDLER_EX(ID_MAIN_EX_NEWWINDOW,	OnMainExNewWindow)
		COMMAND_ID_HANDLER_EX(ID_MAIN_EX_NOACTIVATE, OnMainExNoActivate)
		COMMAND_ID_HANDLER_EX(ID_MAIN_EX_NOACTIVATE_NEWWIN,	OnMainExNoActivateNewWin)
		COMMAND_ID_HANDLER_EX(ID_EXPLORERBAR_AUTOSHOW, OnExplorerBarAutoShow)
	END_MSG_MAP()

	void OnMainExNewWindow(WORD	/*wNotifyCode*/, WORD /*wID*/, HWND	/*hWndCtl*/)
	{
		if (s_dwMainExtendedStyle &	MAIN_EX_NEWWINDOW)
			s_dwMainExtendedStyle &= ~MAIN_EX_NEWWINDOW;
		else
			s_dwMainExtendedStyle |= MAIN_EX_NEWWINDOW;
	}

	void OnMainExNoActivate(WORD /*wNotifyCode*/, WORD /*wID*/,	HWND /*hWndCtl*/)
	{
		if (s_dwMainExtendedStyle &	MAIN_EX_NOACTIVATE)
			s_dwMainExtendedStyle &= ~MAIN_EX_NOACTIVATE;
		else
			s_dwMainExtendedStyle |= MAIN_EX_NOACTIVATE;
	}

	void OnMainExNoActivateNewWin(WORD /*wNotifyCode*/,	WORD /*wID*/, HWND /*hWndCtl*/)
	{
		if (s_dwMainExtendedStyle &	MAIN_EX_NOACTIVATE_NEWWIN)
			s_dwMainExtendedStyle &= ~MAIN_EX_NOACTIVATE_NEWWIN;
		else
			s_dwMainExtendedStyle |= MAIN_EX_NOACTIVATE_NEWWIN;
	}
	void OnExplorerBarAutoShow(WORD	/*wNotifyCode*/, WORD /*wID*/, HWND	/*hWndCtl*/)
	{
		if (s_dwExplorerBarStyle & MAIN_EXPLORER_AUTOSHOW)
			s_dwExplorerBarStyle &=	~MAIN_EXPLORER_AUTOSHOW;
		else
			s_dwExplorerBarStyle |=	MAIN_EXPLORER_AUTOSHOW;
	}

// Update command UI and handlers
	BEGIN_UPDATE_COMMAND_UI_MAP(CMainOption)
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_MAIN_EX_NEWWINDOW, MAIN_EX_NEWWINDOW, s_dwMainExtendedStyle)
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_MAIN_EX_NOACTIVATE, MAIN_EX_NOACTIVATE, s_dwMainExtendedStyle)
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_MAIN_EX_NOACTIVATE_NEWWIN, MAIN_EX_NOACTIVATE_NEWWIN, s_dwMainExtendedStyle)
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_REGISTER_AS_BROWSER,	MAIN_EX_REGISTER_AS_BROWSER, s_dwMainExtendedStyle)
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_EXPLORERBAR_AUTOSHOW, MAIN_EXPLORER_AUTOSHOW, s_dwExplorerBarStyle)
	END_UPDATE_COMMAND_UI_MAP()
};

__declspec(selectany) DWORD	CMainOption::s_dwMainExtendedStyle = MAIN_EX_NEWWINDOW|MAIN_EX_NOACTIVATE|MAIN_EX_NOACTIVATE_NEWWIN|MAIN_EX_KILLDIALOG;
__declspec(selectany) DWORD	CMainOption::s_dwMainExtendedStyle2	= 0;
__declspec(selectany) DWORD	CMainOption::s_dwExplorerBarStyle =	0;
__declspec(selectany) DWORD	CMainOption::s_dwMaxWindowCount	= 0;
__declspec(selectany) DWORD	CMainOption::s_dwBackUpTime	= 1;
__declspec(selectany) DWORD	CMainOption::s_dwAutoRefreshTime = 10; // UDT DGSTR	( dai
__declspec(selectany) bool CMainOption::s_bTabMode = false;

__declspec(selectany) bool CMainOption::s_bAppClosing =	false;
__declspec(selectany) bool CMainOption::s_bIgnoreUpdateClipboard = false;

__declspec(selectany) CRecentDocumentListFixed*	CMainOption::s_pMru	= NULL;
__declspec(selectany) bool CMainOption::s_bNoCstmMenu =	false;

/////////////////////////////////////////////////////////////////////////////
// CMainPropertyPage

// UDT UH
class CMainPropertyPage2 : public CPropertyPageImpl<CMainPropertyPage2>,
	public CWinDataExchange<CMainPropertyPage2>
{
public:
// Constants
	enum { IDD = IDD_PROPPAGE_MAIN2	};
	CWindow	m_wnd;

	// UH
	int	m_nDelCash,	m_nDelCookie, m_nDelHistory;
	int	m_nMakeCash;
	WORD m_nSzPain1, m_nSzPain2;
	int	m_nChkSwapPain;

	int	m_nShowMenu, m_nShowToolBar, m_nShowAdress;
	int	m_nShowTab,	m_nShowLink, m_nShowSearch,	m_nShowStatus;

	CString	m_strToolbarPath, m_strTabSkin,	m_strBtnSkin;
	int	m_nExplorerHScroll,	m_nExplorerNoSpace;
	int	m_nExplorerAutoShow, m_nExplorerOrgImage;

// DDX map
	BEGIN_DDX_MAP(CMainPropertyPage2)
		DDX_CHECK(IDC_CHECK_MAIN_DEL_CASH, m_nDelCash)
		DDX_CHECK(IDC_CHECK_MAIN_DEL_COOKIE, m_nDelCookie)
		DDX_CHECK(IDC_CHECK_MAIN_DEL_HISTORY, m_nDelHistory)
		DDX_CHECK(IDC_CHECK_MAIN_MAKECASH, m_nMakeCash)

		DDX_UINT(IDC_EDIT_SZ_PAIN1,	m_nSzPain1)
		DDX_UINT(IDC_EDIT_SZ_PAIN2,	m_nSzPain2)
		DDX_CHECK(IDC_CHK_SWAP_PAIN, m_nChkSwapPain)

		DDX_CHECK(IDC_CHK_MENU,	m_nShowMenu)
		DDX_CHECK(IDC_CHK_TOOLBAR, m_nShowToolBar)
		DDX_CHECK(IDC_CHK_ADRESS, m_nShowAdress)
		DDX_CHECK(IDC_CHK_TAB, m_nShowTab)
		DDX_CHECK(IDC_CHK_LINK,	m_nShowLink)
		DDX_CHECK(IDC_CHK_SEARCH, m_nShowSearch)
		DDX_CHECK(IDC_CHK_STATUS, m_nShowStatus)

		DDX_TEXT_LEN(IDC_ED_TOOLBAR_PATH, m_strToolbarPath,	MAX_PATH)
		DDX_TEXT_LEN(IDC_ED_TABSKIN_PATH, m_strTabSkin,	MAX_PATH)
		DDX_TEXT_LEN(IDC_ED_BTNSKIN_PATH, m_strBtnSkin,	MAX_PATH)

		DDX_CHECK(IDC_CHECK_EXP_HSCROLL, m_nExplorerHScroll)
		DDX_CHECK(IDC_CHECK_EXP_SPACE, m_nExplorerNoSpace)
		DDX_CHECK(IDC_CHECK_EXP_AUTOSHOW, m_nExplorerAutoShow)
		DDX_CHECK(IDC_CHECK_EXP_ORGIMAGE, m_nExplorerOrgImage)
	END_DDX_MAP()

// Message map and handlers
	BEGIN_MSG_MAP(CMainPropertyPage2)
		COMMAND_ID_HANDLER(IDC_BTN_TOOLBAR_DIR,	OnBtnDir)
		COMMAND_ID_HANDLER(IDC_BTN_TABSKIN_DIR,	OnBtnDir)
		COMMAND_ID_HANDLER(IDC_BTN_BTNSKIN_DIR,	OnBtnDir)

		CHAIN_MSG_MAP(CPropertyPageImpl<CMainPropertyPage2>)
	END_MSG_MAP()

	static int CALLBACK	BrowseCallbackProc(HWND	hwnd,UINT uMsg,LPARAM lParam,LPARAM	lpData)
	{
		if(uMsg	== BFFM_INITIALIZED)
		{
			if(lpData)
				SendMessage(hwnd, BFFM_SETSELECTION, TRUE, lpData);
		}
		return 0;
	}

	CString	BrowseForFolder(CString	strTitle, CString strNowPath)
	{
		TCHAR pszDisplayName[MAX_PATH];

		BROWSEINFO bi =	{ m_hWnd, NULL,	pszDisplayName,	strTitle.GetBuffer(0),
			BIF_RETURNONLYFSDIRS, &BrowseCallbackProc, (LPARAM)strNowPath.GetBuffer(0),	0 };

		CItemIDList	idl;
		idl.Attach(::SHBrowseForFolder(&bi));
		return idl.GetPath();
	}

	LRESULT	OnBtnDir(WORD /*wNotifyCode*/, WORD	wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		CString	strPath;
		switch(wID)
		{
		case IDC_BTN_TOOLBAR_DIR:
			strPath	= BrowseForFolder(_T("c[o[tH_"),	m_strToolbarPath);
			break;
		case IDC_BTN_TABSKIN_DIR:
			strPath	= BrowseForFolder(_T("^uXLtH_"),	m_strTabSkin);
			break;
		case IDC_BTN_BTNSKIN_DIR:
			strPath	= BrowseForFolder(_T("{^XLtH_"), m_strBtnSkin);
			break;
		}

		if (strPath.IsEmpty()==FALSE)
		{
			switch(wID)
			{
			case IDC_BTN_TOOLBAR_DIR: m_strToolbarPath = strPath;	break;
			case IDC_BTN_TABSKIN_DIR: m_strTabSkin = strPath;		break;
			case IDC_BTN_BTNSKIN_DIR: m_strBtnSkin = strPath;		break;
			}
		}
		DoDataExchange(FALSE);
		return 0;

	}

// Constructor
	CMainPropertyPage2(HWND	hWnd) :	m_wnd(hWnd)
	{
		m_nSzPain1 = 150;
		m_nSzPain2 = 150;
		m_nChkSwapPain = FALSE;

		m_nShowMenu	= FALSE;
		m_nShowToolBar = FALSE;
		m_nShowAdress =	FALSE;
		m_nShowTab = FALSE;
		m_nShowLink	= FALSE;
		m_nShowSearch =	FALSE;
		m_nShowStatus =	FALSE;

		m_strToolbarPath = _T("");
		m_strTabSkin = _T("");
		m_strBtnSkin = _T("");
		_SetData();
	}

// Overrides
	BOOL OnSetActive()
	{
		SetModified(TRUE);
		return DoDataExchange(FALSE);
	}
	BOOL OnKillActive()
	{
		return DoDataExchange(TRUE);
	}
	BOOL OnApply()
	{
		if (DoDataExchange(TRUE)) {
			_GetData();
			return TRUE;
		}
		else
			return FALSE;
	}
protected:
	void _GetData()
	{
		// Update main style
		CMainOption::s_dwMainExtendedStyle2	= 0;
		// UH
		if (m_nDelCash == 1)
			CMainOption::s_dwMainExtendedStyle2	|= MAIN_EX2_DEL_CASH;
		if (m_nDelCookie ==	1)
			CMainOption::s_dwMainExtendedStyle2	|= MAIN_EX2_DEL_COOKIE;
		if (m_nDelHistory == 1)
			CMainOption::s_dwMainExtendedStyle2	|= MAIN_EX2_DEL_HISTORY;
		if (m_nMakeCash	== 1)
			CMainOption::s_dwMainExtendedStyle2	|= MAIN_EX2_MAKECASH;

		CMainOption::s_dwExplorerBarStyle =	0;
		if (m_nExplorerHScroll==1)
			CMainOption::s_dwExplorerBarStyle |= MAIN_EXPLORER_HSCROLL;
		if (m_nExplorerNoSpace==1)
			CMainOption::s_dwExplorerBarStyle |= MAIN_EXPLORER_NOSPACE;
		if (m_nExplorerAutoShow==1)
			CMainOption::s_dwExplorerBarStyle |= MAIN_EXPLORER_AUTOSHOW;
		if (m_nExplorerOrgImage==1)
			CMainOption::s_dwExplorerBarStyle |= MAIN_EXPLORER_FAV_ORGIMG;

		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("StatusBar"));
		pr.SetValue(MAKELONG(m_nSzPain1, m_nSzPain2), _T("SizePain"));
		pr.SetValue(m_nChkSwapPain,	_T("SwapPain"));
		pr.Close();

		pr.Open(_szIniFileName,	_T("FullScreen"));
		pr.SetValue(m_nShowMenu, _T("ShowMenu"));
		pr.SetValue(m_nShowToolBar,	_T("ShowToolBar"));
		pr.SetValue(m_nShowAdress, _T("ShowAdress"));
		pr.SetValue(m_nShowTab,	_T("ShowTab"));
		pr.SetValue(m_nShowLink, _T("ShowLink"));
		pr.SetValue(m_nShowSearch, _T("ShowSearch"));
		pr.SetValue(m_nShowStatus, _T("ShowStatus"));
		pr.Close();

		pr.Open(_szIniFileName,	_T("Path"));
		pr.SetValue(m_strToolbarPath, _T("ToolbarPath"));
		pr.SetValue(m_strTabSkin, _T("TabSkinPath"));
		pr.SetValue(m_strBtnSkin, _T("BtnSkinPath"));
		pr.Close();
	}

	void _SetData()
	{
		// UH
		m_nDelCash = CMainOption::s_dwMainExtendedStyle2 & MAIN_EX2_DEL_CASH ? 1:0;
		m_nDelCookie = CMainOption::s_dwMainExtendedStyle2 & MAIN_EX2_DEL_COOKIE ? 1:0;
		m_nDelHistory =	CMainOption::s_dwMainExtendedStyle2	& MAIN_EX2_DEL_HISTORY ? 1:0;
		m_nMakeCash	= CMainOption::s_dwMainExtendedStyle2 &	MAIN_EX2_MAKECASH ?	1:0;

		m_nExplorerHScroll = CMainOption::s_dwExplorerBarStyle & MAIN_EXPLORER_HSCROLL ? 1:0;
		m_nExplorerNoSpace = CMainOption::s_dwExplorerBarStyle & MAIN_EXPLORER_NOSPACE ? 1:0;
		m_nExplorerAutoShow	= CMainOption::s_dwExplorerBarStyle	& MAIN_EXPLORER_AUTOSHOW ? 1:0;
		m_nExplorerOrgImage	= CMainOption::s_dwExplorerBarStyle	& MAIN_EXPLORER_FAV_ORGIMG ? 1:0;

		DWORD dwVal=0;
		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("StatusBar"));
		if (pr.QueryValue(dwVal, _T("SizePain"))==ERROR_SUCCESS)
		{
			m_nSzPain1 = LOWORD(dwVal);
			m_nSzPain2 = HIWORD(dwVal);
		}
		if (pr.QueryValue(dwVal, _T("SwapPain"))==ERROR_SUCCESS)
			m_nChkSwapPain = dwVal;
		pr.Close();

		pr.Open(_szIniFileName,	_T("FullScreen"));
		if (pr.QueryValue(dwVal, _T("ShowMenu"))==ERROR_SUCCESS)
			m_nShowMenu	= dwVal;
		if (pr.QueryValue(dwVal, _T("ShowToolBar"))==ERROR_SUCCESS)
			m_nShowToolBar = dwVal;
		if (pr.QueryValue(dwVal, _T("ShowAdress"))==ERROR_SUCCESS)
			m_nShowAdress =	dwVal;
		if (pr.QueryValue(dwVal, _T("ShowTab"))==ERROR_SUCCESS)
			m_nShowTab = dwVal;
		if (pr.QueryValue(dwVal, _T("ShowLink"))==ERROR_SUCCESS)
			m_nShowLink	= dwVal;
		if (pr.QueryValue(dwVal, _T("ShowSearch"))==ERROR_SUCCESS)
			m_nShowSearch =	dwVal;
		if (pr.QueryValue(dwVal, _T("ShowStatus"))==ERROR_SUCCESS)
			m_nShowStatus =	dwVal;
		pr.Close();


		pr.Open(_szIniFileName,	_T("Path"));

		TCHAR szPath[MAX_PATH];
		memset(szPath, 0, MAX_PATH);
		DWORD dwCount =	MAX_PATH;
		pr.QueryValue(szPath, _T("ToolbarPath"), &dwCount);
		m_strToolbarPath.Format(_T("%s"), szPath);
		if (m_strToolbarPath.IsEmpty())
			m_strToolbarPath = _GetDonutPath() + _T("Toolbar");

		memset(szPath, 0, MAX_PATH);
		pr.QueryValue(szPath, _T("TabSkinPath"), &dwCount);
		m_strTabSkin.Format(_T("%s"), szPath);
		if (m_strTabSkin.IsEmpty())
			m_strTabSkin = _GetDonutPath() + _T("TabSkin");

		memset(szPath, 0, MAX_PATH);
		pr.QueryValue(szPath, _T("BtnSkinPath"), &dwCount);
		m_strBtnSkin.Format(_T("%s"), szPath);
		if (m_strBtnSkin.IsEmpty())
			m_strBtnSkin = _GetDonutPath() + _T("BtnSkin");

		pr.Close();
	}
};
// END

class CMainPropertyPage	: public CPropertyPageImpl<CMainPropertyPage>,
	public CWinDataExchange<CMainPropertyPage>
{
public:
// Constants
	enum { IDD = IDD_PROPPAGE_MAIN };

// Data	members
	int	m_nNewWindow, m_nNoActivate, m_nNoActivateNewWin,
		m_nOneInstance,	m_nLimit, m_nNoCloseDFG, m_nNoMDI, m_nBackUp,
		m_nAddFavoriteOldShell,	m_nOrgFavoriteOldShell,	m_nRegisterAsBrowser;
	int	m_nMaxWindowCount, m_nBackUpTime;
	int	m_nAutoRefreshTime,	m_nAutoRefTimeMin, m_nAutoRefTimeSec; // UDT DGSTR ( dai
	int	m_nLoadGlobalOffline, m_nKillDialog;
	int	m_nInheritOptions;
	CWindow	m_wnd;
	//+++ CLogFont m_lf;
	MTL::CLogFont m_lf;

// DDX map
	BEGIN_DDX_MAP(CMainPropertyPage)
		DDX_CHECK(IDC_CHECK_MAIN_NEWWINDOW,	m_nNewWindow)
		DDX_CHECK(IDC_CHECK_MAIN_NOACTIVATE, m_nNoActivate)
		DDX_CHECK(IDC_CHECK_MAIN_NOACTIVATE_NEWWIN,	m_nNoActivateNewWin)
		DDX_CHECK(IDC_CHECK_MAIN_NOMDI,	m_nNoMDI)
		DDX_CHECK(IDC_CHECK_MAIN_INHERIT_OPTIONS, m_nInheritOptions)
		DDX_CHECK(IDC_CHECK_ONEINSTANCE, m_nOneInstance)
		DDX_CHECK(IDC_CHECK_MAIN_LIMIT,	m_nLimit)
		DDX_CHECK(IDC_CHECK_MAIN_BACKUP, m_nBackUp)
		DDX_CHECK(IDC_CHECK_MAIN_NOCLOSEDFG, m_nNoCloseDFG)
		DDX_CHECK(IDC_CHECK_MAIN_ADDFAVORITEOLDSHELL, m_nAddFavoriteOldShell)
		DDX_CHECK(IDC_CHECK_MAIN_ORGFAVORITEOLDSHELL, m_nOrgFavoriteOldShell)
		DDX_CHECK(IDC_CHECK_MAIN_LOADGLOBALOFFLINE,	m_nLoadGlobalOffline)
		DDX_CHECK(IDC_CHECK_MAIN_KILLDIALOG, m_nKillDialog)
		DDX_CHECK(IDC_CHECK_MAIN_REGISTER_AS_BROWSER, m_nRegisterAsBrowser)
		DDX_INT_RANGE(IDC_EDIT_MAIN_LIMITEDCOUNT, m_nMaxWindowCount, 0,	255)
		DDX_INT_RANGE(IDC_EDIT_MAIN_BACKUPTIME,	m_nBackUpTime, 1, 120)

		// UDT DGSTR ( dai
		DDX_INT_RANGE(IDC_EDIT_MAIN_AUTOREFRESHTIME_MIN, m_nAutoRefTimeMin,	0, 59)
		DDX_INT_RANGE(IDC_EDIT_MAIN_AUTOREFRESHTIME_SEC, m_nAutoRefTimeSec,	0, 59)
		// ENDE

END_DDX_MAP()

// Message map and handlers
	BEGIN_MSG_MAP(CMainPropertyPage)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_BAR_FONT, OnFont)
		CHAIN_MSG_MAP(CPropertyPageImpl<CMainPropertyPage>)
	END_MSG_MAP()

	void OnFont(WORD /*wNotifyCode*/, WORD /*wID*/,	HWND hWndCtl)
	{
		CFontDialog	dlg(&m_lf);
		if (dlg.DoModal() == IDOK){
			m_lf = dlg.m_lf;
		}
	}

// Constructor
	CMainPropertyPage(HWND hWnd) : m_wnd(hWnd)
	{
		_SetData();
	}

// Overrides
	BOOL OnSetActive()
	{
		SetModified(TRUE);
		return DoDataExchange(FALSE);
	}
	BOOL OnKillActive()
	{
		return DoDataExchange(TRUE);
	}
	BOOL OnApply()
	{
		if (DoDataExchange(TRUE)) {
			_GetData();
			return TRUE;
		}
		else
			return FALSE;
	}

// Implementation
protected:
	void _GetData()
	{
		// Update main style
		CMainOption::s_dwMainExtendedStyle = 0;
		if (m_nNewWindow ==	1)
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_NEWWINDOW;
		if (m_nNoActivate == 1)
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_NOACTIVATE;
		if (m_nNoActivateNewWin	== 1)
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_NOACTIVATE_NEWWIN;
		if (m_nOneInstance == 1)
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_ONEINSTANCE;
		if (m_nLimit ==	1)
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_WINDOWLIMIT;
		if (m_nNoCloseDFG == 1)
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_NOCLOSEDFG;
		if (m_nNoMDI ==	1)
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_NOMDI;
		if (m_nBackUp == 1)
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_BACKUP;
		if (m_nAddFavoriteOldShell == 1)
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_ADDFAVORITEOLDSHELL;
		if (m_nOrgFavoriteOldShell == 1)
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_ORGFAVORITEOLDSHELL;
		if (m_nRegisterAsBrowser ==	1) {
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_REGISTER_AS_BROWSER;
			MtlSendOnCommand(m_wnd,	ID_REGISTER_AS_BROWSER);
		}
		else {
			MtlSendOffCommand(m_wnd, ID_REGISTER_AS_BROWSER);
		}

		if (m_nLoadGlobalOffline ==	1)
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_LOADGLOBALOFFLINE;
		if (m_nKillDialog == 1)
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_KILLDIALOG;

		if (m_nInheritOptions == 1)
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_INHERIT_OPTIONS;

		// update max window count
		CMainOption::s_dwMaxWindowCount	= m_nMaxWindowCount;
		CMainOption::s_dwBackUpTime	= m_nBackUpTime;
		// UDT DGSTR ( dai
		m_nAutoRefreshTime = m_nAutoRefTimeMin*60 +	m_nAutoRefTimeSec;
		CMainOption::s_dwAutoRefreshTime = m_nAutoRefreshTime;
		// ENDE
		m_wnd.PostMessage(WM_COMMAND, ID_BACKUPOPTION_CHANGED);

		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("Main"));
		m_lf.WriteProfile(pr);
		pr.Close();
	}

	void _SetData()
	{
		m_nNewWindow = CMainOption::s_dwMainExtendedStyle &	MAIN_EX_NEWWINDOW ?	1 :	0;
		m_nNoActivate =	CMainOption::s_dwMainExtendedStyle & MAIN_EX_NOACTIVATE	? 1	: 0;
		m_nNoActivateNewWin	= CMainOption::s_dwMainExtendedStyle & MAIN_EX_NOACTIVATE_NEWWIN ? 1 : 0;
		m_nOneInstance = CMainOption::s_dwMainExtendedStyle	& MAIN_EX_ONEINSTANCE ?	1 :	0;
		m_nLimit = CMainOption::s_dwMainExtendedStyle &	MAIN_EX_WINDOWLIMIT	? 1	: 0;
		m_nNoCloseDFG =	CMainOption::s_dwMainExtendedStyle & MAIN_EX_NOCLOSEDFG	? 1	: 0;
		m_nNoMDI = CMainOption::s_dwMainExtendedStyle &	MAIN_EX_NOMDI ?	1 :	0;
		m_nBackUp =	CMainOption::s_dwMainExtendedStyle & MAIN_EX_BACKUP	? 1	: 0;
		m_nMaxWindowCount =	CMainOption::s_dwMaxWindowCount;
		m_nBackUpTime =	CMainOption::s_dwBackUpTime;
		// UDT DGSTR ( dai
		m_nAutoRefreshTime = CMainOption::s_dwAutoRefreshTime;
		m_nAutoRefTimeMin =	CMainOption::s_dwAutoRefreshTime/60;
		m_nAutoRefTimeSec =	CMainOption::s_dwAutoRefreshTime%60;
		// ENDE
		m_nAddFavoriteOldShell = CMainOption::s_dwMainExtendedStyle	& MAIN_EX_ADDFAVORITEOLDSHELL ?	1 :	0;
		m_nOrgFavoriteOldShell = CMainOption::s_dwMainExtendedStyle	& MAIN_EX_ORGFAVORITEOLDSHELL ?	1 :	0;
		m_nLoadGlobalOffline = CMainOption::s_dwMainExtendedStyle &	MAIN_EX_LOADGLOBALOFFLINE ?	1 :	0;
		m_nKillDialog =	CMainOption::s_dwMainExtendedStyle & MAIN_EX_KILLDIALOG	? 1	: 0;
		m_nRegisterAsBrowser = CMainOption::s_dwMainExtendedStyle &	MAIN_EX_REGISTER_AS_BROWSER	? 1	: 0;
		m_nInheritOptions =	CMainOption::s_dwMainExtendedStyle & MAIN_EX_INHERIT_OPTIONS ? 1 : 0;

		// refresh our font
		NONCLIENTMETRICS info;
		info.cbSize	= sizeof(info);
		::SystemParametersInfo(SPI_GETNONCLIENTMETRICS,	sizeof(info), &info, 0);
		m_lf = info.lfMenuFont;

		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("Main"));
		//+++ CLogFont lf;
		MTL::CLogFont lf;
		if (lf.GetProfile(pr))
			m_lf = lf;
		pr.Close();
	}
};

// DL Control Flags
#define	DLCTL_DEFAULT DLCTL_DLIMAGES | DLCTL_VIDEOS	| DLCTL_BGSOUNDS
class CDLControlOption
{
public:
	static DWORD 	s_dwDLControlFlags;			// default flags
	static TCHAR 	s_szUserAgent[MAX_PATH]; 	// UDT DGSTR

	static void	GetProfile()
	{
		CIniSection		pr;

		pr.Open(_szIniFileName,	_T("Browser"));
		if (pr.QueryValue(s_dwDLControlFlags, _T("DLControl_Flags")) !=	ERROR_SUCCESS)
			s_dwDLControlFlags = DLCTL_DEFAULT;

		// UDT DGSTR
		DWORD dwCount =	MAX_PATH;
		if (pr.QueryValue(s_szUserAgent, _T("UserAgent"), &dwCount)	!= ERROR_SUCCESS)
			::lstrcpy(s_szUserAgent, _T(""));
		// ENDE

		DWORD dwMozilla	= 0;
		pr.QueryValue(dwMozilla, _T("Mozilla"));
		_bMozilla =	(dwMozilla == 1) ? true	: false;

		// UDT DGSTR ( dai
		DWORD dwFlatScrBar = 0;
		pr.QueryValue(dwFlatScrBar,	_T("FlatScrBar"));
		_bFlatScrBar = (dwFlatScrBar ==	1) ? true :	false;
		//ENDE

		// UH
		pr.QueryValue(_dwViewStyle,	_T("ViewStyle"));

		pr.Close();
	}

	static void	WriteProfile()
	{
		CIniSection	pr;

		pr.Open(_szIniFileName			, _T("Browser")			);
		pr.SetValue(s_dwDLControlFlags	, _T("DLControl_Flags")	);
		pr.SetValue(s_szUserAgent		, _T("UserAgent")		); //	UDT	DGSTR
		pr.SetValue(_bMozilla ?	1 :	0	, _T("Mozilla")			);

		// UDT DGSTR ( dai
		pr.SetValue(_bFlatScrBar ? 1 : 0, _T("FlatScrBar")		);

		// UH
		pr.SetValue(_dwViewStyle		, _T("ViewStyle")		);

		pr.Close();
	}
};

__declspec(selectany) DWORD	CDLControlOption::s_dwDLControlFlags = 0;
//TCHAR	CDLControlOption::s_szUserAgent[MAX_PATH]; // UDT DGSTR

/////////////////////////////////////////////////////////////////////////////
// CDLControlPropertyPage

class CDLControlPropertyPage : public CPropertyPageImpl<CDLControlPropertyPage>,
	public CWinDataExchange<CDLControlPropertyPage>
{
public:
// Constants
	enum { IDD = IDD_PROPPAGE_DLCONTROL	};

// Data	members
	int 	m_nBGSounds, m_nVideos,	m_nDLImages;
	int 	m_nRunActiveXCtls, m_nDLActiveXCtls, m_nScripts, m_nJava;
	int 	m_nMozilla;
	int 	m_nNaviLock;
	int 	m_nFlatScrBar;		// UDT DGSTR ( dai
	CString	m_strUserAgent;		// UDT DGSTR
	CEdit	m_edit; 			// UDT DGSTR

	// UH
	HWND 	m_hMainWnd;
	BOOL 	m_bMsgFilter, m_bMouseGesture,	m_bBlockMailto;

// DDX map
	BEGIN_DDX_MAP(CDLControlPropertyPage)
		DDX_CHECK(IDC_CHECK_DLCTL_BGSOUNDS		, m_nBGSounds		)
		DDX_CHECK(IDC_CHECK_DLCTL_VIDEOS		, m_nVideos			)
		DDX_CHECK(IDC_CHECK_DLCTL_DLIMAGES		, m_nDLImages		)
		DDX_CHECK(IDC_CHECK_DLCTL_RUNACTIVEXCTLS, m_nRunActiveXCtls	)
		DDX_CHECK(IDC_CHECK_DLCTL_DLACTIVEXCTLS	, m_nDLActiveXCtls	)
		DDX_CHECK(IDC_CHECK_DLCTL_SCRIPTS		, m_nScripts		)
		DDX_CHECK(IDC_CHECK_DLCTL_JAVA			, m_nJava			)
		DDX_CHECK(IDC_CHECK_MOZILLA				, m_nMozilla		)
		DDX_CHECK(IDC_CHECK_NAVILOCK			, m_nNaviLock		)
		DDX_CHECK(IDC_CHECK_SCROLLBAR			, m_nFlatScrBar		) // UDT DGSTR ( dai

		// UH
		DDX_CHECK(IDC_CHK_MSG_FILTER			, m_bMsgFilter		)
		DDX_CHECK(IDC_CHK_MOUSE_GESTURE			, m_bMouseGesture	)
		DDX_CHECK(IDC_CHK_BLOCK_MAILTO			, m_bBlockMailto	)

		DDX_TEXT_LEN(IDC_EDIT_USER_AGENT, m_strUserAgent, MAX_PATH)	// UDT DGSTR
	END_DDX_MAP()

// Constructor
	CDLControlPropertyPage(HWND	hMainWnd)
	{
		m_hMainWnd = hMainWnd;
		_SetData();
	}

// Overrides
	BOOL OnSetActive()
	{
		SetModified(TRUE);

		// UDT DGSTR
		if (m_edit.m_hWnd == NULL)
			m_edit.Attach(GetDlgItem(IDC_EDIT_USER_AGENT));
		// ENDE

		return DoDataExchange(FALSE);
	}
	BOOL OnKillActive()
	{
		return DoDataExchange(TRUE);
	}
	BOOL OnApply()
	{
		if (DoDataExchange(TRUE)) {
			_GetData();
			return TRUE;
		}
		else
			return FALSE;
	}

// Message map and handlers
	BEGIN_MSG_MAP(CDLControlPropertyPage)
		CHAIN_MSG_MAP(CPropertyPageImpl<CDLControlPropertyPage>)
	END_MSG_MAP()

// Implementation
protected:
	void _GetData()
	{
		// update dl control flags
		CDLControlOption::s_dwDLControlFlags = 0;

		if (m_nBGSounds	== 1)
			CDLControlOption::s_dwDLControlFlags |=	DLCTL_BGSOUNDS;
		if (m_nVideos   == 1)
			CDLControlOption::s_dwDLControlFlags |=	DLCTL_VIDEOS;
		if (m_nDLImages	== 1)
			CDLControlOption::s_dwDLControlFlags |=	DLCTL_DLIMAGES;

		if (m_nRunActiveXCtls == 0)
			CDLControlOption::s_dwDLControlFlags |=	DLCTL_NO_RUNACTIVEXCTLS;
		if (m_nDLActiveXCtls  == 0)
			CDLControlOption::s_dwDLControlFlags |=	DLCTL_NO_DLACTIVEXCTLS;
		if (m_nScripts		  == 0)
			CDLControlOption::s_dwDLControlFlags |=	DLCTL_NO_SCRIPTS;
		if (m_nJava			  == 0)
			CDLControlOption::s_dwDLControlFlags |=	DLCTL_NO_JAVA;

		if (m_nMozilla == 1)
			_bMozilla =	true;
		else
			_bMozilla =	false;


		// UDT DGSTR ( dai
		if (m_nFlatScrBar == 1)
			_bFlatScrBar = true;
		else
			_bFlatScrBar = false;
		// ENDE

		// UH
		_dwViewStyle = 0;
		if (m_nNaviLock    ==1)	_dwViewStyle |=	DVS_EX_OPENNEWWIN;
		if (m_bMsgFilter   ==1)	_dwViewStyle |=	DVS_EX_MESSAGE_FILTER;
		if (m_bMouseGesture==1)	_dwViewStyle |=	DVS_EX_MOUSE_GESTURE;
		if (m_bBlockMailto ==1)	_dwViewStyle |=	DVS_EX_BLOCK_MAILTO;

		SendMessage(m_hMainWnd,	WM_COMMAND,	ID_RESIZED,	0);
		m_edit.GetWindowText(CDLControlOption::s_szUserAgent, MAX_PATH); //	UDT	DGSTR
	}

	void _SetData()
	{
		m_nBGSounds			= CDLControlOption::s_dwDLControlFlags & DLCTL_BGSOUNDS	? 1	: 0;
		m_nVideos 			= CDLControlOption::s_dwDLControlFlags & DLCTL_VIDEOS	? 1	: 0;
		m_nDLImages			= CDLControlOption::s_dwDLControlFlags & DLCTL_DLIMAGES	? 1	: 0;

		m_nRunActiveXCtls	= CDLControlOption::s_dwDLControlFlags & DLCTL_NO_RUNACTIVEXCTLS ? 0 : 1;
		m_nDLActiveXCtls	= CDLControlOption::s_dwDLControlFlags & DLCTL_NO_DLACTIVEXCTLS  ? 0 : 1;
		m_nScripts			= CDLControlOption::s_dwDLControlFlags & DLCTL_NO_SCRIPTS        ? 0 : 1;
		m_nJava				= CDLControlOption::s_dwDLControlFlags & DLCTL_NO_JAVA           ? 0 : 1;

		m_nMozilla 			= _bMozilla ? 1 : 0;

		// UDT DGSTR ( dai
		m_nFlatScrBar 		= _bFlatScrBar ? 1 : 0;

		// UH
		m_nNaviLock			= (_dwViewStyle & DVS_EX_OPENNEWWIN    ) ? 1:0;
		m_bMsgFilter 		= (_dwViewStyle & DVS_EX_MESSAGE_FILTER) ? 1:0;
		m_bMouseGesture		= (_dwViewStyle & DVS_EX_MOUSE_GESTURE ) ? 1:0;
		m_bBlockMailto 		= (_dwViewStyle & DVS_EX_BLOCK_MAILTO  ) ? 1:0;

		// UDT DGSTR
		if ( lstrlen(CDLControlOption::s_szUserAgent) != 0 )
			m_strUserAgent 	= CDLControlOption::s_szUserAgent;
		else
		{
			//+++ ObtainUserAgentString ansił̂悤...?
			char/*+++TCHAR*/ szDefUserAgent[MAX_PATH];
			DWORD 	size 	= MAX_PATH;
			::ObtainUserAgentString( 0 , szDefUserAgent	,&size);
			// NOTE: Here ,	the	other way.
			/*
			DWORD nUnused;
			::UrlMkGetSessionOption(URLMON_OPTION_USERAGENT	, (void	*)szDefUserAgent ,
					lstrlen(szDefUserAgent)	, &nUnused , 0);
			*/
			m_strUserAgent	= szDefUserAgent;
		}
		// ENDE
	}
};


class CIgnoredURLsOption
{
public:
	typedef	std::list<CString> CStringList;
	static CStringList*	s_pIgnoredURLs;
	static bool	s_bValid;

	static void	GetProfile()
	{
		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("IgnoredURLs"));

		DWORD dwValid;
		LONG lRet =	pr.QueryValue(dwValid, _T("IsValid"));
		if (lRet ==	ERROR_SUCCESS)
			s_bValid = (dwValid	== 1);

		s_pIgnoredURLs = new CStringList;
//		MtlGetProfileString(pr,	std::back_inserter(*s_pIgnoredURLs), _T("url"));
		::FileReadString(_GetFilePath(_T("CloseURL.ini")), s_pIgnoredURLs);

	}

	static void	WriteProfile()
	{
		CIniSection	pr;

		MtlIniDeleteSection(_szIniFileName,	_T("IgnoredURLs"));// clean	up
		pr.Open(_szIniFileName,	_T("IgnoredURLs"));
		pr.SetValue(s_bValid ==	true ? 1 : 0, _T("IsValid"));

//		MtlWriteProfileString(s_pIgnoredURLs->begin(), s_pIgnoredURLs->end(), pr, _T("url"));
		::FileWriteString(_GetFilePath(_T("CloseURL.ini")),	s_pIgnoredURLs);
		delete s_pIgnoredURLs;
	}

	static bool	SearchString(const CString&	strURL)
	{
		ATLASSERT(s_pIgnoredURLs !=	NULL);
		if (!s_bValid)// allways can't found
			return false;

		return MtlSearchStringWildCard(s_pIgnoredURLs->begin(),	s_pIgnoredURLs->end(), strURL);
	}

	static void	Add(const CString& strURL)
	{
		if (!SearchString(strURL))
			s_pIgnoredURLs->push_back(strURL);
	}
};

class CCloseTitlesOption
{
public:
	typedef	std::list<CString> CStringList;
	static CStringList*	s_pCloseTitles;
	static bool	s_bValid;

	static void	GetProfile()
	{
		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("CloseTitles"));

		s_pCloseTitles = new CStringList;
//		MtlGetProfileString(pr,	std::back_inserter(*s_pCloseTitles), _T("title"));
		::FileReadString(_GetFilePath(_T("CloseTitle.ini")), s_pCloseTitles);

		DWORD dwValid;
		LONG lRet =	pr.QueryValue(dwValid, _T("IsValid"));
		if (lRet ==	ERROR_SUCCESS)
			s_bValid = (dwValid	== 1);
	}

	static void	WriteProfile()
	{
		CIniSection	pr;

		MtlIniDeleteSection(_szIniFileName,	_T("CloseTitles"));// clean	up
		pr.Open(_szIniFileName,	_T("CloseTitles"));
		pr.SetValue(s_bValid ==	true ? 1 : 0, _T("IsValid"));

//		MtlWriteProfileString(s_pCloseTitles->begin(), s_pCloseTitles->end(), pr, _T("title"));
		::FileWriteString(_GetFilePath(_T("CloseTitle.ini")), s_pCloseTitles);

		delete s_pCloseTitles;
	}

	static bool	SearchString(const CString&	strTitle)
	{
		ATLASSERT(s_pCloseTitles !=	NULL);
		if (!s_bValid)// allways can't found
			return false;

		return MtlSearchStringWildCard(s_pCloseTitles->begin(),	s_pCloseTitles->end(), strTitle);
	}

	static void	Add(const CString& strTitle)
	{
		if (!SearchString(strTitle))
			s_pCloseTitles->push_back(strTitle);
	}
};

__declspec(selectany) CCloseTitlesOption::CStringList* CCloseTitlesOption::s_pCloseTitles =	NULL;
__declspec(selectany) bool CCloseTitlesOption::s_bValid	= true;



__declspec(selectany) CIgnoredURLsOption::CStringList* CIgnoredURLsOption::s_pIgnoredURLs =	NULL;
__declspec(selectany) bool CIgnoredURLsOption::s_bValid	= true;
class CDeterrentPropertyPage :
	public CPropertyPageImpl<CDeterrentPropertyPage>,
	public CWinDataExchange<CDeterrentPropertyPage>
{
public:
// Declarations
	enum { IDD = IDD_PROPPAGE_DETERRENT	};

// Data	members
	CIgnoredURLsOption::CStringList	m_urls;
	CCloseTitlesOption::CStringList	m_titles;
	CString							m_strUrl,	m_strTitle;
	CListBox						m_ltUrl,	m_ltTitle;
	CEdit							m_edtUrl,	m_edtTitle;
	int								m_nChkUrl,	m_nChkTitle;

// Constructor
	CDeterrentPropertyPage(const CString& strUrl, const	CString& strTitle):
		m_urls(*CIgnoredURLsOption::s_pIgnoredURLs), m_strUrl(strUrl),
		m_titles(*CCloseTitlesOption::s_pCloseTitles), m_strTitle(strTitle)
	{
		m_urls.sort();
		m_titles.sort();
		m_nChkUrl =	CIgnoredURLsOption::s_bValid ? 1 : 0;
		m_nChkTitle	= CCloseTitlesOption::s_bValid ? 1 : 0;
	}

// DDX map
	BEGIN_DDX_MAP(CDeterrentPropertyPage)
		DDX_CHECK(IDC_CHK_URL,		m_nChkUrl)
		DDX_CHECK(IDC_CHK_TITLE,	m_nChkTitle)
	END_DDX_MAP()

// Overrides
	BOOL OnSetActive()
	{
		SetModified(TRUE);
		return _DoDataExchange(FALSE);
	}
	BOOL OnKillActive()
	{
		return _DoDataExchange(TRUE);
	}
	BOOL OnApply()
	{
		if (_DoDataExchange(TRUE)) {
			_GetData();
			return TRUE;
		}
		else
			return FALSE;
	}

// overrides
	BOOL _DoDataExchange(BOOL bSaveAndValidate)// get data from	controls?
	{
		if (!bSaveAndValidate)
		{
			// set data	of control
			m_ltUrl.Attach	( GetDlgItem(IDC_LIST_URL) );
			m_ltTitle.Attach( GetDlgItem(IDC_LIST_TITLE) );

			m_ltUrl.ResetContent();
			m_ltTitle.ResetContent();

			std::for_each( m_urls.begin(), m_urls.end(), _AddToListBox(m_ltUrl)	);
			std::for_each( m_titles.begin(), m_titles.end(), _AddToListBox(m_ltTitle) );

			m_edtUrl.Attach		( GetDlgItem(IDC_EDIT_URL) );
			m_edtTitle.Attach	( GetDlgItem(IDC_EDIT_TITLE) );

			m_edtUrl.SetWindowText(	m_strUrl );
			m_edtTitle.SetWindowText( m_strTitle );
		}

		return DoDataExchange(bSaveAndValidate);
	}

// Message map and handlers
	BEGIN_MSG_MAP(CIgnoredURLsPropertyPage)
		COMMAND_ID_HANDLER_EX( IDC_BTN_ADD_URL,		OnAddCmd )
		COMMAND_ID_HANDLER_EX( IDC_BTN_ADD_TITLE,	OnAddCmd )

		COMMAND_ID_HANDLER_EX( IDC_BTN_DELALL_URL,	OnDelAllCmd	)
		COMMAND_ID_HANDLER_EX( IDC_BTN_DELALL_TITLE,OnDelAllCmd	)

		COMMAND_ID_HANDLER_EX( IDC_BTN_DEL_URL,		OnDelCmd )
		COMMAND_ID_HANDLER_EX( IDC_BTN_DEL_TITLE,	OnDelCmd )

		COMMAND_HANDLER_EX(	IDC_LIST_URL,	LBN_SELCHANGE, OnSelChange )
		COMMAND_HANDLER_EX(	IDC_LIST_TITLE,	LBN_SELCHANGE, OnSelChange )

		CHAIN_MSG_MAP( CPropertyPageImpl<CDeterrentPropertyPage> )
	END_MSG_MAP()

	void OnDelCmd(UINT /*wNotifyCode*/,	int	wID, HWND hWndCtl)
	{
		CListBox ltBox;
		if ( wID ==	IDC_BTN_DEL_URL	)
			ltBox =	m_ltUrl;
		else
			ltBox =	m_ltTitle;

		int	nIndex = ltBox.GetCurSel();
		if (nIndex == LB_ERR) return;
		ltBox.DeleteString(nIndex);

		if ( wID ==	IDC_BTN_DEL_URL	)
		{
			CIgnoredURLsOption::CStringList::iterator it = m_urls.begin();
			std::advance(it, nIndex);
			m_urls.erase(it);
		}
		else
		{
			CCloseTitlesOption::CStringList::iterator it = m_titles.begin();
			std::advance(it, nIndex);
			m_titles.erase(it);
		}
	}

	void OnDelAllCmd(UINT /*wNotifyCode*/, int wID,	HWND hWndCtl )
	{
		switch ( wID )
		{
		case IDC_BTN_DELALL_URL:
			m_ltUrl.ResetContent();
			m_urls.clear();
			break;

		case IDC_BTN_DELALL_TITLE:
			m_ltTitle.ResetContent();
			m_titles.clear();
			break;
		}
	}

	void OnAddCmd(UINT /*wNotifyCode*/,	int	wID, HWND hWndCtl)
	{
		CEdit edtTarget	= hWndCtl;
		switch ( wID )
		{
		case IDC_BTN_ADD_URL:		edtTarget =	m_edtUrl;	break;
		case IDC_BTN_ADD_TITLE:		edtTarget =	m_edtTitle;	break;
		}

		TCHAR szEdit[MAX_PATH];
		if ( edtTarget.GetWindowText(szEdit, MAX_PATH) == 0	)
			return;

		if ( wID ==	IDC_BTN_ADD_URL	)
		{
			CIgnoredURLsOption::CStringList::iterator it = std::find(m_urls.begin(), m_urls.end(), szEdit);
			if (it == m_urls.end())
			{
				m_ltUrl.AddString(szEdit);
				m_urls.push_back(szEdit);
			}
			else {
#ifdef __SGI_STL_INTERNAL_ITERATOR_BASE_H
				int	n =	0;
				std::distance(m_urls.begin(), it, n);
				m_ltUrl.SetCurSel(n);
#else
				m_ltUrl.SetCurSel(std::distance(m_urls.begin(),	it));
#endif
			}
		}
		else
		{
			CCloseTitlesOption::CStringList::iterator it = std::find(m_titles.begin(), m_titles.end(), szEdit);
			if (it == m_titles.end())
			{
				m_ltTitle.AddString(szEdit);
				m_titles.push_back(szEdit);
			}
			else {
#ifdef __SGI_STL_INTERNAL_ITERATOR_BASE_H
				int	n =	0;
				std::distance(m_titles.begin(),	it,	n);
				m_ltTitle.SetCurSel(n);
#else
				m_ltTitle.SetCurSel(std::distance(m_titles.begin(),	it));//	is C++ standard.
#endif
			}
		}
	}

	void OnSelChange(UINT code,	int	id,	HWND hWnd)
	{
		CListBox ltBox = hWnd;
		int	nIndex = ltBox.GetCurSel();
		CString	strBox;
		ltBox.GetText(nIndex, strBox);

		switch ( ltBox.GetDlgCtrlID() )
		{
		case IDC_LIST_URL:
			m_edtUrl.SetWindowText(strBox);
			break;

		case IDC_LIST_TITLE:
			m_edtTitle.SetWindowText(strBox);
			break;
		}
	}

// Implementation
private:
	// function	objects
	struct _AddToListBox : public std::unary_function<const	CString&, void>
	{
		CListBox& _box;
		_AddToListBox(CListBox&	box) : _box(box) { }
		result_type	operator()(argument_type src)
		{
			_box.AddString(src);
		}
	};

	void _GetData()
	{
		// update ignored urls list
		*CIgnoredURLsOption::s_pIgnoredURLs	= m_urls;
		CIgnoredURLsOption::s_bValid = m_nChkUrl ==	1 ?	true : false;

		*CCloseTitlesOption::s_pCloseTitles	= m_titles;
		CCloseTitlesOption::s_bValid = m_nChkTitle == 1	? true : false;
	}
};
/*
class CIgnoredURLsPropertyPage : public	CPropertyPageImpl<CIgnoredURLsPropertyPage>,
	public CWinDataExchange<CIgnoredURLsPropertyPage>
{
public:
// Declarations
	enum { IDD = IDD_PROPPAGE_IGNOREDURLS };

// Data	members
	CIgnoredURLsOption::CStringList	m_urls;
	CString	m_strAddressBar;
	CListBox m_listbox;
	CEdit m_edit;
	int	m_nValid;

// Constructor
	CIgnoredURLsPropertyPage(const CString&	strAddressBar)
		: m_urls(*CIgnoredURLsOption::s_pIgnoredURLs), m_strAddressBar(strAddressBar)
	{
		m_urls.sort();
		m_nValid = CIgnoredURLsOption::s_bValid	? 1	: 0;
	}

// DDX map
	BEGIN_DDX_MAP(CDLControlPropertyPage)
		DDX_CHECK(IDC_IGNORED_URL_VALID, m_nValid)
	END_DDX_MAP()

// Overrides
	BOOL OnSetActive()
	{
		SetModified(TRUE);
		return _DoDataExchange(FALSE);
	}
	BOOL OnKillActive()
	{
		return _DoDataExchange(TRUE);
	}
	BOOL OnApply()
	{
		if (_DoDataExchange(TRUE)) {
			_GetData();
			return TRUE;
		}
		else
			return FALSE;
	}

// overrides
	BOOL _DoDataExchange(BOOL bSaveAndValidate)// get data from	controls?
	{
		if (!bSaveAndValidate) {// set data	of control
			m_listbox.Attach(GetDlgItem(IDC_IGNORED_URL_LIST));
			m_listbox.ResetContent();
			std::for_each(m_urls.begin(), m_urls.end(),	_AddToListBox(m_listbox));

			m_edit.Attach(GetDlgItem(IDC_URL_EDIT));
			m_edit.SetWindowText(m_strAddressBar);
		}

		return DoDataExchange(bSaveAndValidate);
	}

// Message map and handlers
	BEGIN_MSG_MAP(CIgnoredURLsPropertyPage)
		COMMAND_ID_HANDLER_EX(IDC_ADD_BUTTON, OnAddCmd)
		COMMAND_ID_HANDLER_EX(IDC_DELALL_BUTTON,OnDelAllCmd)
		COMMAND_ID_HANDLER_EX(IDC_DEL_BUTTON, OnDelCmd)
		COMMAND_HANDLER_EX(IDC_IGNORED_URL_LIST, LBN_SELCHANGE,	OnSelChange)
		CHAIN_MSG_MAP(CPropertyPageImpl<CIgnoredURLsPropertyPage>)
	END_MSG_MAP()

	void OnDelCmd(UINT wNotifyCode,	int	wID, HWND hWndCtl)
	{
		int	nIndex = m_listbox.GetCurSel();
		if (nIndex == LB_ERR)
			return;

		m_listbox.DeleteString(nIndex);
		CIgnoredURLsOption::CStringList::iterator it = m_urls.begin();
		std::advance(it, nIndex);
		m_urls.erase(it);
	}

	void OnDelAllCmd(UINT wNotifyCode, int wID,	HWND hWndCtl)
	{
		m_listbox.ResetContent();
		m_urls.clear();
	}

	void OnAddCmd(UINT wNotifyCode,	int	wID, HWND hWndCtl)
	{
		TCHAR szEdit[MAX_PATH];
		if (m_edit.GetWindowText(szEdit, MAX_PATH) == 0)
			return;

		CIgnoredURLsOption::CStringList::iterator it = std::find(m_urls.begin(), m_urls.end(), szEdit);
		if (it == m_urls.end())	{
			m_listbox.AddString(szEdit);
			m_urls.push_back(szEdit);
		}
		else {
#ifdef __SGI_STL_INTERNAL_ITERATOR_BASE_H
			int	n =	0;
			std::distance(m_urls.begin(), it, n);
			m_listbox.SetCurSel(n);
#else
			m_listbox.SetCurSel(std::distance(m_urls.begin(), it));
#endif
		}
	}

	void OnSelChange(UINT code,	int	id,	HWND hWnd)
	{
		int	nIndex = m_listbox.GetCurSel();
		CString	strBox;
		m_listbox.GetText(nIndex, strBox);
		m_edit.SetWindowText(strBox);
	}

// Implementation
private:
	// function	objects
	struct _AddToListBox : public std::unary_function<const	CString&, void>
	{
		CListBox& _box;
		_AddToListBox(CListBox&	box) : _box(box) { }
		result_type	operator()(argument_type src)
		{
			_box.AddString(src);
		}
	};

	void _GetData()
	{
		// update ignored urls list
		*CIgnoredURLsOption::s_pIgnoredURLs	= m_urls;
		CIgnoredURLsOption::s_bValid = m_nValid	== 1 ? true	: false;
	}
};
*/

#define	DVS_AUTOREFRESH_15SEC	0x00000001L
#define	DVS_AUTOREFRESH_30SEC	0x00000002L
#define	DVS_AUTOREFRESH_1MIN	0x00000004L
#define	DVS_AUTOREFRESH_2MIN	0x00000008L
#define	DVS_AUTOREFRESH_5MIN	0x00000010L
#define	DVS_AUTOREFRESH_USER	0x00000020L	// UDT DGSTR ( dai

//#define DVS_EX_OPENNEWWIN		0x00000001L
//#define DVS_EX_MESSAGE_FILTER	0x00000002L

template <class	_DonutView>
class CDonutViewOption
{
public:
	DWORD m_dwAutoRefreshStyle;
	DWORD m_dwExStyle;
	CString	m_strURL;

	_DonutView*	__m_pDonutView;
	UINT m_nIDEvent;

	CDonutViewOption(_DonutView* __pDonutView)
		: __m_pDonutView(__pDonutView),	m_nIDEvent(0),
		  m_dwAutoRefreshStyle(0), m_dwExStyle(0)
	{
		m_nIDEvent = 0;
	}

	void Init()
	{
		_SetTimer();
	}

	void Uninit()
	{
		_KillTimer();
	}

// Message map and handlers
	BEGIN_MSG_MAP(CDonutViewOption)
		COMMAND_ID_HANDLER_EX(ID_AUTOREFRESH_NONE, OnAutoRefreshNone)
		COMMAND_ID_HANDLER_EX(ID_AUTOREFRESH_15SEC,	OnAutoRefresh15sec)
		COMMAND_ID_HANDLER_EX(ID_AUTOREFRESH_30SEC,	OnAutoRefresh30sec)
		COMMAND_ID_HANDLER_EX(ID_AUTOREFRESH_1MIN, OnAutoRefresh1min)
		COMMAND_ID_HANDLER_EX(ID_AUTOREFRESH_2MIN, OnAutoRefresh2min)
		COMMAND_ID_HANDLER_EX(ID_AUTOREFRESH_5MIN, OnAutoRefresh5min)
		COMMAND_ID_HANDLER_EX(ID_AUTOREFRESH_USER, OnAutoRefreshUser) // UDT DGSTR ( dai

//		COMMAND_ID_HANDLER_EX(ID_DOCHOSTUI_OPENNEWWIN, OnDocHostUIOpenNewWin)

		// UH
		COMMAND_ID_HANDLER_EX(ID_MESSAGE_FILTER, OnMessageFilter)
		COMMAND_ID_HANDLER_EX(ID_MOUSE_GESTURE,	OnMouseGesture)
		COMMAND_ID_HANDLER_EX(ID_BLOCK_MAILTO, OnBlockMailto)

		MSG_WM_TIMER(OnTimer)
	END_MSG_MAP()

	void OnBlockMailto(WORD	/*wNotifyCode*/, WORD /*wID*/, HWND	/*hWndCtl*/)
	{
		if (m_dwExStyle&DVS_EX_BLOCK_MAILTO)
			m_dwExStyle	&= ~DVS_EX_BLOCK_MAILTO;
		else
			m_dwExStyle	|= DVS_EX_BLOCK_MAILTO;
	}

	void OnMouseGesture(WORD /*wNotifyCode*/, WORD /*wID*/,	HWND /*hWndCtl*/)
	{
		if (m_dwExStyle&DVS_EX_MOUSE_GESTURE)
			m_dwExStyle	&= ~DVS_EX_MOUSE_GESTURE;
		else
			m_dwExStyle	|= DVS_EX_MOUSE_GESTURE;
	}

	void OnMessageFilter(WORD /*wNotifyCode*/, WORD	/*wID*/, HWND /*hWndCtl*/)
	{
		if (m_dwExStyle&DVS_EX_MESSAGE_FILTER)
			m_dwExStyle	&= ~DVS_EX_MESSAGE_FILTER;
		else
			m_dwExStyle	|= DVS_EX_MESSAGE_FILTER;
	}

	void OnDocHostUIOpenNewWin(WORD	/*wNotifyCode*/, WORD /*wID*/, HWND	/*hWndCtl*/)
	{
		if (m_dwExStyle	& DVS_EX_OPENNEWWIN)
			m_dwExStyle	&= ~DVS_EX_OPENNEWWIN;
		else
			m_dwExStyle	|= DVS_EX_OPENNEWWIN;
	}

	void OnAutoRefreshNone(WORD	/*wNotifyCode*/, WORD /*wID*/, HWND	/*hWndCtl*/)
	{
		m_dwAutoRefreshStyle = 0;
		_KillTimer();
	}
	void OnAutoRefresh15sec(WORD /*wNotifyCode*/, WORD /*wID*/,	HWND /*hWndCtl*/)
	{
		m_dwAutoRefreshStyle = 0;
		m_dwAutoRefreshStyle |=	DVS_AUTOREFRESH_15SEC;
		_KillTimer();
		_SetTimer();
	}
	void OnAutoRefresh30sec(WORD /*wNotifyCode*/, WORD /*wID*/,	HWND /*hWndCtl*/)
	{
		m_dwAutoRefreshStyle = 0;
		m_dwAutoRefreshStyle |=	DVS_AUTOREFRESH_30SEC;
		_KillTimer();
		_SetTimer();
	}
	void OnAutoRefresh1min(WORD	/*wNotifyCode*/, WORD /*wID*/, HWND	/*hWndCtl*/)
	{
		m_dwAutoRefreshStyle = 0;
		m_dwAutoRefreshStyle |=	DVS_AUTOREFRESH_1MIN;
		_KillTimer();
		_SetTimer();
	}
	void OnAutoRefresh2min(WORD	/*wNotifyCode*/, WORD /*wID*/, HWND	/*hWndCtl*/)
	{
		m_dwAutoRefreshStyle = 0;
		m_dwAutoRefreshStyle |=	DVS_AUTOREFRESH_2MIN;
		_KillTimer();
		_SetTimer();
	}

	void OnAutoRefresh5min(WORD	/*wNotifyCode*/, WORD /*wID*/, HWND	/*hWndCtl*/)
	{
		m_dwAutoRefreshStyle = 0;
		m_dwAutoRefreshStyle |=	DVS_AUTOREFRESH_5MIN;
		_KillTimer();
		_SetTimer();
	}

	// UDT DGSTR ( dai
	void OnAutoRefreshUser(WORD	/*wNotifyCode*/, WORD /*wID*/, HWND	/*hWndCtl*/)
	{
		m_dwAutoRefreshStyle = 0;
		m_dwAutoRefreshStyle |=	DVS_AUTOREFRESH_USER;
		_KillTimer();
		_SetTimer();
	}
	// ENDE

	//+++ void OnTimer(UINT	wTimerID, TIMERPROC)
	void OnTimer(UINT wTimerID,	TIMERPROC* dmy=0)
	{
		ATLTRACE2(atlTraceUser,	4, _T("CChildFrame::OnTimer\n"));
		if (wTimerID ==	m_nIDEvent)
			::PostMessage(__m_pDonutView->GetParent(), WM_COMMAND, (WPARAM)ID_VIEW_REFRESH,	0);
//			__m_pDonutView->m_spBrowser->Refresh();
		else
			SetMsgHandled(FALSE);
	}

	int	_GetElapse()
	{
		if (m_dwAutoRefreshStyle ==	0)
			return -1;
		else if	(m_dwAutoRefreshStyle &	DVS_AUTOREFRESH_15SEC)
			return 15*1000;
		else if	(m_dwAutoRefreshStyle &	DVS_AUTOREFRESH_30SEC)
			return 30*1000;
		else if	(m_dwAutoRefreshStyle &	DVS_AUTOREFRESH_1MIN)
			return 1*60*1000;
		else if	(m_dwAutoRefreshStyle &	DVS_AUTOREFRESH_2MIN)
			return 2*60*1000;
		else if	(m_dwAutoRefreshStyle &	DVS_AUTOREFRESH_5MIN)
			return 5*60*1000;
		// UDT DGSTR ( dai
		else if	(m_dwAutoRefreshStyle &	DVS_AUTOREFRESH_USER)
			return CMainOption::s_dwAutoRefreshTime*1000;
		// ENDE

		return -1;
	}

	void _KillTimer()
	{
		if (m_nIDEvent != 0) {
			MTLVERIFY(::KillTimer(__m_pDonutView->m_hWnd, m_nIDEvent));
			m_nIDEvent = 0;
		}
	}

	void _SetTimer()
	{
		int	nElapse	= _GetElapse();
		if (nElapse	!= -1)
			m_nIDEvent = ::SetTimer(__m_pDonutView->m_hWnd,	1, _GetElapse(), NULL);
	}

	void WriteProfile(const	CString& strFileName, int nIndex)
	{
		CIniSection	pr;

		CString	strSectionName = _T("Window");
		strSectionName.Append(nIndex);
		pr.Open(strFileName, strSectionName);

		pr.SetValue(__m_pDonutView->GetLocationURL(), _T("Location_URL"));
		pr.SetValue(__m_pDonutView->GetDLControlFlags(), _T("DL_Control_Flags"));
		pr.SetValue(m_dwAutoRefreshStyle, _T("Auto_Refresh_Style"));
		MtlWriteProfileChildFrameState(pr, __m_pDonutView->GetParent(),	_T("child."));

		// save	extended style
		pr.SetValue(m_dwExStyle, _T("Extended_Style"));

		pr.Close();
	}

	void GetProfile(const CString& strFileName,	int	nIndex,	bool bGetChildFrameState)
	{
		CIniSection	pr;

		CString	strSectionName = _T("Window");
		strSectionName.Append(nIndex);
		pr.Open(strFileName, strSectionName);

		DWORD dwDLControlFlags = DLCTL_DEFAULT;
		if (pr.QueryValue(dwDLControlFlags,	_T("DL_Control_Flags"))	== ERROR_SUCCESS)
			__m_pDonutView->PutDLControlFlags(dwDLControlFlags);

		TCHAR sz[INTERNET_MAX_PATH_LENGTH];
		DWORD dwBytes =	INTERNET_MAX_PATH_LENGTH;
		if (pr.QueryValue(sz, _T("Location_URL"), &dwBytes)	== ERROR_SUCCESS) {
			// avoid endless loop
			CString	strURL(sz);
			bool bMaybeEndless = (strURL ==	_T("javascript:location.reload()"));
			if (!bMaybeEndless)
				__m_pDonutView->Navigate2(sz);
		}

		pr.QueryValue(m_dwAutoRefreshStyle,	_T("Auto_Refresh_Style"));
		_SetTimer();

		if (bGetChildFrameState)
			MtlGetProfileChildFrameState(pr, __m_pDonutView->GetParent(), SW_SHOWNORMAL, true, _T("child."));

		// load	extended style
		pr.QueryValue(m_dwExStyle, _T("Extended_Style"));//	never give up yeah.

		if (_check_flag(DVS_EX_OPENNEWWIN, m_dwExStyle)) {
			MtlSendOnCommand(__m_pDonutView->GetParent(), ID_DOCHOSTUI_OPENNEWWIN);
		}

		pr.Close();
	}

// Update command UI and handlers
	BEGIN_UPDATE_COMMAND_UI_MAP(CDonutViewOption)
		UPDATE_COMMAND_UI(ID_AUTOREFRESH_USER, OnUpdateAutoRefreshUser)	// UDT DGSTR ( dai
		UPDATE_COMMAND_UI_SETCHECK_IF_PASS(ID_AUTOREFRESH_NONE,	m_dwAutoRefreshStyle ==	0)
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_AUTOREFRESH_15SEC, DVS_AUTOREFRESH_15SEC, m_dwAutoRefreshStyle)
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_AUTOREFRESH_30SEC, DVS_AUTOREFRESH_30SEC, m_dwAutoRefreshStyle)
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_AUTOREFRESH_1MIN, DVS_AUTOREFRESH_1MIN, m_dwAutoRefreshStyle)
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_AUTOREFRESH_2MIN, DVS_AUTOREFRESH_2MIN, m_dwAutoRefreshStyle)
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_AUTOREFRESH_5MIN, DVS_AUTOREFRESH_5MIN, m_dwAutoRefreshStyle)
		UPDATE_COMMAND_UI_ENABLE_SETCHECK_FLAG(ID_DOCHOSTUI_OPENNEWWIN,	DVS_EX_OPENNEWWIN, m_dwExStyle)

		// UH
		UPDATE_COMMAND_UI_SETCHECK_IF_PASS(ID_AUTO_REFRESH,	m_dwAutoRefreshStyle!=0)
		UPDATE_COMMAND_UI_ENABLE_SETCHECK_FLAG(ID_MESSAGE_FILTER, DVS_EX_MESSAGE_FILTER, m_dwExStyle)
		UPDATE_COMMAND_UI_ENABLE_SETCHECK_FLAG(ID_MOUSE_GESTURE, DVS_EX_MOUSE_GESTURE, m_dwExStyle)
		UPDATE_COMMAND_UI_ENABLE_SETCHECK_FLAG(ID_BLOCK_MAILTO,	DVS_EX_BLOCK_MAILTO, m_dwExStyle)
	END_UPDATE_COMMAND_UI_MAP()

	// UDT DGSTR ( dai
	void OnUpdateAutoRefreshUser(CCmdUI* pCmdUI)
	{
		DWORD dwRefreshTime	= CMainOption::s_dwAutoRefreshTime;
		pCmdUI->Enable(!dwRefreshTime == 0 );
		pCmdUI->SetCheck(m_dwAutoRefreshStyle == DVS_AUTOREFRESH_USER ?	1 :	0);
		CString	str;
		// NOTE: INUYA
		// if using	StrFromTimeInterval	, Load Shlwapi.dll...
		// dwRefreshTime is	limited	to 3599.
		if (dwRefreshTime %60 == 0)		str.Format(_T("%d")	 , dwRefreshTime/60);
		else if	(dwRefreshTime >= 60)	str.Format(_T("%d%db"), dwRefreshTime/60,dwRefreshTime%60);
		else							str.Format(_T("%db")	 , dwRefreshTime%60);
		str	+= _T("([U[ݒ)");
		pCmdUI->SetText(str);
	}
	// ENDE
};

#define	FILENEW_BLANK	0x00000001L
#define	FILENEW_COPY	0x00000002L
#define	FILENEW_HOME	0x00000004L

class CFileNewOption
{
public:
	static DWORD s_dwFlags;

	static void	GetProfile()
	{
		CIniSection	pr;

		pr.Open(_szIniFileName,	_T("Main"));
		pr.QueryValue(s_dwFlags, _T("File_New_Option"));
		pr.Close();
	}

	static void	WriteProfile()
	{
		CIniSection	pr;

		pr.Open(_szIniFileName,	_T("Main"));
		pr.SetValue(s_dwFlags, _T("File_New_Option"));
		pr.Close();
	}
};

__declspec(selectany) DWORD	CFileNewOption::s_dwFlags =	FILENEW_BLANK;

class CFileNewPropertyPage : public	CPropertyPageImpl<CFileNewPropertyPage>,
	public CWinDataExchange<CFileNewPropertyPage>
{
public:
// Constants
	enum { IDD = IDD_PROPPAGE_FILENEW };

// Data	members
	int	m_nRadio;

// DDX map
	BEGIN_DDX_MAP(CFileNewPropertyPage)
		DDX_RADIO(IDC_RADIO_BLANK, m_nRadio)
//		DDX_RADIO(IDC_RADIO_COPY, m_bCopy)
//		DDX_RADIO(IDC_RADIO_HOME, m_bHome)
	END_DDX_MAP()

// Constructor
	CFileNewPropertyPage()
	{
		_SetData();
	}

// Overrides
	BOOL OnSetActive()
	{
		SetModified(TRUE);
		return DoDataExchange(FALSE);
	}
	BOOL OnKillActive()
	{
		return DoDataExchange(TRUE);
	}
	BOOL OnApply()
	{
		if (DoDataExchange(TRUE)) {
			_GetData();
			return TRUE;
		}
		else
			return FALSE;
	}

// Message map and handlers
	BEGIN_MSG_MAP(CFileNewPropertyPage)
		CHAIN_MSG_MAP(CPropertyPageImpl<CFileNewPropertyPage>)
	END_MSG_MAP()

// Implementation
protected:
	void _GetData()
	{
		// update dl control flags
		CFileNewOption::s_dwFlags =	0;

		switch (m_nRadio) {
		case 0:
			CFileNewOption::s_dwFlags =	FILENEW_BLANK;
			break;
		case 1:
			CFileNewOption::s_dwFlags =	FILENEW_COPY;
			break;
		case 2:
			CFileNewOption::s_dwFlags =	FILENEW_HOME;
			break;
		default:
			ATLASSERT(FALSE);
			break;
		}
	}

	void _SetData()
	{
		if (CFileNewOption::s_dwFlags == FILENEW_BLANK)
			m_nRadio = 0;
		else if	(CFileNewOption::s_dwFlags == FILENEW_COPY)
			m_nRadio = 1;
		else if	(CFileNewOption::s_dwFlags == FILENEW_HOME)
			m_nRadio = 2;
		else
			ATLASSERT(FALSE);
//		m_nRadio = CFileNewOption::s_dwFlags & FILENEW_BLANK ? TRUE	: FALSE;
//		m_bCopy	= CFileNewOption::s_dwFlags	& FILENEW_COPY ? TRUE :	FALSE;
//		m_bHome	= CFileNewOption::s_dwFlags	& FILENEW_HOME ? TRUE :	FALSE;
	}
};


#define	STARTUP_NOINITWIN	0x00000000L
#define	STARTUP_GOHOME		0x00000001L
#define	STARTUP_LATEST		0x00000002L
#define	STARTUP_DFG	0x00000004L

#define	STARTUP_ACTIVATE 0x00000001L //	UDT	DGSTR (	dai
#define	STARTUP_WITH_PARAM	0x00000001L	// UDT DGSTR ( dai

class CStartUpOption
{
public:
	static DWORD s_dwFlags;
	static TCHAR s_szDfgPath[MAX_PATH];
	static DWORD s_dwActivate; // UDT DGSTR	( dai
	static DWORD s_dwParam;	// UDT DGSTR ( dai

	static void	GetProfile()
	{
		CIniSection	pr;

		pr.Open(_szIniFileName,	_T("StartUp"));
		pr.QueryValue(s_dwFlags, _T("StartUp_Flags"));
		pr.QueryValue(s_dwParam, _T("StartUp_With_Param"));	// UDT DGSTR ( dai
		pr.QueryValue(s_dwActivate,	_T("StartUp_Activate")); //	UDT	DGSTR (	dai
		DWORD dwCount =	MAX_PATH;
		if (pr.QueryValue(s_szDfgPath, _T("Favorite_Group"), &dwCount) != ERROR_SUCCESS)
			::lstrcpy(s_szDfgPath, _T(""));
		pr.Close();
	}

	static void	WriteProfile()
	{
		CIniSection	pr;

		pr.Open(_szIniFileName,	_T("StartUp"));
		pr.SetValue(s_dwFlags, _T("StartUp_Flags"));
		pr.SetValue(s_szDfgPath, _T("Favorite_Group"));
		pr.SetValue(s_dwParam, _T("StartUp_With_Param")); // UDT DGSTR ( dai
		pr.SetValue(s_dwActivate, _T("StartUp_Activate")); // UDT DGSTR	( dai
		pr.Close();
	}

	template <class	_MainFrame>
	static void	StartUp(_MainFrame&	__frame)
	{
		HWND hWndChild = NULL;
		switch (s_dwFlags) {
		case STARTUP_NOINITWIN:
			break;
		case STARTUP_GOHOME:
			hWndChild =	__frame.OnUserOpenFile(NULL, 0);
			if (hWndChild) {
				CWebBrowser2 browser = DonutGetIWebBrowser2(hWndChild);
				if (browser.m_spBrowser	!= NULL)
					browser.GoHome();
			}

			break;
		case STARTUP_LATEST:
			__frame.OnUserOpenFile(GetDefaultDFGFilePath(),	0);
			break;
		case STARTUP_DFG: {
			CString	strPath(s_szDfgPath);
			if (!strPath.IsEmpty())
				__frame.OnUserOpenFile(s_szDfgPath,	0);
						  }
			break;
		default:
			ATLASSERT(FALSE);
			break;
		}
	}

	static CString GetDefaultDFGFilePath()
	{
		TCHAR sz[MAX_PATH];
		::GetModuleFileName(_Module.GetModuleInstance(), sz, MAX_PATH);
		CString	strPath(sz);

		int	nIndex = strPath.ReverseFind(_T('\\'));
		strPath	= strPath.Left(nIndex);
		strPath	+= _T("\\Default.dfg");

		return strPath;
	}
};

__declspec(selectany) DWORD	CStartUpOption::s_dwFlags =	STARTUP_NOINITWIN;
__declspec(selectany) DWORD	CStartUpOption::s_dwParam =	STARTUP_WITH_PARAM;	// UDT DGSTR ( dai
__declspec(selectany) DWORD	CStartUpOption::s_dwActivate = STARTUP_ACTIVATE; //	UDT	DGSTR (	dai
///*__declspec(selectany)*/	TCHAR CStartUpOption::s_szDfgPath[MAX_PATH];

class CStartUpPropertyPage : public	CPropertyPageImpl<CStartUpPropertyPage>,
	public CWinDataExchange<CStartUpPropertyPage>
{
public:
// Constants
	enum { IDD = IDD_PROPPAGE_STARTUP };

// Data	members
	int	m_nRadio;
	CString	m_strDfg;
	CEdit m_edit;
	int	m_nCheckActivate; // UDT DGSTR ( dai
	int	m_nCheckParam; // UDT DGSTR	( dai

// DDX map
	BEGIN_DDX_MAP(CStartUpPropertyPage)
		DDX_RADIO(IDC_RADIO_NOINITWIN, m_nRadio)
		DDX_CHECK(IDC_CHECK_STARTUP_WITH_PARAM,	m_nCheckParam) // UDT DGSTR	( dai
		DDX_CHECK(IDC_CHECK_STARTUP_ACTIVATE, m_nCheckActivate)	// UDT DGSTR ( dai
		DDX_TEXT_LEN(IDC_EDIT_DFG, m_strDfg, MAX_PATH)
	END_DDX_MAP()

// Constructor
	CStartUpPropertyPage()
	{
		_SetData();
	}

// Overrides
	BOOL OnSetActive()
	{
		SetModified(TRUE);

		if (m_edit.m_hWnd == NULL)
			m_edit.Attach(GetDlgItem(IDC_EDIT_DFG));

		return DoDataExchange(FALSE);
	}
	BOOL OnKillActive()
	{
		return DoDataExchange(TRUE);
	}
	BOOL OnApply()
	{
		if (DoDataExchange(TRUE)) {
			_GetData();
			return TRUE;
		}
		else
			return FALSE;
	}

// Message map and handlers
	BEGIN_MSG_MAP(CStartUpPropertyPage)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_EXPDFG, OnButton)
		CHAIN_MSG_MAP(CPropertyPageImpl<CStartUpPropertyPage>)
	END_MSG_MAP()

	void OnButton(WORD /*wNotifyCode*/,	WORD /*wID*/, HWND /*hWndCtl*/)
	{
		TCHAR szOldPath[MAX_PATH];// save current directory
		::GetCurrentDirectory(MAX_PATH,	szOldPath);

		::SetCurrentDirectory(DonutGetFavoriteGroupFolder());

		static const TCHAR szFilter[] =	_T("Donut Favorite Groupt@C(*.dfg)\0*.dfg\0\0");

		CFileDialog	fileDlg(TRUE, NULL,	NULL, OFN_HIDEREADONLY,	szFilter);
		fileDlg.m_ofn.lpstrTitle = _T("X^[gAbvCɓO[v");
		if (fileDlg.DoModal() == IDOK) {
			m_edit.SetWindowText(fileDlg.m_szFileName);
		}

		// restore current directory
		::SetCurrentDirectory(szOldPath);
	}

// Implementation
protected:
	void _GetData()
	{
		CStartUpOption::s_dwParam =	(m_nCheckParam)	?  0 : 1;  // UDT DGSTR	( dai
		CStartUpOption::s_dwActivate = (m_nCheckActivate) ?	 1 : 0;	 //	UDT	DGSTR (	dai

		// update dl control flags
		CStartUpOption::s_dwFlags =	0;

		switch (m_nRadio) {
		case 0:
			CStartUpOption::s_dwFlags =	STARTUP_NOINITWIN;
			break;
		case 1:
			CStartUpOption::s_dwFlags =	STARTUP_GOHOME;
			break;
		case 2:
			CStartUpOption::s_dwFlags =	STARTUP_LATEST;
			break;
		case 3:
			CStartUpOption::s_dwFlags =	STARTUP_DFG;
			break;
		default:
			ATLASSERT(FALSE);
			break;
		}

		m_edit.GetWindowText(CStartUpOption::s_szDfgPath, MAX_PATH);
	}

	void _SetData()
	{
		m_nCheckParam =	CStartUpOption::s_dwParam == STARTUP_WITH_PARAM	? 0	: 1; //	UDT	DGSTR (	dai
		m_nCheckActivate = CStartUpOption::s_dwActivate	== STARTUP_ACTIVATE	? 1	: 0; //	UDT	DGSTR (	dai

		if (CStartUpOption::s_dwFlags == STARTUP_NOINITWIN)
			m_nRadio = 0;
		else if	(CStartUpOption::s_dwFlags == STARTUP_GOHOME)
			m_nRadio = 1;
		else if	(CStartUpOption::s_dwFlags == STARTUP_LATEST)
			m_nRadio = 2;
		else if	(CStartUpOption::s_dwFlags == STARTUP_DFG)
			m_nRadio = 3;
		else
			ATLASSERT(FALSE);

		m_strDfg = CStartUpOption::s_szDfgPath;
	}
};


class COpenURLDlg :	public CDialogImpl<COpenURLDlg>,
	public CWinDataExchange<COpenURLDlg>
{
public:
// Declarations
	enum { IDD = IDD_DIALOG_OPENURL	};

// Data	members
	CString	m_strEdit;
	CEdit m_edit;

// Constructor
	COpenURLDlg()
	{
	}

// DDX map
	BEGIN_DDX_MAP(COpenURLDlg)
		DDX_TEXT_LEN(IDC_EDIT_URL, m_strEdit, INTERNET_MAX_PATH_LENGTH)
	END_DDX_MAP()

// Message map and handlers
	BEGIN_MSG_MAP(COpenURLDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(IDOK, OnCloseCmd)
		COMMAND_ID_HANDLER(IDCANCEL, OnCloseCmd)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_REF, OnRefCmd)
	END_MSG_MAP()

	LRESULT	OnInitDialog(UINT /*uMsg*/,	WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL&	/*bHandled*/)
	{
		CenterWindow(GetParent());
		DoDataExchange(FALSE);

		m_edit.Attach(GetDlgItem(IDC_EDIT_URL));
		return 0;
	}

	LRESULT	OnCloseCmd(WORD	/*wNotifyCode*/, WORD wID, HWND	/*hWndCtl*/, BOOL& /*bHandled*/)
	{
		DoDataExchange(TRUE);
		EndDialog(wID);
		return 0;
	}

	void OnRefCmd(UINT /*wNotifyCode*/,	int	/*wID*/, HWND /*hWndCtl*/)
	{
		const TCHAR	szFilter[] = _T("HTMLt@C(*.htm;*.html)\0*.htm;*.html\0")
			_T("Donut Favorite Groupt@C(*.dfg)\0*.dfg\0")
			_T("eLXgt@C(*.txt)\0*.txt\0")
			_T("GIFt@C(*.gif)\0*.gif\0")
			_T("JPEGt@C(*.jpg;*.jpeg)\0*.jpg;*.jpeg\0")
			_T("AUt@C(*.au)\0*.au\0")
			_T("AIFFt@C(*.aif;*.aiff)\0*.aif;*.aiff\0")
			_T("XBMt@C(*.xbm)\0*.xbm\0")
			_T("ׂẴt@C(*.*)\0*.*\0\0");

		CFileDialog	fileDlg(TRUE, NULL,	NULL, OFN_HIDEREADONLY,	szFilter);
		fileDlg.m_ofn.lpstrTitle = _T("J");
		if (fileDlg.DoModal() == IDOK) {
			m_edit.SetWindowText(fileDlg.m_szFileName);
		}
	}
};

