#include "FlatComboBox.h"
#include "AccelManager.h"

#include "ChevronHandler.h"
#include "DonutPFunc.h"
#include "DonutToolBar.h"

extern UINT	_uDropDownCommandID[];
extern UINT	_uDropDownWholeCommandID[];
extern int _uDropDownCommandCount;
extern int _uDropDownWholeCommandCount;

class CCommandSelectDialog :
	public CDialogImpl<CCommandSelectDialog	>,
	public CWinDataExchange<CCommandSelectDialog >
{
public:
	enum { IDD = IDD_DIALOG_CMD_SELECT };

// Data	members
	HMENU m_hMenu;
	CComboBox m_cmbCategory;
	CComboBox m_cmbCommand;
	DWORD m_dwCommandID;

	CCommandSelectDialog(HMENU hMenu)
	{
		m_hMenu	= hMenu;
	}

// DDX map
	BEGIN_DDX_MAP(CCommandSelectDialog)
	END_DDX_MAP()

	DWORD GetCommandID(){return	m_dwCommandID;};

// Message map and handlers
	BEGIN_MSG_MAP(CCommandSelectDialog)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)

		COMMAND_HANDLER_EX(IDC_CMB_CATEGORY, CBN_SELCHANGE,	OnSelChangeCate)
		COMMAND_HANDLER_EX(IDC_CMB_COMMAND,	CBN_SELCHANGE, OnSelChangeCmd)

		COMMAND_ID_HANDLER(IDOK, OnCloseCmd)
		COMMAND_ID_HANDLER(IDCANCEL, OnCloseCmd)
	END_MSG_MAP()

	LRESULT	OnInitDialog(UINT /*uMsg*/,	WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL&	/*bHandled*/)
	{
		CenterWindow(GetParent());
		DoDataExchange(FALSE);

		m_cmbCategory.Attach(GetDlgItem(IDC_CMB_CATEGORY));
		m_cmbCommand.Attach(GetDlgItem(IDC_CMB_COMMAND));

		if (_SetCombboxCategory(m_cmbCategory, m_hMenu)==FALSE)
			return FALSE;

		// 鎖
		m_cmbCommand.SetDroppedWidth(250);
		OnSelChangeCate(0,0,0);
		return TRUE;
	}

	LRESULT	OnCloseCmd(WORD	/*wNotifyCode*/, WORD wID, HWND	/*hWndCtl*/, BOOL& /*bHandled*/)
	{
		EndDialog(wID);
		return 0;
	}

	void OnSelChangeCate(UINT code,	int	id,	HWND hWnd)
	{
		int	nIndex = m_cmbCategory.GetCurSel();

		// R}hI
		_PickUpCommand(m_hMenu,	nIndex,	m_cmbCommand);

		m_dwCommandID =	0;
		SetGuideMsg();
	}

	// R}hύX
	void OnSelChangeCmd(UINT code, int id, HWND	hWnd)
	{
		int	nIndex = m_cmbCommand.GetCurSel();
		if (nIndex==-1)	return;

		m_dwCommandID =	m_cmbCommand.GetItemData(nIndex);
		SetGuideMsg();
	}

	void SetGuideMsg()
	{
		CString	strGuide;
		if (m_dwCommandID!=0)
			strGuide.LoadString(m_dwCommandID);
		else
			strGuide = _T("R}hI肵܂B");


		int	nFindIt	= strGuide.Find(_T('\t'));
		if (nFindIt!=-1)
			strGuide = strGuide.Mid(nFindIt+1);

		nFindIt	= strGuide.Find(_T('\n'));
		if (nFindIt!=-1)
			strGuide = strGuide.Left(nFindIt);

		::SetWindowText(::GetDlgItem(m_hWnd, IDC_STC01), strGuide);
	}
};

class CProxyPropertyPage : public CPropertyPageImpl<CProxyPropertyPage>,
	public CWinDataExchange<CProxyPropertyPage>
{
public:
// Constants
	enum { IDD = IDD_PROPPAGE_PROXY};

// Data	members
	CEdit m_editPrx;
	CEdit m_editNoPrx;
	int	m_nRandChk,	m_nRandTimeMin,	m_nRandTimeSec;	// U.H
	int	m_nLocalChk, m_nUseIE;


// DDX map
	BEGIN_DDX_MAP(CProxyPropertyPage)
		// UDT DGSTR ( U.H
		DDX_CHECK(IDC_RAND_CHK,	m_nRandChk)
		DDX_INT_RANGE(IDC_EDIT_RAND_MIN, m_nRandTimeMin, 0,	59)
		DDX_INT_RANGE(IDC_EDIT_RAND_SEC, m_nRandTimeSec, 0,	59)
		DDX_CHECK(IDC_LOCAL_CHK, m_nLocalChk)
		DDX_CHECK(IDC_IE_CHK, m_nUseIE)
		// ENDE
	END_DDX_MAP()

// Constructor
	CProxyPropertyPage()
	{
		m_nRandTimeMin = 5;
		m_nRandTimeSec = 0;
		m_nRandChk = 0;
		m_nLocalChk	= 0;
		m_nUseIE = 1;
	}

// Overrides
	BOOL OnSetActive()
	{
		SetModified(TRUE);

		if (m_editPrx.m_hWnd ==	NULL)
		{
			m_editPrx.Attach(GetDlgItem(IDC_EDIT1));
		}

		if (m_editNoPrx.m_hWnd == NULL)
		{
			m_editNoPrx.Attach(GetDlgItem(IDC_EDIT2));
		}

		if (m_editPrx.m_hWnd &&	m_editNoPrx.m_hWnd)
			_SetData();

		return DoDataExchange(FALSE);
	}
	BOOL OnKillActive()
	{
		return DoDataExchange(TRUE);
	}
	BOOL OnApply()
	{
		if (DoDataExchange(TRUE)) {
			_GetData();
			return TRUE;
		}
		else
			return FALSE;
	}
// Message map and handlers
	BEGIN_MSG_MAP(CProxyPropertyPage)
		CHAIN_MSG_MAP(CPropertyPageImpl<CProxyPropertyPage>)
	END_MSG_MAP()


// Implementation
protected:
	void _GetData()
	{
		CString	strFile;
		strFile	= _GetFilePath(_T("Proxy.ini"));
		CIniSection	pr;

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// vLV
		pr.Open(strFile, _T("PROXY"));
		int	nLineCnt = m_editPrx.GetLineCount();
		pr.SetValue((DWORD)nLineCnt, _T("MAX"));
		for	(int ii=0; ii<nLineCnt;	ii++)
		{
			CString	strKey;
			strKey.Format(_T("%d"),	ii);

			TCHAR/*+++ char*/ cBuff[MAX_PATH];
			memset(cBuff, 0, MAX_PATH);
			int	nTextSize =	m_editPrx.GetLine(ii, cBuff, MAX_PATH);
			cBuff[nTextSize] = _T('\0');

			CString	strBuff(cBuff);
			pr.SetValue(strBuff, strKey);
		}
		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// _
		pr.Open(strFile, _T("RAND"));
		pr.SetValue((DWORD)m_nRandChk, _T("Enabel"));
		pr.SetValue((DWORD)m_nRandTimeMin, _T("Min"));
		pr.SetValue((DWORD)m_nRandTimeSec, _T("Sec"));
		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// vLV
		pr.Open(strFile, _T("NOPROXY"));
		nLineCnt = m_editNoPrx.GetLineCount();
		pr.SetValue((DWORD)nLineCnt, _T("MAX"));
		for	(/*+++*/int	ii2=0; ii2<nLineCnt; ii2++)
		{
			CString	strKey;
			strKey.Format(_T("%d"),	ii2);

			TCHAR/*+++ char*/ cBuff[MAX_PATH];
			memset(cBuff, 0, MAX_PATH);
			int	nTextSize =	m_editNoPrx.GetLine(ii2, cBuff, MAX_PATH);
			cBuff[nTextSize] = _T('\0');

			CString	strBuff(cBuff);
			strBuff	+= _T("\n");
			pr.SetValue(strBuff, strKey);
		}
		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// [J
		pr.Open(strFile, _T("LOCAL"));
		pr.SetValue((DWORD)m_nLocalChk,	_T("Enabel"));
		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// hd
		pr.Open(strFile, _T("USE_IE"));
		pr.SetValue((DWORD)m_nUseIE, _T("Enabel"));
		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	}

	void _SetData()
	{
		CString	strFile;
		strFile	= _GetFilePath(_T("Proxy.ini"));
		CIniSection	pr;

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// vLV
		pr.Open(strFile, _T("PROXY"));
		DWORD dwLineCnt	= 0;
		pr.QueryValue(dwLineCnt, _T("MAX"));
		m_editPrx.SetSelAll();
		for	(int ii=0; ii<dwLineCnt; ii++)
		{
			CString	strKey;
			strKey.Format(_T("%d"),	ii);

			TCHAR cBuff[MAX_PATH];
			DWORD dwCount=MAX_PATH;
			pr.QueryValue(cBuff, strKey, &dwCount);

			CString	strProxy(cBuff);
			if (strProxy.IsEmpty())	continue;

			m_editPrx.ReplaceSel(cBuff);
			m_editPrx.ReplaceSel(_T("\r\n"));
		}
		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// _
		pr.Open(strFile, _T("RAND"));

		DWORD dwRandChk=0;
		pr.QueryValue(dwRandChk, _T("Enabel"));
		m_nRandChk = dwRandChk;

		DWORD dwRandTimeMin	= 5;
		pr.QueryValue(dwRandTimeMin, _T("Min"));
		m_nRandTimeMin = dwRandTimeMin;

		DWORD dwRandTimeSec	= 0;
		pr.QueryValue(dwRandTimeSec, _T("Sec"));
		m_nRandTimeSec = dwRandTimeSec;

		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// vLV
		pr.Open(strFile, _T("NOPROXY"));
		dwLineCnt =	0;
		pr.QueryValue(dwLineCnt, _T("MAX"));
		m_editNoPrx.SetSelAll();
		for	(/*+++*/DWORD ii2=0; ii2<dwLineCnt; ii2++)
		{
			CString	strKey;
			strKey.Format(_T("%d"),	ii2);

			TCHAR cBuff[MAX_PATH];
			DWORD dwCount=MAX_PATH;
			pr.QueryValue(cBuff, strKey, &dwCount);

			CString	strProxy(cBuff);
			if (strProxy.IsEmpty())	continue;

			m_editNoPrx.ReplaceSel(cBuff);
			m_editNoPrx.ReplaceSel(_T("\r\n"));
		}
		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// [J
		pr.Open(strFile, _T("LOCAL"));
		DWORD dwLocalChk=0;
		pr.QueryValue(dwLocalChk, _T("Enabel"));
		m_nLocalChk	= dwLocalChk;
		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// [J
		pr.Open(strFile, _T("USE_IE"));
		DWORD dwUseIE=1;
		pr.QueryValue(dwUseIE, _T("Enabel"));
		m_nUseIE = dwUseIE;
		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	}
};

class CKeyBoardPropertyPage	: public CPropertyPageImpl<CKeyBoardPropertyPage>,
	public CWinDataExchange<CKeyBoardPropertyPage>
{
public:
// Constants
	enum { IDD = IDD_PROPPAGE_KEYBOARD};

// Data	members
	CEdit		m_editNow;
	CEditAccel	m_editNew;
	CComboBox m_cmbCategory;
	CComboBox m_cmbCommand;
	CListViewCtrl m_ltAccel;

	HACCEL		m_hAccel;
	HMENU		m_hMenu;
	int			m_nCmdUpdate;
	int			m_nCmdMove;

// DDX map
	BEGIN_DDX_MAP(CKeyBoardPropertyPage)
		DDX_CHECK(IDC_CHK_CMDUPDATE, m_nCmdUpdate)
		DDX_CHECK(IDC_CHK_CMDMOVE, m_nCmdMove)
	END_DDX_MAP()


	CKeyBoardPropertyPage(HACCEL hAccel, HMENU hMenu)
	{
		m_hAccel = hAccel;
		m_hMenu	= hMenu;
		m_nCmdUpdate = 0;
		m_nCmdMove = 0;

		int	nAccelSize = ::CopyAcceleratorTable(m_hAccel, NULL,	0);
		ACCEL* lpAccel = new ACCEL [nAccelSize];
		::CopyAcceleratorTable(hAccel, lpAccel,	nAccelSize);
		m_hAccel = ::CreateAcceleratorTable(lpAccel, nAccelSize);
		delete lpAccel;
	}

	~CKeyBoardPropertyPage()
	{
		::DestroyAcceleratorTable (m_hAccel);
	}

// Overrides
	BOOL OnSetActive()
	{
		SetModified(TRUE);

		if (m_editNow.m_hWnd ==	NULL)
			m_editNow.Attach(GetDlgItem(IDC_EDIT_NOW_KEY));

		if (m_editNew.m_hWnd ==	NULL)
			m_editNew.Attach(GetDlgItem(IDC_EDIT_NEW_KEY));

		if (m_cmbCategory.m_hWnd ==	NULL)
			m_cmbCategory.Attach(GetDlgItem(IDC_CMB_CATEGORY));

		if (m_cmbCommand.m_hWnd	== NULL)
			m_cmbCommand.Attach(GetDlgItem(IDC_CMB_COMMAND));

		if (m_ltAccel.m_hWnd ==	NULL)
			m_ltAccel.Attach(GetDlgItem(IDC_LIST1));

		if (m_editNow.m_hWnd &&	m_editNew.m_hWnd &&	m_cmbCategory.m_hWnd &&	m_cmbCommand.m_hWnd)
			_SetData();

		return DoDataExchange(FALSE);
	}
	BOOL OnKillActive()
	{
		return DoDataExchange(TRUE);
	}
	BOOL OnApply()
	{
		if (DoDataExchange(TRUE)) {
			_GetData();
			return TRUE;
		}
		else
			return FALSE;
	}
// Constructor
	// f[^𓾂
	void _SetData()
	{
		// R{{bN̏
		InitialCombbox();
		// Xg{bNX̏
		InitialListbox();
	}

	// f[^ۑ
	void _GetData()
	{
		CAccelerManager	accelManager(m_hAccel);
		accelManager.SaveAccelaratorState();
	}


// Message map and handlers
	BEGIN_MSG_MAP(CKeyBoardPropertyPage)
		COMMAND_HANDLER_EX(IDC_CMB_CATEGORY, CBN_SELCHANGE,	OnSelChangeCate)
		COMMAND_HANDLER_EX(IDC_CMB_COMMAND,	CBN_SELCHANGE, OnSelChangeCmd)

		COMMAND_ID_HANDLER_EX(IDC_BTN_DEL, OnBtnDel)
		COMMAND_ID_HANDLER_EX(IDC_BTN_SET, OnBtnSel)
		COMMAND_ID_HANDLER(IDC_CHK_CMDUPDATE, OnChkBtn)
		COMMAND_ID_HANDLER(IDC_CHK_CMDMOVE,	OnChkBtn)

		CHAIN_MSG_MAP(CPropertyPageImpl<CKeyBoardPropertyPage>)
	END_MSG_MAP()

	LRESULT	OnChkBtn(WORD /*wNotifyCode*/, WORD	wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		DoDataExchange(TRUE);

		// ݒ{^Enable
		EnableSetBtn();
		return 0;
	}

	void OnBtnDel(UINT /*wNotifyCode*/,	int	/*wID*/, HWND /*hWndCtl*/)
	{
		CString	strAccel;
		TCHAR szAccel[MAX_PATH];

		if (m_editNow.GetWindowText(szAccel, MAX_PATH) == 0) return;
		int	nIndexCmd =	m_cmbCommand.GetCurSel();
		UINT nCmdID	= m_cmbCommand.GetItemData(nIndexCmd);

		CAccelerManager	accelManager(m_hAccel);
		m_hAccel = accelManager.DeleteAccelerator(nCmdID);

		// IɁAύXꂽɂ(;^_^A 
		OnSelChangeCmd(0, 0, NULL);

		SetAccelList();
	}

	void OnBtnSel(UINT /*wNotifyCode*/,	int	/*wID*/, HWND /*hWndCtl*/)
	{

		// CommandID
		int	nIndexCmd =	m_cmbCommand.GetCurSel();
		UINT nCmdID	= m_cmbCommand.GetItemData(nIndexCmd);

		// L[𓾂
		ACCEL accel;
		memcpy(&accel, m_editNew.GetAccel(), sizeof(ACCEL));
		accel.fVirt	|= FNOINVERT;
		accel.fVirt	|= FVIRTKEY;
		accel.cmd =	nCmdID;

		//
		CAccelerManager	accelManager(m_hAccel);

		TCHAR cBuff[MAX_PATH];
		CString	strAccelNow, strCmd;
		m_editNow.GetWindowText(cBuff, MAX_PATH);
		strAccelNow	= CString(cBuff);

		::GetWindowText(GetDlgItem(IDC_STC01), cBuff, MAX_PATH);
		strCmd = CString(cBuff);
		if (strAccelNow.IsEmpty())
		{
			// R}h
			if (!strCmd.IsEmpty())
			{
				UINT uOldCmd = accelManager.FindCommandID(&accel);
				m_hAccel = accelManager.DeleteAccelerator(uOldCmd);
			}

			m_hAccel = accelManager.AddAccelerator(&accel);
		}
		else
		{
			if (!strAccelNow.IsEmpty() && !strCmd.IsEmpty())
			{
				UINT uOldCmd = accelManager.FindCommandID(&accel);

				m_hAccel = accelManager.DeleteAccelerator(uOldCmd);
				m_hAccel = accelManager.DeleteAccelerator(nCmdID);
				m_hAccel = accelManager.AddAccelerator(&accel);
			}
			else
			{
				m_hAccel = accelManager.DeleteAccelerator(nCmdID);
				m_hAccel = accelManager.AddAccelerator(&accel);
			}
		}

		// IɁAύXꂽɂ(;^_^A 
		OnSelChangeCmd(0, 0, NULL);

		SetAccelList();
	}

	// R{{bN̏
	void InitialCombbox()
	{
		if (_SetCombboxCategory(m_cmbCategory, m_hMenu)==FALSE)
			return;

		// 鎖
		m_cmbCommand.SetDroppedWidth(250);
		OnSelChangeCate(0,0,0);
		::SetWindowText(GetDlgItem(IDC_STC01), _T(""));
	}

	void InitialListbox()
	{
		//+++ static ǉ
		static const TCHAR*	titles[] = { _T("R}h"), _T("V[gJbg") };
		static const int widths[] =	{ 150, 350};

		LVCOLUMN col;
		col.mask = LVCF_TEXT | LVCF_WIDTH;

		for	(int i = 0;	i <	_countof(titles); ++i) {
			col.pszText	= (LPTSTR)titles[i];
			col.cx = widths[i];
			m_ltAccel.InsertColumn(i, &col);
		}
		m_ltAccel.SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE,	0, LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);

		SetAccelList();
	}

	void SetAccelList()
	{
		m_ltAccel.DeleteAllItems();

		CAccelerManager	accelManager(m_hAccel);
		for	(int ii=0; ii<accelManager.GetCount(); ii++)
		{
			LPACCEL	lpAccel	= accelManager.GetAt(ii);

			CString	strShortCut;
			CKeyHelper helper(lpAccel);
			helper.Format(strShortCut);

			CString	strCmdName;
			CStdToolBarCtrlBase::_LoadToolTipText(lpAccel->cmd,	strCmdName);

			m_ltAccel.InsertItem(ii, strCmdName);
			m_ltAccel.SetItemText(ii, 1, strShortCut);
		}
	}

	// JeSύX
	void OnSelChangeCate(UINT code,	int	id,	HWND hWnd)
	{
		m_editNew.EnableWindow(FALSE);
		int	nIndex = m_cmbCategory.GetCurSel();

		// R}hI
		_PickUpCommand(m_hMenu,	nIndex,	m_cmbCommand);
	}

	// R}hύX
	void OnSelChangeCmd(UINT code, int id, HWND	hWnd)
	{
		int	nIndex = m_cmbCommand.GetCurSel();
		if (nIndex==-1)	return;

		// R}hID
		UINT nCmdID	= m_cmbCommand.GetItemData(nIndex);

		// ܂AL
		if (nCmdID==0)
			m_editNew.EnableWindow(FALSE);
		else
			m_editNew.EnableWindow(TRUE);

		// V[gJbgL[𓾂
		CString	strAccel;
		CAccelerManager	accelManager(m_hAccel);
		if (accelManager.FindAccelerator(nCmdID, strAccel))
		{
			m_editNow.SetWindowText(strAccel);
			::EnableWindow(GetDlgItem(IDC_BTN_DEL),	TRUE);
		}
		else
		{
			m_editNow.SetWindowText(_T(""));
			::EnableWindow(GetDlgItem(IDC_BTN_DEL),	FALSE);
		}

		m_editNew.SetWindowText(_T(""));
		::EnableWindow(GetDlgItem(IDC_BTN_SET),	FALSE);
		::SetWindowText(GetDlgItem(IDC_STC01), _T(""));
	}

	BOOL OnTranslateAccelerator(LPMSG lpMsg)
	{
		BOOL bSts =	m_editNew.OnTranslateAccelerator(lpMsg);

		if (bSts)
		{
			// L[𓾂
			ACCEL accel;
			memcpy(&accel, m_editNew.GetAccel(), sizeof(ACCEL));
			CAccelerManager	accelManager(m_hAccel);
			UINT nCmdID	= accelManager.FindCommandID(&accel);

			// New ANZXL[eLXg
			TCHAR/*+++char*/ cBuff[MAX_PATH];
			cBuff[0] = 0;	//+++.
			::GetWindowText(m_editNew.m_hWnd, cBuff, MAX_PATH);
			CString	strAccelNew(cBuff);

			// Now ANZXL[eLXg
			cBuff[0] = 0;	//+++.
			::GetWindowText(m_editNow.m_hWnd, cBuff, MAX_PATH);
			CString	strAccelNow(cBuff);

			// R}heLXg
			CString	strCmd;
			if (nCmdID!=0)
				CStdToolBarCtrlBase::_LoadToolTipText(nCmdID, strCmd);

			::SetWindowText(GetDlgItem(IDC_STC01), strCmd);

			// ݒ{^Enable
			EnableSetBtn();
		}
		return bSts;
	}

	// ݒ{^Enable
	void EnableSetBtn()
	{
		// New ANZXL[eLXg
		TCHAR/*+++ char*/ cBuff[MAX_PATH];
		cBuff[0] = 0;	//+++.
		::GetWindowText(m_editNew.m_hWnd, cBuff, MAX_PATH);
		CString	strAccelNew(cBuff);

		// Now ANZXL[eLXg
		cBuff[0] = 0;	//+++.
		::GetWindowText(m_editNow.m_hWnd, cBuff, MAX_PATH);
		CString	strAccelNow(cBuff);

		// R}heLXg
		::GetWindowText(GetDlgItem(IDC_STC01), cBuff, MAX_PATH);
		CString	strCmd(cBuff);

		BOOL bEnableSetBtn=TRUE;
		if (strAccelNew.IsEmpty()==FALSE)
		{
			// Now ANZXL[Ȃ
			if (strAccelNow.IsEmpty())
			{
				if (strCmd.IsEmpty()) bEnableSetBtn	= TRUE;
				else if	(m_nCmdMove==1)	bEnableSetBtn =	TRUE;
				else bEnableSetBtn = FALSE;
			}
			else
			{
				if (strCmd.IsEmpty())
				{
					if (m_nCmdUpdate==1)
						bEnableSetBtn =	TRUE;
					else
						bEnableSetBtn =	FALSE;
				}
				else
				{
					if (m_nCmdMove==1 && m_nCmdUpdate==1)
						bEnableSetBtn =	TRUE;
					else
						bEnableSetBtn =	FALSE;
				}
			}
		}
		else
			bEnableSetBtn=FALSE;

		::EnableWindow(GetDlgItem(IDC_BTN_SET),	bEnableSetBtn);
	}
};
extern UINT	_uDropDownCommandID[];
extern UINT	_uDropDownWholeCommandID[];

class CToolBarPropertyPage : public	CPropertyPageImpl<CToolBarPropertyPage>,
	public CWinDataExchange<CToolBarPropertyPage>
{
public:
// Constants
	enum { IDD = IDD_PROPPAGE_TOOLBAR};

// Data	members
	CComboBox		m_cmbCategory;
	CComboBox		m_cmbCommand;
	CListViewCtrl	m_ltIcon;
	CImageList		m_imageBig;
	HMENU			m_hMenu;
	CSimpleArray<STD_TBBUTTON> m_aryStdBtn;
	CSimpleArray<STD_TBBUTTON>*	m_pAryStdBtnBase;

// DDX map
	BEGIN_DDX_MAP(CToolBarPropertyPage)
	END_DDX_MAP()


	CToolBarPropertyPage(HMENU hMenu, CSimpleArray<STD_TBBUTTON>* pAryStdBtn)
	{
		m_hMenu	= hMenu;
		m_pAryStdBtnBase = pAryStdBtn;

		// Rs[(;^_^A 
		//m_arrStdBtn.Copy(*pAryStdBtn);
		for	(int ii=0; ii<pAryStdBtn->GetSize(); ii++)
			m_aryStdBtn.Add((*pAryStdBtn)[ii]);
	}

// Overrides
	BOOL OnSetActive()
	{
		SetModified(TRUE);

		if (m_cmbCategory.m_hWnd ==	NULL)
			m_cmbCategory.Attach(GetDlgItem(IDC_CMB_CATEGORY));

		if (m_cmbCommand.m_hWnd	== NULL)
			m_cmbCommand.Attach(GetDlgItem(IDC_CMB_COMMAND));

		if (m_ltIcon.m_hWnd	== NULL)
			m_ltIcon.Attach(GetDlgItem(IDC_LIST_ICON));

		_SetData();
		return DoDataExchange(FALSE);
	}
	BOOL OnKillActive()
	{
		return DoDataExchange(TRUE);
	}
	BOOL OnApply()
	{
		if (DoDataExchange(TRUE)) {
			_GetData();
			return TRUE;
		}
		else
			return FALSE;
	}

// Constructor
	// f[^𓾂
	void _SetData()
	{
		// R{{bN̏
		InitialCombbox();
		// Xgr[̏
		InitialListCtrl();
	}

	// f[^ۑ
	void _GetData()
	{
		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// pX
		CString	strFile;
		strFile	= CDonutToolBar::GetToolBarFilePath();

		CIniSection	pr;

		//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
		// c[o[
		pr.Open(strFile, _T("TOOLBAR"));

		DWORD dwToolbarCnt = m_aryStdBtn.GetSize();
		pr.SetValue(dwToolbarCnt, _T("TOOLBAR_CNT"));

		for	(int ii=0; ii<m_aryStdBtn.GetSize(); ii++)
		{
			CString	strKeyID, strKeyStyle;
			strKeyID.Format(_T("ID_%d"), ii);
			strKeyStyle.Format(_T("STYLE_%d"), ii);

			pr.SetValue((DWORD)m_aryStdBtn[ii].idCommand, strKeyID);
			pr.SetValue((DWORD)m_aryStdBtn[ii].fsStyle,	strKeyStyle);
		}
		pr.Close();
		//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

		m_pAryStdBtnBase->RemoveAll();
		for	(/*+++*/int	ii2=0; ii2<m_aryStdBtn.GetSize(); ii2++)
			m_pAryStdBtnBase->Add(m_aryStdBtn[ii2]);
	}


// Message map and handlers
	BEGIN_MSG_MAP(CToolBarPropertyPage)
		COMMAND_HANDLER_EX(IDC_CMB_CATEGORY, CBN_SELCHANGE,	OnSelChangeCate)
		COMMAND_HANDLER_EX(IDC_CMB_COMMAND,	CBN_SELCHANGE, OnSelChangeCmd)
		NOTIFY_HANDLER_EX(IDC_LIST_ICON, LVN_ITEMCHANGED, OnItemChgIcon)
		COMMAND_ID_HANDLER_EX(IDC_BTN01, OnBtnMove)
		COMMAND_ID_HANDLER_EX(IDC_BTN02, OnBtnMove)
		COMMAND_ID_HANDLER_EX(IDC_BTN03, OnBtnAdd)
		COMMAND_ID_HANDLER_EX(IDC_BTN04, OnBtnDel)
		COMMAND_ID_HANDLER_EX(IDC_BTN05, OnBtnIns)
		COMMAND_ID_HANDLER(IDC_CHKBTN_TXT, OnChkBtnText)
		CHAIN_MSG_MAP(CPropertyPageImpl<CToolBarPropertyPage>)
	END_MSG_MAP()

	// R{{bN̏
	void InitialCombbox()
	{
		if (_SetCombboxCategory(m_cmbCategory, m_hMenu)==FALSE)
			return;

		m_cmbCategory.AddString(_T("hbv_EEACR"));

		// zIɁAIύX
		OnSelChangeCate(0,0,0);
	}

	// JeSύX
	void OnSelChangeCate(UINT code,	int	id,	HWND hWnd)
	{
		int	nIndex = m_cmbCategory.GetCurSel();

		// R}hI
		if ((nIndex+1)!=m_cmbCategory.GetCount())
			_PickUpCommand(m_hMenu,	nIndex,	m_cmbCommand);
		else
			PickUpCommandEx();
	}

	// gR}h
	void PickUpCommandEx()
	{
		m_cmbCommand.ResetContent();

		for	(int ii=0; ii<_uDropDownCommandCount; ii++)
		{
			CString	strMenu;
			strMenu.LoadString(_uDropDownCommandID[ii]);
			if (strMenu.Find(_T("\n"))!=-1)
				strMenu	= strMenu.Left(strMenu.Find(_T("\n")));

			int	nIndex = m_cmbCommand.AddString(strMenu);
			m_cmbCommand.SetItemData(nIndex, _uDropDownCommandID[ii]);
		}
		for	(/*+++*/int	ii2=0; ii2<_uDropDownWholeCommandCount; ii2++)
		{
			CString	strMenu;
			strMenu.LoadString(_uDropDownWholeCommandID[ii2]);
			if (strMenu.Find(_T("\n"))!=-1)
				strMenu	= strMenu.Left(strMenu.Find(_T("\n")));

			int	nIndex = m_cmbCommand.AddString(strMenu);
			m_cmbCommand.SetItemData(nIndex, _uDropDownWholeCommandID[ii2]);
		}
	}

	CString	GetBigFilePath()
	{
		TCHAR cPathExe[MAX_PATH];
		::GetModuleFileName(_Module.GetModuleInstance(), cPathExe, MAX_PATH);

		TCHAR szPath[MAX_PATH];		memset(szPath, 0, MAX_PATH);
		DWORD dwCount =	MAX_PATH;

		CString	strFile;
		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("Path"));
		pr.QueryValue(szPath, _T("ToolbarPath"), &dwCount);
		strFile.Format(_T("%s"), szPath);
		if (strFile.IsEmpty())
		{
			strFile.Format(_T("%s"), cPathExe);

#ifdef _DEBUG
			strFile	= strFile.Left(strFile.ReverseFind(_T('\\')));
#endif
			strFile	= strFile.Left(strFile.ReverseFind('\\')+1)	+ _T("Toolbar\\BigHot.bmp");
		}
		else
			strFile	= strFile +	_T("\\BigHot.bmp");

		pr.Close();
		return strFile;
	}

	// Xgr[̏
	void InitialListCtrl()
	{
		if (m_ltIcon.m_hWnd==NULL) return;
		if (m_imageBig.m_hImageList!=NULL) return;

		CBitmap	bmp;
		bmp.Attach(AtlLoadBitmapImage(GetBigFilePath().GetBuffer(0), LR_LOADFROMFILE));

		CSize szBig;
		bmp.GetSize(szBig);
		int	nCount = szBig.cx/szBig.cy;
		szBig.cx = szBig.cy;
		MTLVERIFY( m_imageBig.Create(szBig.cx, szBig.cy, ILC_COLOR8	| ILC_MASK,	nCount,	1) );
		MTLVERIFY( m_imageBig.Add(bmp, RGB(255,	0, 255)) !=	-1 );

		m_ltIcon.SetImageList(m_imageBig, TVSIL_NORMAL);
		for	(int ii=0; ii<m_aryStdBtn.GetSize(); ii++)
		{
			UINT nID = m_aryStdBtn[ii].idCommand;

			CString	strCmd;
			CStdToolBarCtrlBase::_LoadToolTipText(nID, strCmd);

			m_ltIcon.InsertItem(ii,	strCmd,	ii);
		}

		::EnableWindow(GetDlgItem(IDC_BTN01), FALSE);
		::EnableWindow(GetDlgItem(IDC_BTN02), FALSE);
		::EnableWindow(GetDlgItem(IDC_BTN03), FALSE);
		::EnableWindow(GetDlgItem(IDC_BTN04), FALSE);
		::EnableWindow(GetDlgItem(IDC_BTN05), FALSE);
	}

	LRESULT	OnChkBtnText(WORD /*wNotifyCode*/, WORD	wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		DoDataExchange(TRUE);

		int	nIndexLt = m_ltIcon.GetSelectedIndex();
		if (nIndexLt==-1) return 0;

		int	nChk = ::SendMessage(GetDlgItem(IDC_CHKBTN_TXT), BM_GETCHECK, 0L, 0L);
		if (nChk ==	BST_CHECKED)
			m_aryStdBtn[nIndexLt].fsStyle |= BTNS_STD_LIST;
		else
			m_aryStdBtn[nIndexLt].fsStyle &= ~BTNS_STD_LIST;

		return 0;
	}

	LRESULT	OnItemChgIcon(LPNMHDR pnmh)
	{
		LPNMLISTVIEW pnmv =	(LPNMLISTVIEW)pnmh;
		if (pnmv->uNewState!=LBN_SELCANCEL)	return 0;

		BOOL bEnableAdd=FALSE, bEnableDel=FALSE, bEnableIns=FALSE;

		int	nIndexCmd =	m_cmbCommand.GetCurSel();
		bEnableAdd=bEnableIns=CanAddCommand();

		long nIndex	= pnmv->iItem;
		bEnableDel=TRUE;

		::EnableWindow(GetDlgItem(IDC_BTN03), bEnableAdd);
		::EnableWindow(GetDlgItem(IDC_BTN04), bEnableDel);
		::EnableWindow(GetDlgItem(IDC_BTN05), bEnableIns);

		UINT nID = m_aryStdBtn[nIndex].idCommand;
		UINT nStyle	= m_aryStdBtn[nIndex].fsStyle;

		if (m_aryStdBtn[nIndex].fsStyle	& BTNS_STD_LIST)
			::SendMessage(GetDlgItem(IDC_CHKBTN_TXT), BM_SETCHECK, BST_CHECKED,	0L);
		else
			::SendMessage(GetDlgItem(IDC_CHKBTN_TXT), BM_SETCHECK, BST_UNCHECKED, 0L);

		return 0;
	}

	void EnableMove(int	nIndex)
	{
		BOOL bEnableL=FALSE, bEnableR=FALSE;
		if (m_aryStdBtn.GetSize()<2)
		{
			bEnableL=FALSE;
			bEnableR=FALSE;
		}
		else if	(nIndex==0)
		{
			bEnableL=FALSE;
			bEnableR=TRUE;
		}
		else if	((nIndex+1)==m_aryStdBtn.GetSize())
		{
			bEnableL=TRUE;
			bEnableR=FALSE;
		}
		else
		{
			bEnableL=TRUE;
			bEnableR=TRUE;
		}

		::EnableWindow(GetDlgItem(IDC_BTN01), bEnableL);
		::EnableWindow(GetDlgItem(IDC_BTN02), bEnableR);
	}

	// R}hύX
	void OnSelChangeCmd(UINT code, int id, HWND	hWnd)
	{
		::EnableWindow(GetDlgItem(IDC_BTN03), CanAddCommand());

		int	nIndexLt = m_ltIcon.GetSelectedIndex();
		if (nIndexLt!=-1)
			::EnableWindow(GetDlgItem(IDC_BTN05), CanAddCommand());
		else
			::EnableWindow(GetDlgItem(IDC_BTN05), FALSE);
	}

	// ǉłHH
	BOOL CanAddCommand()
	{
		int	nIndex = m_cmbCommand.GetCurSel();
		if (nIndex==-1)	return FALSE;

		UINT nTarID	= m_cmbCommand.GetItemData(nIndex);
		if (nTarID==0) return FALSE;

		for	(int ii=0; ii<m_aryStdBtn.GetSize(); ii++)
		{
			UINT nID = m_aryStdBtn[ii].idCommand;
			if (nID==nTarID) return	FALSE;
		}

		return TRUE;
	}

	void OnBtnIns(UINT /*wNotifyCode*/,	int	/*wID*/, HWND /*hWndCtl*/)
	{
		int	nIndexLt = m_ltIcon.GetSelectedIndex();
		if (nIndexLt==-1) return;

		int	nIndexCmb =	m_cmbCommand.GetCurSel();
		if (nIndexCmb==-1) return;

		UINT nTarID	= m_cmbCommand.GetItemData(nIndexCmb);
		if (nTarID==0) return;

		CString	strCmd;
		CStdToolBarCtrlBase::_LoadToolTipText(nTarID, strCmd);

		int	nLtCnt = m_ltIcon.GetItemCount();
		m_ltIcon.InsertItem(nLtCnt,	strCmd,	nLtCnt);
		for	(int ii=nLtCnt;	ii>nIndexLt; ii--)
		{
			TCHAR/*+++ char*/ cBuff[MAX_PATH];
			memset(cBuff, 0, sizeof(cBuff));
			m_ltIcon.GetItemText(ii-1, 0, cBuff, MAX_PATH);
			CString	strText(cBuff);

			m_ltIcon.SetItemText(ii, 0,	strText);
		}
		m_ltIcon.SetItemText(nIndexLt, 0, strCmd);


		STD_TBBUTTON stdBtn;
		stdBtn.idCommand = nTarID;
		stdBtn.fsStyle = GetToolButtonStyle(nTarID);

		int	nAryCnt	= m_aryStdBtn.GetSize();
		m_aryStdBtn.Add(stdBtn);
		for	(/*++*/int ii2=nLtCnt; ii2>nIndexLt; ii2--)
			m_aryStdBtn[ii2]  = m_aryStdBtn[ii2-1];
		m_aryStdBtn[nIndexLt] =	stdBtn;

		m_cmbCommand.SetCurSel(nIndexCmb+1);
		::EnableWindow(GetDlgItem(IDC_BTN03), CanAddCommand());
		::EnableWindow(GetDlgItem(IDC_BTN05), CanAddCommand());
		EnableMove(nIndexLt);
	}

	void OnBtnDel(UINT /*wNotifyCode*/,	int	/*wID*/, HWND /*hWndCtl*/)
	{
		int	nIndex = m_ltIcon.GetSelectedIndex();
		if (nIndex==-1)	return;

		m_aryStdBtn.RemoveAt(nIndex);

		int	ii;	//+++
		for	(/*int*/ ii=nIndex;	ii<(m_ltIcon.GetItemCount()-1);	ii++)
		{
			TCHAR/*+++ char*/ cBuff[MAX_PATH];
			memset(cBuff, 0, sizeof(cBuff));
			m_ltIcon.GetItemText(ii+1, 0, cBuff, MAX_PATH);
			CString	strText(cBuff);

			m_ltIcon.SetItemText(ii, 0,	strText);
		}
		m_ltIcon.DeleteItem(ii);
		EnableMove(nIndex);
	}

	void OnBtnAdd(UINT /*wNotifyCode*/,	int	/*wID*/, HWND /*hWndCtl*/)
	{
		int	nIndex = m_cmbCommand.GetCurSel();
		if (nIndex==-1)	return;

		UINT nTarID	= m_cmbCommand.GetItemData(nIndex);
		if (nTarID==0) return;

		STD_TBBUTTON stdBtn;
		stdBtn.idCommand = nTarID;
		stdBtn.fsStyle = GetToolButtonStyle(nTarID);

		CString	strCmd;
		CStdToolBarCtrlBase::_LoadToolTipText(nTarID, strCmd);

		int	nLtCnt = m_ltIcon.GetItemCount();
		nLtCnt = m_ltIcon.InsertItem(nLtCnt, strCmd, nLtCnt);

		// RedrawȂƁAXN[o[̗̈悪Ȃ
		m_ltIcon.RedrawWindow();

		int	nMinPos=999, nMaxPos=-999, nCurPos=0;
		::GetScrollRange(m_ltIcon.m_hWnd, WS_HSCROLL, &nMinPos,	&nMaxPos);
		nCurPos=::GetScrollPos(m_ltIcon.m_hWnd,	WS_HSCROLL);
		m_ltIcon.Scroll(CSize(nMaxPos-nCurPos, 0));

		m_aryStdBtn.Add(stdBtn);
		m_cmbCommand.SetCurSel(nIndex+1);
		::EnableWindow(GetDlgItem(IDC_BTN03), CanAddCommand());
		::EnableWindow(GetDlgItem(IDC_BTN05), CanAddCommand());
	}

	DWORD GetToolButtonStyle(UINT nTarID)
	{
		for	(int ii=0; ii<_uDropDownCommandCount; ii++)
		{
			if (nTarID == _uDropDownCommandID[ii])
				return BTNS_BUTTON|BTNS_DROPDOWN;
		}
		for	(/*+++*/int	ii2=0; ii2<_uDropDownWholeCommandCount; ii2++)
		{
			if (nTarID == _uDropDownWholeCommandID[ii2])
			{
				if (nTarID == ID_FAVORITES_DROPDOWN)
					return BTNS_BUTTON|BTNS_STD_LIST|BTNS_DROPDOWN|BTNS_WHOLEDROPDOWN;
				else
					return BTNS_BUTTON|BTNS_DROPDOWN|BTNS_WHOLEDROPDOWN;
			}
		}

		return BTNS_BUTTON;
	}

	void OnBtnMove(UINT	/*wNotifyCode*/, int wID, HWND /*hWndCtl*/)
	{
		int	nIndex = m_ltIcon.GetSelectedIndex();
		if (nIndex==-1)	return;

		int	nAdd = 1;
		if (wID==IDC_BTN01)
			nAdd = -1;

		TCHAR/*+++ char*/ cBuff[MAX_PATH];
		memset(cBuff, 0, sizeof(cBuff));
		m_ltIcon.GetItemText(nIndex, 0,	cBuff, MAX_PATH);
		CString	strTextNow(cBuff);

		memset(cBuff, 0, sizeof(cBuff));
		m_ltIcon.GetItemText(nIndex+nAdd, 0, cBuff,	MAX_PATH);
		CString	strTextTar(cBuff);

		m_ltIcon.SetItemText(nIndex, 0,	strTextTar);
		m_ltIcon.SetItemText(nIndex+nAdd, 0, strTextNow);

		STD_TBBUTTON stdBtn	= m_aryStdBtn[nIndex];
		STD_TBBUTTON stdBtnTar = m_aryStdBtn[nIndex+nAdd];

		m_aryStdBtn.SetAtIndex(nIndex, stdBtnTar);
		m_aryStdBtn.SetAtIndex(nIndex+nAdd,	stdBtn);

		m_ltIcon.SelectItem(nIndex+nAdd);
		EnableMove(nIndex+nAdd);
	}
};

class CMousePropertyPage : public CPropertyPageImpl<CMousePropertyPage>,
	public CWinDataExchange<CMousePropertyPage>
{
public:
// Constants
	enum { IDD = IDD_PROPPAGE_MOUSE};

// Data	members
	CComboBox m_cmbLinkM;

	CSimpleMap<CString,	DWORD>	m_mapMouseCmd;
	CSimpleArray<CString>		m_aryDelJst;

	CComboBox m_cmbCategory;
	CComboBox m_cmbCommand;
	CListViewCtrl m_ltMoveCmd;
	HMENU	m_hMenu;

	CStatic	m_stcMoveCmd;
	CString	m_strPath;

// DDX map
	BEGIN_DDX_MAP(CMousePropertyPage)
	END_DDX_MAP()

	CMousePropertyPage(HMENU hMenu)
	{
		m_hMenu	= hMenu;
		m_strPath =	_GetFilePath(_T("MouseEdit.ini"));
	}

// Overrides
	BOOL OnSetActive()
	{
		SetModified(TRUE);

		if (m_cmbLinkM.m_hWnd == NULL)
		{
			OnInitSetting();

			if (m_cmbCategory.m_hWnd ==	NULL)
				m_cmbCategory.Attach(GetDlgItem(IDC_CMB_CATEGORY));

			if (m_cmbCommand.m_hWnd	== NULL)
				m_cmbCommand.Attach(GetDlgItem(IDC_CMB_COMMAND));

			OnInitCmb();
			OnInitList();

			SetCmdString();

			m_stcMoveCmd.Attach(GetDlgItem(IDC_STC01));
		}

		_SetData();
		return DoDataExchange(FALSE);
	}
	BOOL OnKillActive()
	{
		return DoDataExchange(TRUE);
	}
	BOOL OnApply()
	{
		if (DoDataExchange(TRUE)) {
			_GetData();
			return TRUE;
		}
		else
			return FALSE;
	}

// Constructor
	// f[^𓾂
	void _SetData()
	{
	}

	// f[^ۑ
	void _GetData()
	{
		CIniSection	pr;
		pr.Open(m_strPath, _T("MouseCtrl"));

		for	(int ii=0; ii<m_mapMouseCmd.GetSize(); ii++)
		{
			CString	strKey = m_mapMouseCmd.GetKeyAt(ii);
			DWORD dwCommand	= m_mapMouseCmd.GetValueAt(ii);

			pr.SetValue(dwCommand, strKey);
		}

		for	(/*+++*/int	ii2=0; ii2<m_aryDelJst.GetSize(); ii2++)
			pr.DeleteValue(m_aryDelJst[ii2]);

		for	(/*+++*/int	ii3=0; ii3<m_ltMoveCmd.GetItemCount(); ii3++)
		{
			CString	strMoveCmd;
			m_ltMoveCmd.GetItemText(ii3, 0, strMoveCmd);
			DWORD dwCommand=0;
			dwCommand =	m_ltMoveCmd.GetItemData(ii3);

			pr.SetValue(dwCommand, strMoveCmd);
		}
		pr.Close();

		pr.Open(m_strPath, _T("MouseJst"));
		pr.SetValue(m_ltMoveCmd.GetItemCount(),	_T("Count"));
		for	(/*+++*/int	ii4=0; ii4<m_ltMoveCmd.GetItemCount(); ii4++)
		{
			CString	strMoveCmd;
			m_ltMoveCmd.GetItemText(ii4, 0, strMoveCmd);

			CString	strKey;
			strKey.Format(_T("%d"),	ii4);
			pr.SetValue(strMoveCmd,	strKey);
		}
	}

	void OnInitSetting()
	{
		//+++ static ǉ.
		static	LPCTSTR	lpKeyStr[]={_T("WHEEL_UP")		, _T("WHEEL_DOWN"),
									_T("LButtonUp")		, _T("MButtonUp"),
									_T("XButtonUp1")	, _T("XButtonUp2"),
									_T("LinkOpenBtnM")	,
									_T("Side1")			, _T("Side2")		};
		int	nKeyCnt	= 9;

		CIniSection	pr;
		pr.Open(m_strPath, _T("MouseCtrl"));

		for	(int ii=0; ii<nKeyCnt; ii++)
		{
			CString	strKey;
			strKey.Format(_T("%s"),	lpKeyStr[ii]);

			DWORD dwCommand=0;
			pr.QueryValue(dwCommand, strKey);

			m_mapMouseCmd.Add(strKey, dwCommand);
		}
	}

	void SetCmdString()
	{
		//+++ static ǉ.
		static DWORD dwWndID[] = {	IDC_SETBTN_RL	, IDC_SETBTN_RM,
									IDC_SETBTN_RX1	, IDC_SETBTN_RX2,
									IDC_SETBTN_RW_UP, IDC_SETBTN_RW_DOWN,
									IDC_SETBTN_SIDE1, IDC_SETBTN_SIDE2	};

		for	(int ii=0; ii<(sizeof(dwWndID)/sizeof(DWORD)); ii++)
		{
			CString	strTar = GetTarString(dwWndID[ii]);
			DWORD dwCommand	= m_mapMouseCmd.Lookup(strTar);

			CString	strCmdName;
			if (dwCommand!=0)
				CStdToolBarCtrlBase::_LoadToolTipText(dwCommand, strCmdName);
			else
				strCmdName = _T("ftHg");

			DWORD dwStatic = GetTarStaticID(dwWndID[ii]);
			::SetWindowText(::GetDlgItem(m_hWnd, dwStatic),	strCmdName);
		}

		CString	strTar = GetTarString(IDC_CMB_LINK_M);
		DWORD dwCommand	= m_mapMouseCmd.Lookup(strTar);
		for	(/*+++*/int	ii2=0; ii2<m_cmbLinkM.GetCount(); ii2++)
		{
			DWORD dwVal	= m_cmbLinkM.GetItemData(ii2);
			if (dwVal!=dwCommand) continue;

			m_cmbLinkM.SetCurSel(ii2);
			break;
		}
	}

	void OnInitCmb()
	{
		m_cmbLinkM.Attach(GetDlgItem(IDC_CMB_LINK_M));

		CMenu menuSel;
		menuSel.LoadMenu(IDR_MOUSE_EX_SEL);

		m_cmbLinkM.Attach(GetDlgItem(IDC_CMB_LINK_M));
		AddMenuItem(menuSel, m_cmbLinkM);

		// JeSZbg
		_SetCombboxCategory(m_cmbCategory, m_hMenu);
		OnSelChangeCate(0,0,0);
	}

	void OnInitList()
	{
		m_ltMoveCmd.Attach(GetDlgItem(IDC_LISTBOX));

		//+++ static ǉ.
		static const TCHAR*	titles[] = { _T("WFX`["), _T("R}h")	};
		static const int widths[] =	{ 350, 150};

		LVCOLUMN col;
		col.mask = LVCF_TEXT | LVCF_WIDTH;

		for	(int i = 0;	i <	_countof(titles); ++i) {
			col.pszText	= (LPTSTR)titles[i];
			col.cx = widths[i];
			m_ltMoveCmd.InsertColumn(i,	&col);
		}

		m_ltMoveCmd.SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);

		CIniSection	pr;
		pr.Open(m_strPath, _T("MouseJst"));

		CIniSection	pr2;
		pr2.Open(m_strPath,	_T("MouseCtrl"));

		DWORD dwCount=0;
		pr.QueryValue(dwCount, _T("Count"));

		DWORD dwBuff=MAX_PATH;
		TCHAR cBuff[MAX_PATH];
		for	(int ii=0; ii<dwCount; ii++)
		{
			CString	strMoveCmd;
			m_ltMoveCmd.GetItemText(ii,	0, strMoveCmd);

			CString	strKey;
			strKey.Format(_T("%d"),	ii);

			memset(cBuff, 0, MAX_PATH);
			pr.QueryValue(cBuff, strKey, &dwBuff);
			CString	strJst(cBuff);

			DWORD dwCmdID=0;
			pr2.QueryValue(dwCmdID,	strJst);

			CString	strCmdName;
			CStdToolBarCtrlBase::_LoadToolTipText(dwCmdID, strCmdName);

			m_ltMoveCmd.InsertItem(ii, strJst);
			m_ltMoveCmd.SetItemText(ii,	1, strCmdName);
			m_ltMoveCmd.SetItemData(ii,	dwCmdID);
		}

		::EnableWindow(GetDlgItem(IDC_BTN_ADD),	FALSE);
		::EnableWindow(GetDlgItem(IDC_BTN_DEL),	FALSE);
	}

	void AddMenuItem(CMenu &menu, CComboBox	&cmb)
	{
		cmb.SetDroppedWidth(250);
		int	nIndex = cmb.AddString(_T("ftHg"));
		cmb.SetItemData(nIndex,	0);

		for	(int ii=0; ii<menu.GetMenuItemCount(); ii++)
		{
			DWORD dwCommand	= menu.GetMenuItemID(ii);
			if (dwCommand==0) continue;

			CString	strMenu;
			menu.GetMenuString(ii, strMenu,	MF_BYPOSITION);

			nIndex = cmb.AddString(strMenu);
			cmb.SetItemData(nIndex,	dwCommand);
		}
	}

// Message map and handlers
	BEGIN_MSG_MAP(CMousePropertyPage)
		CHAIN_MSG_MAP(CPropertyPageImpl<CMousePropertyPage>)


		COMMAND_HANDLER_EX(IDC_CMB_LINK_M, CBN_SELCHANGE, OnSelChange)


		COMMAND_HANDLER_EX(IDC_CMB_CATEGORY, CBN_SELCHANGE,	OnSelChangeCate)
		COMMAND_HANDLER_EX(IDC_CMB_COMMAND,	CBN_SELCHANGE, OnSelChangeCmd)

		COMMAND_ID_HANDLER_EX(IDC_BTN_UP, OnBtn)
		COMMAND_ID_HANDLER_EX(IDC_BTN_DOWN,	OnBtn)
		COMMAND_ID_HANDLER_EX(IDC_BTN_LEFT,	OnBtn)
		COMMAND_ID_HANDLER_EX(IDC_BTN_RIGHT, OnBtn)
		COMMAND_ID_HANDLER_EX(IDC_BTN_CLEAR, OnBtn)

		COMMAND_ID_HANDLER_EX(IDC_BTN_ADD, OnBtnAdd)
		COMMAND_ID_HANDLER_EX(IDC_BTN_DEL, OnBtnDel)
		NOTIFY_HANDLER_EX(IDC_LISTBOX, LVN_ITEMCHANGED,	OnItemChg)

		COMMAND_ID_HANDLER_EX(IDC_SETBTN_RL, OnSetBtn)
		COMMAND_ID_HANDLER_EX(IDC_SETBTN_RM, OnSetBtn)
		COMMAND_ID_HANDLER_EX(IDC_SETBTN_RX1, OnSetBtn)
		COMMAND_ID_HANDLER_EX(IDC_SETBTN_RX2, OnSetBtn)
		COMMAND_ID_HANDLER_EX(IDC_SETBTN_RW_UP,	OnSetBtn)
		COMMAND_ID_HANDLER_EX(IDC_SETBTN_RW_DOWN, OnSetBtn)
		COMMAND_ID_HANDLER_EX(IDC_SETBTN_SIDE1,	OnSetBtn)
		COMMAND_ID_HANDLER_EX(IDC_SETBTN_SIDE2,	OnSetBtn)

		COMMAND_ID_HANDLER(IDC_STC_RL, OnSetStatic)
		COMMAND_ID_HANDLER(IDC_STC_RM, OnSetStatic)
		COMMAND_ID_HANDLER(IDC_STC_RX1,	OnSetStatic)
		COMMAND_ID_HANDLER(IDC_STC_RX2,	OnSetStatic)
		COMMAND_ID_HANDLER(IDC_STC_RW_UP, OnSetStatic)
		COMMAND_ID_HANDLER(IDC_STC_RW_DOWN,	OnSetStatic)
		COMMAND_ID_HANDLER(IDC_STC_SIDE1, OnSetStatic)
		COMMAND_ID_HANDLER(IDC_STC_SIDE2, OnSetStatic)
	END_MSG_MAP()

	LRESULT	OnSetStatic(WORD /*wNotifyCode*/, WORD wID,	HWND /*hWndCtl*/, BOOL&	/*bHandled*/) // UDT DGSTR
	{
		switch(wID)
		{
		case IDC_STC_RL:		OnSetBtn(0,IDC_SETBTN_RL,0);		break;
		case IDC_STC_RM:		OnSetBtn(0,IDC_SETBTN_RM,0);		break;
		case IDC_STC_RX1:		OnSetBtn(0,IDC_SETBTN_RX1,0);		break;
		case IDC_STC_RX2:		OnSetBtn(0,IDC_SETBTN_RX2,0);		break;
		case IDC_STC_RW_UP:		OnSetBtn(0,IDC_SETBTN_RW_UP,0);		break;
		case IDC_STC_RW_DOWN:	OnSetBtn(0,IDC_SETBTN_RW_DOWN,0);	break;

		case IDC_STC_SIDE1:		OnSetBtn(0,IDC_SETBTN_SIDE1,0);		break;
		case IDC_STC_SIDE2:		OnSetBtn(0,IDC_SETBTN_SIDE2,0);		break;
		}
		return 0;
	}

	void OnSetBtn(UINT /*wNotifyCode*/,	int	wID, HWND /*hWndCtl*/)
	{
		CCommandSelectDialog dlg(m_hMenu);
		if (dlg.DoModal()!=IDOK) return;

		DWORD dwCommand=dlg.GetCommandID();
		CString	strTar = GetTarString(wID);

		m_mapMouseCmd.SetAt(strTar,	dwCommand);

		CString	strCmdName;
		if (dwCommand!=0)
			CStdToolBarCtrlBase::_LoadToolTipText(dwCommand, strCmdName);
		else
			strCmdName = _T("ftHg");

		DWORD dwStatic = GetTarStaticID(wID);
		::SetWindowText(::GetDlgItem(m_hWnd, dwStatic),	strCmdName);

	}

	void OnBtnAdd(UINT /*wNotifyCode*/,	int	/*wID*/, HWND /*hWndCtl*/)
	{
		int	nIndexCmd =	m_cmbCommand.GetCurSel();
		UINT nCmdID	= m_cmbCommand.GetItemData(nIndexCmd);
		if (nCmdID==0) return;

		TCHAR szText[255];
		CString	strText;
		m_stcMoveCmd.GetWindowText(szText, 255);
		strText	= szText;
		if (strText.IsEmpty()) return;

		CString	strCmd;
		CStdToolBarCtrlBase::_LoadToolTipText(nCmdID, strCmd);
		if (strCmd.IsEmpty()) return;

		int	nCnt = m_ltMoveCmd.GetItemCount();
		nCnt = m_ltMoveCmd.InsertItem(nCnt,	strText);
		m_ltMoveCmd.SetItemText(nCnt, 1, strCmd);
		m_ltMoveCmd.SetItemData(nCnt, nCmdID);

		m_stcMoveCmd.SetWindowText(_T(""));
		::EnableWindow(GetDlgItem(IDC_BTN_ADD),	FALSE);
		::EnableWindow(GetDlgItem(IDC_BTN_DEL),	FALSE);
	}

	void OnBtnDel(UINT /*wNotifyCode*/,	int	/*wID*/, HWND /*hWndCtl*/)
	{
		int	nIndex = m_ltMoveCmd.GetSelectedIndex();
		if (nIndex==-1)	return;

		CString	strJst;
		m_ltMoveCmd.GetItemText(nIndex,	0, strJst);
		m_aryDelJst.Add(strJst);

		m_ltMoveCmd.DeleteItem(nIndex);
		::EnableWindow(GetDlgItem(IDC_BTN_DEL),	TRUE);
	}

	void OnBtn(UINT	/*wNotifyCode*/, int wID, HWND /*hWndCtl*/)
	{
		TCHAR szText[255];

		CString	strText;
		m_stcMoveCmd.GetWindowText(szText, 255);
		strText	= szText;

		switch(wID)
		{
		case IDC_BTN_UP:	strText	+= _T("");	break;
		case IDC_BTN_DOWN:	strText	+= _T("");	break;
		case IDC_BTN_LEFT:	strText	+= _T("");	break;
		case IDC_BTN_RIGHT:	strText	+= _T("");	break;
		case IDC_BTN_CLEAR:	strText	= _T("");	break;
		}

		m_stcMoveCmd.SetWindowText(strText);
		EnableAddBtn();
	}

	void OnSelChangeCmd(UINT code, int id, HWND	hWnd)
	{
		EnableAddBtn();
	}

	void EnableAddBtn()
	{
		TCHAR szText[255];
		CString	strNowJst;
		m_stcMoveCmd.GetWindowText(szText, 255);
		strNowJst =	szText;

		BOOL bEnable=TRUE;

		int	nIndexCmd =	m_cmbCommand.GetCurSel();
		UINT nCmdID	= m_cmbCommand.GetItemData(nIndexCmd);
		if (nCmdID==0 || nIndexCmd==-1)	bEnable=FALSE;

		for	(int ii=0; ii<m_ltMoveCmd.GetItemCount() &&	bEnable; ii++)
		{
			CString	strMoveJst;
			m_ltMoveCmd.GetItemText(ii,	0, strMoveJst);
			if (strNowJst!=strMoveJst) continue;

			bEnable=FALSE;
			break;
		}

		::EnableWindow(GetDlgItem(IDC_BTN_ADD),	bEnable);
	}

	LRESULT	OnItemChg(LPNMHDR pnmh)
	{
		LPNMLISTVIEW pnmv =	(LPNMLISTVIEW)pnmh;
		if (pnmv->uNewState!=LBN_SELCANCEL)	return 0;

		long nIndex	= pnmv->iItem;
		::EnableWindow(GetDlgItem(IDC_BTN_DEL),	TRUE);
		return 0;
	}

	CString	GetTarString(int id)
	{
		CString	strTar;
		switch(id)
		{
		case IDC_SETBTN_RL:			strTar = _T("LButtonUp");		break;
		case IDC_SETBTN_RM:			strTar = _T("MButtonUp");		break;
		case IDC_SETBTN_RW_UP:		strTar = _T("WHEEL_UP");		break;
		case IDC_SETBTN_RW_DOWN:	strTar = _T("WHEEL_DOWN");		break;
		case IDC_SETBTN_RX1:		strTar = _T("XButtonUp1");		break;
		case IDC_SETBTN_RX2:		strTar = _T("XButtonUp2");		break;

		case IDC_SETBTN_SIDE1:		strTar = _T("Side1");			break;
		case IDC_SETBTN_SIDE2:		strTar = _T("Side2");			break;

		case IDC_CMB_LINK_M:	strTar = _T("LinkOpenBtnM");	break;
		}

		return strTar;
	}

	DWORD GetTarStaticID(int id)
	{
		DWORD dwWndID;
		switch(id)
		{
		case IDC_SETBTN_RL:			dwWndID	= IDC_STC_RL;		break;
		case IDC_SETBTN_RM:			dwWndID	= IDC_STC_RM;		break;
		case IDC_SETBTN_RX1:		dwWndID	= IDC_STC_RX1;		break;
		case IDC_SETBTN_RX2:		dwWndID	= IDC_STC_RX2;		break;
		case IDC_SETBTN_RW_UP:		dwWndID	= IDC_STC_RW_UP;	break;
		case IDC_SETBTN_RW_DOWN:	dwWndID	= IDC_STC_RW_DOWN;	break;

		case IDC_SETBTN_SIDE1:		dwWndID	= IDC_STC_SIDE1;	break;
		case IDC_SETBTN_SIDE2:		dwWndID	= IDC_STC_SIDE2;	break;
		}

		return dwWndID;
	}

	void OnSelChange(UINT code,	int	id,	HWND hWnd)
	{
		CString	strTar=GetTarString(id);

		CComboBox cmb(hWnd);
		int	nIndex = cmb.GetCurSel();
		DWORD dwCommand=0;
		dwCommand =	cmb.GetItemData(nIndex);
		m_mapMouseCmd.SetAt(strTar,	dwCommand);
	}

	// JeSύX
	void OnSelChangeCate(UINT code,	int	id,	HWND hWnd)
	{
		int	nIndex = m_cmbCategory.GetCurSel();

		// R}hI
		_PickUpCommand(m_hMenu,	nIndex,	m_cmbCommand);
	}
};

class CMenuPropertyPage	: public CPropertyPageImpl<CMenuPropertyPage>,
	public CWinDataExchange<CMenuPropertyPage>
{
public:
// Constants
	enum { IDD = IDD_PROPPAGE_MENU};

// Data	members
	HMENU	m_hMenu;
	CComboBox m_cmbTar;
	CComboBox m_cmbCategory;
	CComboBox m_cmbCommand;

	CComboBox m_cmbCategory2;
	CComboBox m_cmbCommand2;

	CListBox m_ltFront;
	CListBox m_ltBack;
	CListBox m_ltMenuEx;

	CSimpleMap<int,	CSimpleArray<int>*>	m_mapFront;
	CSimpleMap<int,	CSimpleArray<int>*>	m_mapBack;
	CSimpleArray<int> m_aryMenuEx;

	BOOL m_bFirst;
	CString	m_strPath;

	int	m_nNoCstmMenu, m_nNoCstmIeMenu;

// DDX map
	BEGIN_DDX_MAP(CMenuPropertyPage)
		DDX_CHECK(IDC_NO_CSTM_TXT_MENU,	m_nNoCstmMenu)
		DDX_CHECK(IDC_NO_CSTM_IE_MENU,	m_nNoCstmIeMenu)
	END_DDX_MAP()

	CMenuPropertyPage(HMENU	hMenu)
	{
		m_bFirst = TRUE;
		m_hMenu	= hMenu;
	}

	~CMenuPropertyPage()
	{
		for	(int ii=0; ii<m_mapFront.GetSize();	ii++)
		{
			CSimpleArray<int>* pAry	= m_mapFront.GetValueAt(ii);
			delete pAry;
		}

		for	(/*+++*/int	ii2=0; ii2<m_mapBack.GetSize(); ii2++)
		{
			CSimpleArray<int>* pAry	= m_mapBack.GetValueAt(ii2);
			delete pAry;
		}
	}

// Overrides
	BOOL OnSetActive()
	{
		SetModified(TRUE);

		if (m_cmbTar.m_hWnd==NULL)
		{
			m_strPath =	_GetFilePath(_T("Menu.ini"));
			InitialCmbbox();
			InitialListbox();

			m_nNoCstmMenu =	CMainOption::s_dwMainExtendedStyle2	& MAIN_EX2_NOCSTMMENU ?	1:0;

			DWORD dwVal=0;
			CIniSection	pr;
			pr.Open(_szIniFileName,	_T("ETC"));
			if (pr.QueryValue(dwVal, _T("IeMenuNoCstm"))==ERROR_SUCCESS)
				m_nNoCstmIeMenu	= dwVal;
			pr.Close();

			SetAddMenu(m_cmbTar.GetItemData(0));
		}

		return DoDataExchange(FALSE);
	}

	BOOL OnKillActive()
	{
		return DoDataExchange(TRUE);
	}
	BOOL OnApply()
	{
		if (DoDataExchange(TRUE)) {
			_SaveData();
			return TRUE;
		}
		else
			return FALSE;
	}

	// f[^ۑ
	void _SaveData()
	{
		// j[eLXgҏW
		if (m_nNoCstmMenu==1)
			CMainOption::s_dwMainExtendedStyle2	|= MAIN_EX2_NOCSTMMENU;
		else if	(CMainOption::s_dwMainExtendedStyle2&MAIN_EX2_NOCSTMMENU)
			CMainOption::s_dwMainExtendedStyle2&=~MAIN_EX2_NOCSTMMENU;

		// IE Menu ̃JX^
		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("ETC"));
		pr.SetValue(m_nNoCstmIeMenu, _T("IeMenuNoCstm"));
		pr.Close();

		CString	strKey;

		// IE Menu JX^
		static const long nMenuType[] =	{CONTEXT_MENU_DEFAULT, CONTEXT_MENU_TEXTSELECT,	CONTEXT_MENU_ANCHOR};	//+++ static const ǉ.
		for	(int ii=0; ii<(sizeof(nMenuType)/sizeof(long));	ii++)
		{
			strKey.Format(_T("Type%d"),	nMenuType[ii]);
			pr.Open(m_strPath, strKey);

			CSimpleArray<int>* pAryFront = m_mapFront.Lookup(nMenuType[ii]);
			pr.SetValue(pAryFront->GetSize(), _T("FrontCount"));
			for	(int jj=0; jj<pAryFront->GetSize();	jj++)
			{
				strKey.Format(_T("Front%02d"), jj);
				pr.SetValue((*pAryFront)[jj], strKey);
			}

			CSimpleArray<int>* pAryBack	= m_mapBack.Lookup(nMenuType[ii]);
			pr.SetValue(pAryBack->GetSize(), _T("BackCount"));
			for	(/*+++*/int	jj2=0; jj2<pAryBack->GetSize(); jj2++)
			{
				strKey.Format(_T("Back%02d"), jj2);
				pr.SetValue((*pAryBack)[jj2], strKey);
			}
			pr.Close();
		}

		pr.Open(m_strPath, _T("MenuEx"));
		pr.SetValue(m_aryMenuEx.GetSize(), _T("Count"));
		for	(/*+++*/int	ii2=0; ii2<m_aryMenuEx.GetSize(); ii2++)
		{
			strKey.Format(_T("%02d"), ii2);
			pr.SetValue(m_aryMenuEx[ii2], strKey);
		}
	}

	void InitialListbox()
	{
		m_ltFront.Attach(GetDlgItem(IDC_LIST1));
		m_ltBack.Attach(GetDlgItem(IDC_LIST2));
		m_ltMenuEx.Attach(GetDlgItem(IDC_LIST3));

		CIniSection	pr;
		CString	strKey;
		DWORD dwCount=0;
		for	(int ii=0; ii<m_cmbTar.GetCount(); ii++)
		{
			CSimpleArray<int>* pAryFront=new CSimpleArray<int>;
			CSimpleArray<int>* pAryBack=new	CSimpleArray<int>;

			int	nKind =	m_cmbTar.GetItemData(ii);
			m_mapFront.Add(nKind, pAryFront);
			m_mapBack.Add(nKind, pAryBack);

			strKey.Format(_T("Type%d"),	nKind);
			pr.Open(m_strPath, strKey);
			pr.QueryValue(dwCount, _T("FrontCount"));
			for	(int jj=0; jj<dwCount; jj++)
			{
				strKey.Format(_T("Front%02d"), jj);
				DWORD dwCmd=0;
				pr.QueryValue(dwCmd, strKey);
				int	nCmd = dwCmd;
				pAryFront->Add(nCmd);
			}

			pr.QueryValue(dwCount, _T("BackCount"));
			for	(/*+++*/int	jj2=0; jj2<dwCount; jj2++)
			{
				strKey.Format(_T("Back%02d"), jj2);
				DWORD dwCmd=0;
				pr.QueryValue(dwCmd, strKey);
				int	nCmd = dwCmd;
				pAryBack->Add(nCmd);
			}
			pr.Close();
		}


		pr.Open(m_strPath, _T("MenuEx"));
		pr.QueryValue(dwCount, _T("Count"));
		for	(/*++*/int ii2=0; ii2<dwCount; ii2++)
		{
			strKey.Format(_T("%02d"), ii2);
			DWORD dwCmd=0;
			pr.QueryValue(dwCmd, strKey);
			int	nCmd = dwCmd;
			m_aryMenuEx.Add(nCmd);

			CString	strCmd;
			if (nCmd==0)
				strCmd = _cSeparater;
			else
				CStdToolBarCtrlBase::_LoadToolTipText(nCmd,	strCmd);

			m_ltMenuEx.AddString(strCmd);
		}
	}

	void InitialCmbbox()
	{
		m_cmbTar.Attach(GetDlgItem(IDC_CMB_TAR));
		m_cmbCategory.Attach(GetDlgItem(IDC_CMB_CATEGORY));
		m_cmbCommand.Attach(GetDlgItem(IDC_CMB_COMMAND));

		m_cmbCategory2.Attach(GetDlgItem(IDC_CMB_CATEGORY2));
		m_cmbCommand2.Attach(GetDlgItem(IDC_CMB_COMMAND2));

		m_cmbTar.AddString(_T("ʏ펞"));
		m_cmbTar.AddString(_T("I"));
		m_cmbTar.AddString(_T("N㎞"));
		m_cmbTar.SetItemData(0,	CONTEXT_MENU_DEFAULT);
		m_cmbTar.SetItemData(1,	CONTEXT_MENU_TEXTSELECT);
		m_cmbTar.SetItemData(2,	CONTEXT_MENU_ANCHOR);

		m_cmbTar.SetCurSel(0);

		// JeSZbg
		_SetCombboxCategory(m_cmbCategory, m_hMenu);
		_SetCombboxCategory(m_cmbCategory2,	m_hMenu);
		OnSelChangeCate(0,IDC_CMB_CATEGORY,0);
		OnSelChangeCate(0,IDC_CMB_CATEGORY2,0);

		m_cmbCategory.AddString(_T("O[vEj["));
		m_cmbCategory2.AddString(_T("O[vEj["));
	}

// Constructor

// Message map and handlers
	BEGIN_MSG_MAP(CMenuPropertyPage)
		CHAIN_MSG_MAP(CPropertyPageImpl<CMenuPropertyPage>)
		COMMAND_HANDLER_EX(IDC_CMB_CATEGORY, CBN_SELCHANGE,	OnSelChangeCate)
		COMMAND_HANDLER_EX(IDC_CMB_CATEGORY2, CBN_SELCHANGE, OnSelChangeCate)
		COMMAND_HANDLER_EX(IDC_CMB_COMMAND,	CBN_SELCHANGE, OnSelChangeCmd)
		COMMAND_HANDLER_EX(IDC_CMB_COMMAND2, CBN_SELCHANGE,	OnSelChangeCmd)

		COMMAND_HANDLER_EX(IDC_CMB_TAR,	CBN_SELCHANGE, OnSelChangeTarget)

		COMMAND_ID_HANDLER_EX(IDC_BTN_ADD1,	OnBtnAdd)
		COMMAND_ID_HANDLER_EX(IDC_BTN_DEL1,	OnBtnDel)

		COMMAND_ID_HANDLER_EX(IDC_BTN_ADD2,	OnBtnAdd)
		COMMAND_ID_HANDLER_EX(IDC_BTN_DEL2,	OnBtnDel)

		COMMAND_ID_HANDLER_EX(IDC_BTN_ADD3,	OnBtnAddEx)
		COMMAND_ID_HANDLER_EX(IDC_BTN_DEL3,	OnBtnDelEx)

		COMMAND_HANDLER_EX(IDC_LIST1, LBN_SELCHANGE, OnListChg)
		COMMAND_HANDLER_EX(IDC_LIST2, LBN_SELCHANGE, OnListChg)
		COMMAND_HANDLER_EX(IDC_LIST3, LBN_SELCHANGE, OnListChg)

		COMMAND_ID_HANDLER_EX(IDC_BTN_UP1, OnBtnUp)
		COMMAND_ID_HANDLER_EX(IDC_BTN_UP2, OnBtnUp)
		COMMAND_ID_HANDLER_EX(IDC_BTN_UP3, OnBtnUpEx)

		COMMAND_ID_HANDLER_EX(IDC_BTN_DOWN1, OnBtnDown)
		COMMAND_ID_HANDLER_EX(IDC_BTN_DOWN2, OnBtnDown)
		COMMAND_ID_HANDLER_EX(IDC_BTN_DOWN3, OnBtnDownEx)
	END_MSG_MAP()

	void OnSelChangeCate(UINT code,	int	id,	HWND hWnd)
	{
		if (id==IDC_CMB_CATEGORY)
		{
			int	nIndex = m_cmbCategory.GetCurSel();

			// R}hI
			if ((nIndex+1)!=m_cmbCategory.GetCount())
				_PickUpCommand(m_hMenu,	nIndex,	m_cmbCommand);
			else
				PickUpCommandEx(m_cmbCommand);

			::EnableWindow(GetDlgItem(IDC_BTN_ADD1), FALSE);
			::EnableWindow(GetDlgItem(IDC_BTN_ADD2), FALSE);
			::EnableWindow(GetDlgItem(IDC_BTN_DEL1), FALSE);
			::EnableWindow(GetDlgItem(IDC_BTN_DEL2), FALSE);
		}
		else if	(id==IDC_CMB_CATEGORY2)
		{
			int	nIndex = m_cmbCategory2.GetCurSel();

			// R}hI
			if ((nIndex+1)!=m_cmbCategory2.GetCount())
				_PickUpCommand(m_hMenu,	nIndex,	m_cmbCommand2);
			else
				PickUpCommandEx(m_cmbCommand2);

			::EnableWindow(GetDlgItem(IDC_BTN_ADD3), FALSE);
			::EnableWindow(GetDlgItem(IDC_BTN_DEL3), FALSE);
		}
	}

	// gR}h
	void PickUpCommandEx(CComboBox &cmbCmd)
	{
		//+++ static const ǉ.
		static const UINT uCommandExID[] = {ID_FAVORITES_DROPDOWN, ID_FAVORITES_GROUP_DROPDOWN,	ID_SCRIPT,
											ID_DLCTL_CHG_MULTI,	ID_DLCTL_CHG_SECU, ID_VIEW_FONT_SIZE, ID_COOKIE_IE6};

		cmbCmd.ResetContent();

		for	(int ii=0; ii<sizeof(uCommandExID)/sizeof(UINT); ii++)
		{
			CString	strMenu;
			CStdToolBarCtrlBase::_LoadToolTipText(uCommandExID[ii],	strMenu);
			if (strMenu.IsEmpty()) continue;

			int	nIndex = cmbCmd.AddString(strMenu);
			cmbCmd.SetItemData(nIndex, uCommandExID[ii]);
		}
	}

	void OnSelChangeCmd(UINT code, int id, HWND	hWnd)
	{
		if (id==IDC_CMB_COMMAND)
		{
			::EnableWindow(GetDlgItem(IDC_BTN_ADD1), TRUE);
			::EnableWindow(GetDlgItem(IDC_BTN_ADD2), TRUE);
		}
		else if	(id==IDC_CMB_COMMAND2)
		{
			::EnableWindow(GetDlgItem(IDC_BTN_ADD3), TRUE);
		}
	}

	void OnBtnAdd(UINT /*wNotifyCode*/,	int	wID, HWND /*hWndCtl*/)
	{
		int	nIndexCmd =	m_cmbCommand.GetCurSel();
		int	nCmdID = m_cmbCommand.GetItemData(nIndexCmd);

		CString	strCmd;
		m_cmbCommand.GetLBText(nIndexCmd, strCmd);

		CListBox* pListBox=NULL;
		switch(wID)
		{
		case IDC_BTN_ADD1:	pListBox = &m_ltFront;	break;
		case IDC_BTN_ADD2:	pListBox = &m_ltBack;	break;
		}

		int	nIndex = pListBox->AddString(strCmd);

		int	nType =	m_cmbTar.GetItemData(m_cmbTar.GetCurSel());
		CSimpleArray<int>* pAryFrontMenu = m_mapFront.Lookup(nType);
		CSimpleArray<int>* pAryBackMenu	= m_mapBack.Lookup(nType);
		switch(wID)
		{
		case IDC_BTN_ADD1:	pAryFrontMenu->Add(nCmdID);	break;
		case IDC_BTN_ADD2:	pAryBackMenu->Add(nCmdID);	break;
		}
	}

	void OnBtnDel(UINT /*wNotifyCode*/,	int	wID, HWND /*hWndCtl*/)
	{
		CListBox* pListBox=NULL;
		switch(wID)
		{
		case IDC_BTN_DEL1:	pListBox = &m_ltFront;	break;
		case IDC_BTN_DEL2:	pListBox = &m_ltBack;	break;
		}

		int	nIndex = pListBox->GetCurSel();
		if (nIndex<0) return;
		pListBox->DeleteString(nIndex);

		int	nType =	m_cmbTar.GetItemData(m_cmbTar.GetCurSel());
		CSimpleArray<int>* pAryFrontMenu = m_mapFront.Lookup(nType);
		CSimpleArray<int>* pAryBackMenu	= m_mapBack.Lookup(nType);
		switch(wID)
		{
		case IDC_BTN_DEL1:	pAryFrontMenu->RemoveAt(nIndex);	break;
		case IDC_BTN_DEL2:	pAryBackMenu->RemoveAt(nIndex);		break;
		}
	}

	void OnBtnAddEx(UINT /*wNotifyCode*/, int wID, HWND	/*hWndCtl*/)
	{
		int	nIndexCmd =	m_cmbCommand2.GetCurSel();
		int	nCmdID = m_cmbCommand2.GetItemData(nIndexCmd);

		CString	strCmd;
		m_cmbCommand2.GetLBText(nIndexCmd, strCmd);

		int	nIndex = m_ltMenuEx.AddString(strCmd);
		m_aryMenuEx.Add(nCmdID);
	}

	void OnBtnDelEx(UINT /*wNotifyCode*/, int wID, HWND	/*hWndCtl*/)
	{
		int	nIndex = m_ltMenuEx.GetCurSel();
		if (nIndex<0) return;
		m_ltMenuEx.DeleteString(nIndex);
		m_aryMenuEx.RemoveAt(nIndex);
	}

	void OnListChg(UINT	code, int id, HWND hWnd)
	{
		int	nEnableID=0;
		switch(id)
		{
		case IDC_LIST1:	nEnableID =	IDC_BTN_DEL1;	break;
		case IDC_LIST2:	nEnableID =	IDC_BTN_DEL2;	break;
		case IDC_LIST3:	nEnableID =	IDC_BTN_DEL3;	break;
		}

		::EnableWindow(GetDlgItem(nEnableID), TRUE);
	}

	void OnSelChangeTarget(UINT	code, int id, HWND hWnd)
	{
		int	nIndex = m_cmbTar.GetCurSel();
		SetAddMenu(m_cmbTar.GetItemData(nIndex));
	}

	void SetAddMenu(int	nType)
	{
		CSimpleArray<int>* pAryFrontMenu = m_mapFront.Lookup(nType);
		CSimpleArray<int>* pAryBackMenu	= m_mapBack.Lookup(nType);

		m_ltFront.ResetContent();
		m_ltBack.ResetContent();

		CSimpleArray<int>* pAryMenu=NULL;
		CListBox* pListBox=NULL;
		for	(int ii=0; ii<2; ii++)
		{
			if (ii==0)
			{
				pAryMenu = pAryFrontMenu;
				pListBox = &m_ltFront;
			}
			else
			{
				pAryMenu = pAryBackMenu;
				pListBox = &m_ltBack;
			}

			for	(int jj=0; jj<pAryMenu->GetSize(); jj++)
			{
				int	nCmdID = (*pAryMenu)[jj];
				CString	strCmd;
				if (nCmdID==0)
					strCmd = _cSeparater;
				else
					CStdToolBarCtrlBase::_LoadToolTipText(nCmdID, strCmd);

				int	nIndex = pListBox->AddString(strCmd);
			}
		}
	}

	void GetTargetMenuaryAndListbox(int	nID, CSimpleArray<int>*	&pAryMenu, CListBox* &pListBox)
	{
		int	nType =	m_cmbTar.GetItemData(m_cmbTar.GetCurSel());
		switch(nID)
		{
		case IDC_BTN_UP1:
		case IDC_BTN_DOWN1:
			pAryMenu = m_mapFront.Lookup(nType);
			pListBox = &m_ltFront;
			break;

		case IDC_BTN_UP2:
		case IDC_BTN_DOWN2:
			pAryMenu = m_mapBack.Lookup(nType);
			pListBox = &m_ltBack;
			break;
		}
	}

	void OnBtnUpEx(UINT	/*wNotifyCode*/, int wID, HWND /*hWndCtl*/)
	{
		int	nIndex = m_ltMenuEx.GetCurSel();
		if (nIndex<1) return;

		CString	strKeep;
		m_ltMenuEx.GetText(nIndex-1, strKeep);
		m_ltMenuEx.DeleteString(nIndex-1);
		m_ltMenuEx.InsertString(nIndex,	strKeep);

		int	nTemp =	m_aryMenuEx[nIndex-1];
		m_aryMenuEx[nIndex-1] =	m_aryMenuEx[nIndex];
		m_aryMenuEx[nIndex]	= nTemp;
	}

	void OnBtnDownEx(UINT /*wNotifyCode*/, int wID,	HWND /*hWndCtl*/)
	{
		int	nIndex = m_ltMenuEx.GetCurSel();
		if (nIndex<0) return;
		if (nIndex>=(m_ltMenuEx.GetCount()-1)) return;

		CString	strKeep;
		m_ltMenuEx.GetText(nIndex+1, strKeep);
		m_ltMenuEx.DeleteString(nIndex+1);
		m_ltMenuEx.InsertString(nIndex,	strKeep);

		int	nTemp =	m_aryMenuEx[nIndex+1];
		m_aryMenuEx[nIndex+1] =	m_aryMenuEx[nIndex];
		m_aryMenuEx[nIndex]	= nTemp;
	}

	void OnBtnUp(UINT /*wNotifyCode*/, int wID,	HWND /*hWndCtl*/)
	{
		CSimpleArray<int>* pAryMenu=NULL;
		CListBox* pListBox=NULL;
		GetTargetMenuaryAndListbox(wID,	pAryMenu, pListBox);

		int	nIndex = pListBox->GetCurSel();
		if (nIndex<1) return;

		CString	strKeep;
		pListBox->GetText(nIndex-1,	strKeep);
		pListBox->DeleteString(nIndex-1);
		pListBox->InsertString(nIndex, strKeep);

		int	nTemp =	(*pAryMenu)[nIndex-1];
		(*pAryMenu)[nIndex-1] =	(*pAryMenu)[nIndex];
		(*pAryMenu)[nIndex]	= nTemp;
	}

	void OnBtnDown(UINT	/*wNotifyCode*/, int wID, HWND /*hWndCtl*/)
	{
		CSimpleArray<int>* pAryMenu=NULL;
		CListBox* pListBox=NULL;
		GetTargetMenuaryAndListbox(wID,	pAryMenu, pListBox);

		int	nIndex = pListBox->GetCurSel();
		if (nIndex<0) return;
		if (nIndex>=(pListBox->GetCount()-1)) return;

		CString	strKeep;
		pListBox->GetText(nIndex+1,	strKeep);
		pListBox->DeleteString(nIndex+1);
		pListBox->InsertString(nIndex, strKeep);

		int	nTemp =	(*pAryMenu)[nIndex+1];
		(*pAryMenu)[nIndex+1] =	(*pAryMenu)[nIndex];
		(*pAryMenu)[nIndex]	= nTemp;
	}
};

#include "Include/PluginInfo.h"
class CPluginPropertyPage:
	public CPropertyPageImpl<CPluginPropertyPage>,
	public CWinDataExchange<CPluginPropertyPage>
{
public:
// Constants
	enum { IDD = IDD_PROPPAGE_PLUGIN };

	CSimpleMap<CString,	PLUGININFO*> m_mapPlaginInfo;


// Data	members
	CCheckListViewCtrl m_listview;
	CString	m_strPluginName;
	CString	m_strPluginKind;
	CString	m_strPluginVer;
	CString	m_strPluginDate;
	CString	m_strPluginComment;
	CString	m_strAuthuorName;
	CString	m_strAuthuorURL;
	CString	m_strAuthuorEMail;

// DDX map
	BEGIN_DDX_MAP(CPluginPropertyPage)
		DDX_TEXT( IDC_ED_PLUGIN_NAME,	m_strPluginName	);
		DDX_TEXT( IDC_ED_PLUGIN_KIND,	m_strPluginKind	);
		DDX_TEXT( IDC_ED_PLUGIN_VER,	m_strPluginVer );
		DDX_TEXT( IDC_ED_PLUGIN_DATE,	m_strPluginDate	);
		DDX_TEXT( IDC_ED_PLUGIN_COMMENT,m_strPluginComment );
		DDX_TEXT( IDC_ED_AUTHOR_NAME,	m_strAuthuorName );
		DDX_TEXT( IDC_ED_AUTHOR_URL,	m_strAuthuorURL	);
		DDX_TEXT( IDC_ED_AUTHOR_EMAIL,	m_strAuthuorEMail );

	END_DDX_MAP()

// Constructor
	CPluginPropertyPage()
	{
	}

	~CPluginPropertyPage()
	{
		m_listview.Detach();
	}

// Overrides
	BOOL OnSetActive()
	{
		if ( NULL==m_listview.m_hWnd )
		{
			m_listview.SubclassWindow(GetDlgItem(IDC_LIST_PLUGIN));
			_SetData();
		}
		return DoDataExchange(FALSE);
	}
	BOOL OnKillActive()
	{
		return DoDataExchange(TRUE);
	}
	BOOL OnApply()
	{
		if (DoDataExchange(TRUE)) {
			_GetData();
			return TRUE;
		}
		else
			return FALSE;
	}

// Message map and handlers
	BEGIN_MSG_MAP(CPluginPropertyPage)
		COMMAND_ID_HANDLER_EX(IDC_BTN_SETTING, OnBtnSetting)
		NOTIFY_HANDLER_EX(IDC_LIST_PLUGIN, LVN_ITEMCHANGED,	OnListPluginSelectchange)

		CHAIN_MSG_MAP(CPropertyPageImpl<CPluginPropertyPage>)
	END_MSG_MAP()

	void OnBtnSetting(WORD /*wNotifyCode*/,	WORD /*wID*/, HWND /*hWndCtl*/);

// Implementation
protected:
	void _GetData();
	void _SetData();


	LRESULT	OnListPluginSelectchange(LPNMHDR);

private:
	void InitListItem();
	void DoCheckListItem();
};
