template <class	_PanelBar>
//+++ class	CPanelMenu : public	CExplorerMenuImpl<CPanelMenu>
class CPanelMenu : public CExplorerMenuImpl<CPanelMenu<_PanelBar> >
{
public:
	_PanelBar* __m_pPanelBar;

	CPanelMenu(_PanelBar* __pPanelBar, int nInsertPointMenuItemID)
		:CExplorerMenuImpl<CPanelMenu>(nInsertPointMenuItemID, _T("(Ȃ)")),
		__m_pPanelBar(__pPanelBar)
	{
		m_dwStyle =	EMS_DRAW_ICON;
	}

	void OnExecute(const CString& strFilePath)
	{
		__m_pPanelBar->OpenFile(strFilePath);
	}

	BEGIN_MSG_MAP(CPanelMenu)
		CHAIN_MSG_MAP(CExplorerMenuImpl<CPanelMenu>)
	END_MSG_MAP()

};

template <class	T, class TParent, class	TBase =	CWindow, class TWinTraits =	CControlWinTraits>
class CDonutPanelBarImpl :
	public CWindowImpl<	T, TBase, TWinTraits >,
	//+++ public IWebBrowserEvents2Impl<CDonutPanelBarImpl,	ID_DONUTVIEW>,
	public IWebBrowserEvents2Impl<CDonutPanelBarImpl<T,	TParent, TBase,	TWinTraits>, ID_DONUTVIEW>,
	//+++ public CWebBrowserCommandHandler<CDonutPanelBarImpl>,
	public CWebBrowserCommandHandler<CDonutPanelBarImpl<T, TParent,	TBase, TWinTraits> >,
	//+++ public CUpdateCmdUI<CDonutPanelBarImpl>,
	public CUpdateCmdUI<CDonutPanelBarImpl<T, TParent, TBase, TWinTraits> >,
	//+++ public CChevronHandler<CDonutPanelBarImpl>,
	public CChevronHandler<CDonutPanelBarImpl<T, TParent, TBase, TWinTraits> >,
	public CWebBrowser2
{
public:
	DECLARE_WND_CLASS_EX(NULL, 0, -1)
	typedef	CDonutPanelBarImpl<T, TParent, TBase, TWinTraits> thisClass;

	CToolBarCtrl	m_wndToolBar;
	CReBarCtrl		m_wndReBar;
	CDonutView		m_view;
	CString			m_strPanelFile;
	BOOL			m_bInitNavi;

	int								m_cxyHeader;
	CPanelMenu<CDonutPanelBarImpl>	m_menuPanel;
	CMenu							m_menuPlacement;
	TParent*						m_pParent;

	enum
	{
		s_cxyBorder	= 2,
		s_cxyBtnOffset = 1,
		s_cxyViewGap = 1,
	};

	struct _ThreadParam
	{
		thisClass* pPanelBar;
		HANDLE _hExitEvent;
	};

	_ThreadParam	m_ThreadParams;
	HANDLE			m_hThread;

	CDonutPanelBarImpl():
		m_view(DLCTL_DEFAULT),
		m_menuPanel(this, ID_INSERTPOINT_PANELTYPEMENU),
		m_strPanelFile("about:blank")
	{
		m_pParent =	NULL;
		m_bInitNavi	= TRUE;
	}

	// Message map and handlers
	BEGIN_MSG_MAP(CDonutPanelBarImpl)
		PASS_MSG_MAP_MENUOWNER_TO_EXPMENU(m_menuPanel)

		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_DESTROY,	OnDestroy)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
		MESSAGE_HANDLER(WM_PAINT, OnPaint)
		MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBackground)

		COMMAND_ID_HANDLER(ID_PANEL_TYPE, OnPanelType)

		CHAIN_MSG_MAP(CChevronHandler<CDonutPanelBarImpl>)
		CHAIN_MSG_MAP(CUpdateCmdUI<CDonutPanelBarImpl>)
		CHAIN_COMMANDS(CWebBrowserCommandHandler<CDonutPanelBarImpl>)
		CHAIN_COMMANDS_MEMBER(m_view)//	CHAIN_CLIENT_COMMANDS()	not	send, why?


		NOTIFY_CODE_HANDLER(TBN_DROPDOWN, OnTbnDropDown)
		FORWARD_NOTIFICATIONS()
	END_MSG_MAP()

	LRESULT	OnPanelType(WORD /*wNotifyCode*/, WORD /*wID*/,	HWND /*hWndCtl*/, BOOL&	/*bHandled*/)
	{
		OpenFile(m_strPanelFile);
		return S_OK;
	}

	void SetTitle()
	{
		CString	strTitle;
		strTitle.Format(_T("pl:%s"), MtlGetDisplayTextFromPath(m_strPanelFile));
		SetWindowText(strTitle);
		m_pParent->SetTitle(strTitle);
	}

	void OpenFile(CString strFile)
	{
		m_strPanelFile = strFile;
		SetTitle();

		MtlRemoveStringHeaderAndFooter(strFile);

		if ( !MtlIsProtocol(strFile, _T("http")) &&
			 !MtlIsProtocol(strFile, _T("https")) )
		{
			if (MtlPreOpenFile(strFile))
				return;// handled
		}

		MtlParseIntenetShortcutFile(strFile);

		if (strFile.GetLength()	> INTERNET_MAX_PATH_LENGTH)
			return;

		Navigate2(strFile);
	}

	LRESULT	OnTbnDropDown(int idCtrl, LPNMHDR pnmh,	BOOL& bHandled)
	{
		LPNMTOOLBAR	lpnmtb = (LPNMTOOLBAR)pnmh;

		CRect rc; m_wndToolBar.GetItemRect(0, &rc);
		ClientToScreen(&rc);
		UINT uMenuFlags	= TPM_LEFTBUTTON | TPM_RIGHTBUTTON | TPM_VERTICAL |	TPM_LEFTALIGN |	TPM_TOPALIGN | (!AtlIsOldWindows() ? TPM_VERPOSANIMATION : 0);
		TPMPARAMS TPMParams;
		TPMParams.cbSize = sizeof(TPMPARAMS);
		TPMParams.rcExclude	= rc;

		switch(lpnmtb->iItem)
		{
		case ID_PANEL_TYPE:
			::TrackPopupMenuEx(m_menuPlacement.GetSubMenu(0), uMenuFlags, rc.left +	1, rc.bottom + 2, m_hWnd, &TPMParams);
			break;
		case ID_PANEL_NAVI:
			break;
		}

		return TBDDRET_DEFAULT;
	}

	LRESULT	OnCreate(UINT /*uMsg*/,	WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL&	/*bHandled*/)
	{
		DWORD dwStyle =	WS_CHILD | WS_VISIBLE;

		m_view.Create(m_hWnd, rcDefault, _T("about:blank"),
			WS_CHILD | WS_VISIBLE, WS_EX_CLIENTEDGE, ID_DONUTVIEW);
		m_wndReBar = _CreateSimpleReBarCtrl(m_hWnd,	ATL_SIMPLE_REBAR_NOBORDER_STYLE|CCS_NOPARENTALIGN);

		m_view.SetIeMenuNoCstm(TRUE);
		m_view.QueryControl(IID_IWebBrowser2, (void**)&m_spBrowser);
		WebBrowserEvents2Advise();

		m_menuPlacement.LoadMenu(IDR_PANEL_TYPE);

		CMenuHandle	menuPanel =	m_menuPlacement.GetSubMenu(0);
		m_menuPanel.SetRootDirectoryPath(_GetDonutPath()+_T("Panel"));
		m_menuPanel.SetTargetWindow(m_hWnd);
		m_menuPanel.ResetIDCount(TRUE);
		m_menuPanel.InstallExplorerMenu(menuPanel);

		if (m_bInitNavi)
		{
			// Thread Create
			m_ThreadParams._hExitEvent = ::CreateEvent(NULL, FALSE,	FALSE, NULL);
			m_ThreadParams.pPanelBar = this;
			DWORD wThreadId=0;
			m_hThread =	::CreateThread(NULL, 0,	_PanelThread,
				(LPVOID)&m_ThreadParams, 0,	&wThreadId);
			::SetThreadPriority(m_hThread ,	THREAD_PRIORITY_IDLE);
		}

		return 0;
	}

	LRESULT	OnDestroy(UINT uMsg, WPARAM	wParam,	LPARAM lParam, BOOL& bHandled)
	{
		bHandled = FALSE;

		if (m_bInitNavi)
		{
			// Thread Remove
			::SetEvent(m_ThreadParams._hExitEvent);
			DWORD dwResult = ::WaitForSingleObject(m_hThread, INFINITE);
			::CloseHandle(m_ThreadParams._hExitEvent);
			::CloseHandle(m_hThread);
		}

		_WriteProfile();
		return 0;
	}

	static DWORD WINAPI	_PanelThread(LPVOID	lpParam)
	{
		_ThreadParam* pParam = (_ThreadParam*)lpParam;
		pParam->pPanelBar->_GetProfile();
		pParam->pPanelBar->PostMessage(WM_COMMAND, ID_PANEL_TYPE);
		return 0;
	}

	void _WriteProfile()
	{
		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("Panel_Bar"));
		pr.SetValue(m_strPanelFile,	_T("LastPanel"));
	}

	void _GetProfile()
	{
		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("Panel_Bar"));

		TCHAR cBuff[MAX_PATH];
		DWORD dwCount=MAX_PATH;
		if (ERROR_SUCCESS==pr.QueryValue(cBuff,	_T("LastPanel"), &dwCount))
			m_strPanelFile = cBuff;
	}

	LRESULT	OnSize(UINT	/*uMsg*/, WPARAM /*wParam*/, LPARAM	lParam,	BOOL& /*bHandled*/)
	{
		UpdateLayout(GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam));
		return 0;
	}

	void UpdateLayout(int cxWidth, int cyHeight)
	{
		ATLASSERT(::IsWindow(m_hWnd));
		RECT rect;

		::SetRect(&rect, 0,	0, cxWidth,	m_cxyHeader);
		if(m_wndReBar.m_hWnd)
			m_wndReBar.SetWindowPos(NULL, rect.left	+ s_cxyBorder, s_cxyBorder,	rect.right - s_cxyBorder*2,	rect.bottom, SWP_NOZORDER);

		if(m_view.m_hWnd !=	NULL) {
			CRect rc(rect.left,	m_cxyHeader, cxWidth, cyHeight);
			rc.top += 1;
			rc.left	+= 1;
			rc.right -=	2;
			rc.bottom -= 2;
			m_view.SetWindowPos(NULL, rc, SWP_NOZORDER);
		}
		else
			rect.bottom	= cyHeight;

		CClientDC dc(m_hWnd);
		T* pT =	static_cast<T*>(this);
		pT->DrawPaneTitle(dc.m_hDC);
	}

	void OnBeforeNavigate2(IDispatch* pDisp, const CString&	strURL,	DWORD nFlags,
		const CString& strTargetFrameName, CSimpleArray<BYTE>& baPostedData, const CString&	strHeaders,	bool& bCancel)
	{
		ATLTRACE(_T("CDonutPanelBarImpl::BeforeNavigate2 url(%s) frame(%s)\n"),	strURL.Left(100), strTargetFrameName);
	}

	void OnNewWindow2(IDispatch** ppDisp, bool&	bCancel)
	{
		if (CMainOption::s_bAppClosing)
		{
			ATLTRACE(_T(" application closing, ignore this event\n"));
			bCancel	= true;
			return;
		}

		CChildFrame* pChild	= CChildFrame::NewWindow(g_pMainWnd->m_hWndMDIClient, g_pMainWnd->m_MDITab,	g_pMainWnd->m_AddressBar,
			true, _GetInheritedDLControlFlags());
		if (pChild == NULL)
		{
			bCancel	= true;
			return;
		}
		pChild->m_spBrowser->QueryInterface(IID_IDispatch, (void**)ppDisp);
		ATLASSERT(ppDisp !=	NULL);
	}

	DWORD _GetInheritedDLControlFlags()
	{
		DWORD dwDLFlags;
		if (_check_flag(MAIN_EX_INHERIT_OPTIONS, CMainOption::s_dwMainExtendedStyle))
			dwDLFlags =	m_view._GetDLControlFlags();
		else
			dwDLFlags =	CDLControlOption::s_dwDLControlFlags;//	default

		return dwDLFlags;
	}

	BOOL PreTranslateMessage(MSG* pMsg)
	{
		if (pMsg->message==WM_MBUTTONDOWN && ::IsChild(m_hWnd, pMsg->hwnd))
		{
			CString	strKey;
			strKey = _T("LinkOpenBtnM");

			DWORD dwLinkOpenBtnM=0;
			CIniSection	pr;
			pr.Open(_GetFilePath(_T("MouseEdit.ini")), _T("MouseCtrl"));
			pr.QueryValue(dwLinkOpenBtnM, strKey);
			if (dwLinkOpenBtnM)
			{
				::SendMessage(pMsg->hwnd, WM_LBUTTONDOWN, 0, pMsg->lParam);

				int	nTabCnt	= g_pMainWnd->m_MDITab.GetItemCount();
				LRESULT	res	= ::SendMessage(pMsg->hwnd,	WM_COMMAND,	dwLinkOpenBtnM,	0);
				if (g_pMainWnd->m_MDITab.GetItemCount()!=nTabCnt)
					return TRUE;

				::SendMessage(pMsg->hwnd, WM_LBUTTONUP,	0, pMsg->lParam);
			}
		}
		return FALSE;
	}

	CString	GetSkinPanelBarPath(BOOL bHot)
	{
		CString	strBmp;
		if (bHot)	strBmp = _T("\\PanelBarHot.bmp");
		else		strBmp = _T("\\PanelBar.bmp");
		return _GetBtnSkinDir()+strBmp;
	}

	void InitToolBar(COLORREF clrMask, UINT	nFlags = ILC_COLOR8)
	{
		CBitmap	bmp;
		bmp.Attach(AtlLoadBitmapImage(GetSkinPanelBarPath(FALSE).GetBuffer(0), LR_LOADFROMFILE));

		CBitmap	bmpHot;
		bmpHot.Attach(AtlLoadBitmapImage(GetSkinPanelBarPath(TRUE).GetBuffer(0), LR_LOADFROMFILE));

		CSize szBmp;
		if (bmp.m_hBitmap) bmp.GetSize(szBmp);

		CImageList imgs;
		imgs.Create(szBmp.cy, szBmp.cy,	nFlags | ILC_MASK, szBmp.cx/szBmp.cy, 1);

		CImageList imgsHot;
		imgsHot.Create(szBmp.cy, szBmp.cy, nFlags |	ILC_MASK, szBmp.cx/szBmp.cy, 1);

		imgs.Add(bmp, clrMask);
		imgsHot.Add(bmpHot,	clrMask);

		m_wndToolBar.Create(m_hWnd,	rcDefault, NULL,
			ATL_SIMPLE_TOOLBAR_PANE_STYLE|TBSTYLE_LIST,	0);
		m_wndToolBar.SetExtendedStyle(TBSTYLE_EX_DRAWDDARROWS);
		m_wndToolBar.SetButtonStructSize(sizeof(TBBUTTON));

		// add Add and Organize	button
		TBBUTTON btnType = { 0,	ID_PANEL_TYPE,
			TBSTATE_ENABLED, TBSTYLE_BUTTON|TBSTYLE_AUTOSIZE|BTNS_DROPDOWN,	0, 0};
		TBBUTTON btnNavi = { 1,	ID_PANEL_NAVI,
			TBSTATE_ENABLED, TBSTYLE_BUTTON|TBSTYLE_AUTOSIZE|BTNS_WHOLEDROPDOWN, 0,	0};
		m_wndToolBar.InsertButton(-1, &btnType);
//		m_wndToolBar.InsertButton(-1, &btnNavi);

		CVersional<TBBUTTONINFO> bi;
		bi.dwMask =	TBIF_TEXT;
		bi.pszText = _T("pl");
		m_wndToolBar.SetButtonInfo(ID_PANEL_TYPE, &bi);

		m_wndToolBar.SetImageList(imgs);
		m_wndToolBar.SetHotImageList(imgsHot);

		_AddSimpleReBarBandCtrl(m_wndReBar,	m_wndToolBar);

		CalcSize();
	}

	void CalcSize()
	{
		CRect rcBtn;
		m_wndToolBar.GetItemRect(0,	&rcBtn);
		m_cxyHeader	= rcBtn.Height() + s_cxyBorder;
	}

	LRESULT	OnPaint(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		CPaintDC dc(m_hWnd);

		T* pT =	static_cast<T*>(this);
		pT->DrawPaneTitle(dc.m_hDC);

		return 0;
	}

	LRESULT	OnEraseBackground(UINT /*uMsg*/, WPARAM	wParam,	LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		return 1;	// no background needed
	}

	void DrawPaneTitle(CDCHandle dc)
	{
		CRect rect;
		GetClientRect(&rect);

//		CRect rc; m_view.GetWindowRect(&rc);
//		ScreenToClient(&rc);
		CPen pen; pen.CreatePen(PS_SOLID, 1, ::GetSysColor(COLOR_3DSHADOW));
		POINT pts[]	= {	{ rect.right - 3, rect.top + m_cxyHeader },	{ rect.left, rect.top +	m_cxyHeader	},
		{ rect.left, rect.bottom - 2 } };//, { rect.right -	3, rect.bottom - 1 } };

//		CRect rect_(rect);
//		rect_.top += m_cxyHeader;
//		dc.DrawEdge(&rect_,	BDR_RAISEDINNER, BF_RECT | BF_FLAT);

//		POINT pts[]	= {	{ rc.right - 1,	rc.top - 1}, { rc.left,	rc.top - 1},
//			{ rc.left, rc.bottom },	{ rc.right - 1,	rc.bottom }	};
		HPEN hOldPen = dc.SelectPen(pen);
		dc.Polyline(pts, _countof(pts));
		dc.SelectPen(hOldPen);

		dc.DrawEdge(CRect(rect.left, rect.top +	m_cxyHeader, rect.right, rect.bottom),
			EDGE_ETCHED, BF_RIGHT |	BF_BOTTOM);

//		dc.DrawEdge(CRect(rect.left, rect.bottom - 2, rect.right - 2, rect.bottom +	10), EDGE_ETCHED, BF_TOP);

		rect.bottom	= rect.top + m_cxyHeader;
		dc.DrawEdge(&rect, EDGE_ETCHED,	BF_LEFT	| BF_TOP | BF_RIGHT	| BF_ADJUST);
		dc.FillRect(&rect, (HBRUSH)LongToPtr(COLOR_3DFACE +	1));
	}


	BEGIN_UPDATE_COMMAND_UI_MAP(CDonutPanelBarImpl)
	END_UPDATE_COMMAND_UI_MAP()
};

template <class	T>
//+++ class	CDonutPanelBar : public	CDonutPanelBarImpl<CDonutPanelBar, T>
class CDonutPanelBar : public CDonutPanelBarImpl<CDonutPanelBar<T>,	T>
{
public:
	DECLARE_WND_CLASS_EX(_T("Donut_PanelBar"), 0, -1)
};
