class CDonutStatusBarCtrl:public CMultiPaneStatusBarCtrl
{
public:
	DECLARE_WND_SUPERCLASS(_T("DonutStatusBar"), GetWndClassName())
	CDonutStatusBarCtrl() :	CMultiPaneStatusBarCtrl()
	{
		CBitmap	bmp;
		bmp.Attach(AtlLoadBitmapImage(_T("BtnSkin\\secure.bmp"), LR_LOADFROMFILE));

		CSize szIcon;
		bmp.GetSize(szIcon);
		m_imgList.Create(szIcon.cy,	szIcon.cy, ILC_COLOR8|ILC_MASK,	1, 1);
		m_imgList.Add(bmp, RGB(255,	0, 255));
	}

	std::map<int, HICON>	m_mapIcon;

	~CDonutStatusBarCtrl()
	{
		std::map<int, HICON>::iterator itIcon;
		for	( itIcon=m_mapIcon.begin();	itIcon!=m_mapIcon.end(); itIcon++ )
		{
			if ( itIcon->second	)
				DestroyIcon( itIcon->second	);
		}
	}

	void SetIcon(int nIdPane, int nIndexIcon)
	{
		HICON hIcon=NULL;
		if (nIndexIcon!=USHRT_MAX)
		{
			if ( m_mapIcon[nIndexIcon] == NULL)
			{
				m_mapIcon[nIndexIcon] =	m_imgList.ExtractIcon(nIndexIcon);
			}
			hIcon =	m_mapIcon[nIndexIcon];
		}

		SetPaneIcon(nIdPane, hIcon);
	}

	void SetCommand(int	nPaneID, int nCommand)
	{
		m_mapCmdID.Add(nPaneID,	nCommand);
	}

private:
	CImageList m_imgList;
	CCrasyMap<int, int>		m_mapCmdID;			// CmdID

	BEGIN_MSG_MAP(CDonutStatusBarCtrl)
		MSG_WM_LBUTTONDBLCLK(OnLButtonDblClk)
		MESSAGE_HANDLER(WM_STATUS_SETICON, OnSetIcon)
		CHAIN_MSG_MAP(CMultiPaneStatusBarCtrl)
	END_MSG_MAP()

	LRESULT	OnSetIcon(UINT uMsg, WPARAM	wParam,	LPARAM lParam, BOOL& bHandled)
	{
		int	nIdPane	= LOWORD(wParam);
		int	nIndexIcon = HIWORD(wParam);
		SetIcon(nIdPane, nIndexIcon);
		return S_OK;
	}

	void OnLButtonDblClk(UINT nFlags, CPoint point)
	{
		SetMsgHandled(FALSE);

		for	(int nIndex=0; nIndex<m_nPanes;	nIndex++)
		{
			CRect rcPane;
			GetRect(nIndex,	&rcPane);

			if (!rcPane.PtInRect(point)) continue;

			int	nCommand=0;
			nCommand = m_mapCmdID.Lookup(m_pPane[nIndex]);
			if ( nCommand==0 ) continue;
			::PostMessage(GetTopLevelParent(), WM_COMMAND, nCommand, 0);
		}

	}
};