
#include "OleDragDropExpTreeViewCtrl.h"
#include "ChevronHandler.h"
#include <URLHIST.H>
#include <shlguid.h> //	needed for CLSID_CUrlHistory
#include <atldef.h>
#include "comdef.h"
#include "wtypes.h"

//GetUrlCacheEntryInfo

class CFavoritesTreeViewCtrl :
	public COleDragDrogExplorerTreeViewCtrlImpl<CFavoritesTreeViewCtrl>
{
public:
	DECLARE_WND_SUPERCLASS(_T("Mtl_FavTreeViewCtrl"), GetWndClassName())
	typedef	COleDragDrogExplorerTreeViewCtrlImpl<CFavoritesTreeViewCtrl> baseClass;
	typedef	CFavoritesTreeViewCtrl thisClass;

// Constants
	enum { s_nIDOpenAll	= 10, };

// Ctor/dtor

// Attributes
	bool _IsNeedFavoritesFix()
	{
		if (_check_flag(ETV_EX_FAVORITES, GetExplorerTreeViewExtendedStyle()) || _check_flag(ETV_EX_USERDEFINED, GetExplorerTreeViewExtendedStyle()))
			return true;
		else
			return false;
	}

// Overrides
	void OnExplorerTreeViewInit()
	{
		baseClass::OnExplorerTreeViewInit();

		_GetProfile();
	}

	void OnExplorerTreeViewTerm()
	{
		baseClass::OnExplorerTreeViewTerm();

		_WriteProfile();
	}

	void OnChangeImageList()
	{
		if (_check_flag(ETV_EX_FAVORITES, GetExplorerTreeViewExtendedStyle()) && m_bOrgImage)
		{
			SetImageList(m_imgDonut.m_hImageList, TVSIL_NORMAL);
		}
		else
		{
			SHFILEINFO sfi;
			HIMAGELIST hImgs = (HIMAGELIST)::SHGetFileInfo(_T("C:\\"), 0, &sfi,	sizeof(sfi),
				SHGFI_SYSICONINDEX | SHGFI_SMALLICON);

			ATLASSERT(hImgs	!= NULL);
			SetImageList(hImgs,	TVSIL_NORMAL);
		}
	}

	CItemIDList	OnInitRootFolder()
	{
		// change Image
		OnChangeImageList();

		if (_check_flag(ETV_EX_MYCOMPUTER, GetExplorerTreeViewExtendedStyle()))	{
			CItemIDList	idl;
			HRESULT	hr = ::SHGetSpecialFolderLocation(m_hWnd, CSIDL_DESKTOP, &idl);
			ATLASSERT(SUCCEEDED(hr));
			return idl;
		}
		else if	(_check_flag(ETV_EX_FAVORITEGROUP, GetExplorerTreeViewExtendedStyle()))	{
			CString	strDir = DonutGetFavoriteGroupFolder();
			//+++ return strDir;
			return LPCTSTR(strDir);
		}
		else if	(_check_flag(ETV_EX_USERDEFINED, GetExplorerTreeViewExtendedStyle())) {
			//+++ return CFavoritesMenuOption::GetUserDirectory();
			return LPCTSTR(	CFavoritesMenuOption::GetUserDirectory() );
		}
		else if	(_check_flag(ETV_EX_SCRIPT,	GetExplorerTreeViewExtendedStyle())) {
			//+++ return _GetDonutPath() + _T("Script\\");
			return LPCTSTR(	_GetDonutPath()	+ _T("Script\\") );
		}
		// UDT DGSTR ꂫ
		else if	(_check_flag(ETV_EX_HISTORY, GetExplorerTreeViewExtendedStyle())) {
			CItemIDList	idl;
			if (_check_flag(ETV_EX_HISTORY_TIME, GetExplorerTreeViewExtendedStyle()))
				return idl;

			HRESULT	hr = ::SHGetSpecialFolderLocation(m_hWnd, CSIDL_HISTORY, &idl);
			ATLASSERT(SUCCEEDED(hr));
			return idl;
		}
		else if	(_check_flag(ETV_EX_HISTORY, GetExplorerTreeViewExtendedStyle())) {
			CString	strDir;
			CItemIDList	idl;
			if(MtlGetHistoryFolder(strDir))	{
				//+++ return strDir;
				return LPCTSTR(strDir);
			} else {
			HRESULT	hr = ::SHGetSpecialFolderLocation(m_hWnd, CSIDL_HISTORY, &idl);
			ATLASSERT(SUCCEEDED(hr));
			return idl;
			}
		}
		// ENDE
		else {
			CString	strDir;	MtlGetFavoritesFolder(strDir);
			//+++ return strDir;
			return LPCTSTR(strDir);
		}
	}

	// U.H
	void OnFolderEmpty()
	{
		if (!_check_flag(ETV_EX_HISTORY, GetExplorerTreeViewExtendedStyle()))
			return;

		SYSTEMTIME sysTimeNow;
		::GetSystemTime(&sysTimeNow);
		::GetLocalTime(&sysTimeNow);

		CSimpleMap<CString,	HTREEITEM> mapRoot;

		IUrlHistoryStg2* pHistory;
		IEnumSTATURL* pEnumUrls;
		ULONG ulFetched=1;

		CoInitialize(NULL);
		HRESULT	hr = CoCreateInstance(CLSID_CUrlHistory, NULL, CLSCTX_INPROC_SERVER,
			IID_IUrlHistoryStg,	reinterpret_cast<void**>(&pHistory));
		if (SUCCEEDED(hr))
		{
			pHistory->EnumUrls(&pEnumUrls);
			LPCOLESTR lpFilter=OLESTR("http");
			pEnumUrls->SetFilter(lpFilter,STATURLFLAG_ISTOPLEVEL);
			_STATURL StatUrl;
			while ((hr = pEnumUrls->Next(1,	&StatUrl, &ulFetched)) == S_OK)
			{
			  #if 1	//+++ _bstr_t g _com_utl::ConvertBSTRToStringȂAƃRpCɓ{̂ŁAĂ݂.
				// Err
				if (StatUrl.pwcsTitle==NULL)	continue;
				if (StatUrl.pwcsUrl==NULL)		continue;

				// 
				CString		strUrl((LPCTSTR)StatUrl.pwcsUrl);
				CString		strTitle((LPCTSTR)StatUrl.pwcsTitle);
				FILETIME	ftLocal;
				SYSTEMTIME	sysTimeHist;
				FileTimeToLocalFileTime(&StatUrl.ftLastVisited,	&ftLocal);
				FileTimeToSystemTime(&ftLocal, &sysTimeHist);
			  #else
				_bstr_t	bstrUrl, bstrTitle;

				// Err
				if (StatUrl.pwcsTitle==NULL)	continue;
				if (StatUrl.pwcsUrl==NULL)		continue;

				// 
				bstrUrl	= StatUrl.pwcsUrl;
				bstrTitle =	StatUrl.pwcsTitle;
				FILETIME ftLocal;
				SYSTEMTIME sysTimeHist;
				FileTimeToLocalFileTime(&StatUrl.ftLastVisited,	&ftLocal);
				FileTimeToSystemTime(&ftLocal, &sysTimeHist);
				CString	strTitle((LPCTSTR)bstrTitle);
				CString	strUrl((LPCTSTR)bstrUrl);
			  #endif

/*				INTERNET_CACHE_ENTRY_INFO entryInfo;
				memset(&entryInfo, 0, sizeof(INTERNET_CACHE_ENTRY_INFO));
				entryInfo.dwStructSize = sizeof(INTERNET_CACHE_ENTRY_INFO);
				DWORD dwSize=0;
				::GetUrlCacheEntryInfo(strUrl, &entryInfo, &dwSize);
				::GetUrlCacheEntryInfo(strUrl, &entryInfo, &dwSize);
*/
				// Ώ̂́Â
				if (sysTimeHist.wYear	!= sysTimeNow.wYear)	continue;
				if (sysTimeHist.wMonth	!= sysTimeNow.wMonth)	continue;
				if (sysTimeHist.wDay	!= sysTimeNow.wDay)		continue;

				CString	strTime;
				strTime.Format(_T("%02d "), sysTimeHist.wHour);
				HTREEITEM hParent =	mapRoot.Lookup(strTime);
				if (hParent==NULL)
				{
					hParent	= AddItem(strTime);
					mapRoot.Add(strTime, hParent);
				}

				// TreeItem
				LPTSTR lpszText	= NULL;
				ATLTRY(lpszText	= new TCHAR[strTitle.GetLength() + 1]);
				::lstrcpy(lpszText,	strTitle);

				TV_INSERTSTRUCT	tvis;
				tvis.hParent = hParent;
				tvis.item.mask = TVIF_TEXT | TVIF_IMAGE	| TVIF_SELECTEDIMAGE | TVIF_PARAM;
				tvis.item.pszText =	lpszText;
				tvis.item.iImage = I_IMAGECALLBACK;//MtlGetNormalIconIndex(idlFull,	_pidlHtm);
				tvis.item.iSelectedImage = I_IMAGECALLBACK;//MtlGetSelectedIconIndex(idlFull, false, _pidlHtm);
				tvis.hInsertAfter =	TVI_SORT;

				// set up full item	id list!
				CItemIDList	idlFull(strUrl);

				// set up!!
				tvis.item.lParam = (LPARAM)idlFull.m_pidl;
				idlFull.Detach();//	*********don't forget clean	up the lParam!!!!!!!********

				// ǉ
				InsertItem(&tvis);
				delete [] lpszText;
			}
			pEnumUrls->Release();
		}
		pHistory->Release(); //	release	our	reference
		CoUninitialize();
	}

	HTREEITEM AddItem(CString strText)
	{
		// TreeItem
		LPTSTR lpszText	= NULL;
		ATLTRY(lpszText	= new TCHAR[strText.GetLength()	+ 1]);
		::lstrcpy(lpszText,	strText);

		CString	strDir;
		MtlGetHistoryFolder(strDir);
		CItemIDList	idlHist(strDir);

		TV_INSERTSTRUCT	tvis;
		tvis.hParent = NULL;
		tvis.item.mask = TVIF_TEXT | TVIF_IMAGE	| TVIF_SELECTEDIMAGE | TVIF_PARAM;
		tvis.item.pszText =	lpszText;
		tvis.item.iImage = MtlGetNormalIconIndex(idlHist);
		tvis.item.iSelectedImage = MtlGetSelectedIconIndex(idlHist,	true);
		tvis.item.mask |= TVIF_CHILDREN;
		tvis.item.cChildren	= 1;
		tvis.hInsertAfter =	TVI_SORT;

		// set up full item	id list!
		CItemIDList	idlFull(strText);
		// set up!!
		tvis.item.lParam = (LPARAM)idlFull.m_pidl;
		idlFull.Detach();//	*********don't forget clean	up the lParam!!!!!!!********

		HTREEITEM hItem	= InsertItem(&tvis);
		delete [] lpszText;
		return hItem;
	}


	void OnInitialUpdateTreeItems(CSimpleArray<TV_INSERTSTRUCT>& items,	LPCITEMIDLIST pidl)
	{
		ATLASSERT(pidl != NULL);

		DWORD dwStyle =	CFavoritesMenuOption::GetStyle();
		if (_check_flag(EMS_ORDER_FAVORITES, dwStyle) && _check_flag(ETV_EX_FAVORITES, GetExplorerTreeViewExtendedStyle()))	{
			CFavoritesOrder	order;
			MtlGetFavoritesOrder(order,	CItemIDList(pidl).GetPath());
			std::sort(_begin(items), _end(items), _FavoritesTreeItemCompare<thisClass>(order, this));
		}
		else if	(_check_flag(ETV_EX_HISTORY, GetExplorerTreeViewExtendedStyle())){}	// UDT DGSTR ꂫ
		else {
			baseClass::OnInitialUpdateTreeItems(items, pidl);
		}
	}

//	void OnOpenTreeItem(HTREEITEM hItem, LPITEMIDLIST pidl)
//	{
//		if (_check_flag(ETV_EX_MYCOMPUTER, GetExplorerTreeViewExtendedStyle()))	{
//			MtlShellExecute(m_hWnd,	pidl);
//			return;
//		}

//		CItemIDList	idl(pidl);
//		if (!idl.IsNull())
//			DonutOpenFile(m_hWnd, idl.GetPath(), DonutGetStdOpenFlag());
//	}

	void OnTreeItemClicked(HTREEITEM hTreeItem,	UINT uFlags)
	{
		if ( !_check_flag(ETV_EX_FAVORITEGROUP,	GetExplorerTreeViewExtendedStyle())	&&
			 ( _check_flag(ETV_EX_MYCOMPUTER|ETV_EX_SHELLEXECUTE|ETV_EX_HISTORY|ETV_EX_SCRIPT, GetExplorerTreeViewExtendedStyle())))
		{
			MtlShellExecute(m_hWnd,	_GetItemIDList(hTreeItem));
			return;
		}

		HWND hWnd =	NULL;
		CItemIDList	idl	= _GetItemIDList(hTreeItem);

		if (!idl.IsNull())
			hWnd = DonutOpenFile(m_hWnd, idl.GetPath(),	DonutGetStdOpenFlag());

		if (m_hWnd)	{	//+++ `FbNǉ.
			CWindow	wnd(m_hWnd);
			::SetFocus(wnd.GetTopLevelWindow());
		}
	}

	bool OnGetInfoToolTip(HTREEITEM	hItem, CString&	strTip,	int	cchTextMax)
	{
		if (_IsItemFolder(hItem))
			return false;

		CItemIDList	idl	= _GetItemIDList(hItem);
		if (idl.IsNull())
			return false;

		// ԑѕʗ
		if (_check_flag(ETV_EX_HISTORY|ETV_EX_HISTORY_TIME,	GetExplorerTreeViewExtendedStyle()))
		{
			CString	strText;
			GetItemText(hItem, strText);

//			strTip = MtlMakeFavoriteToolTipText(strTitle,strUrl, cchTextMax);
			strTip = strText;
			return true;
		}

		CString	strPath	= idl.GetPath();
		if (strPath.IsEmpty())
			return false;

		CString	strUrl = MtlGetInternetShortcutUrl(strPath);
		if (strUrl.IsEmpty())
			strUrl = strPath;

		CString	strName;
		if (!GetItemText(hItem,	strName))
			return false;

		strTip = MtlMakeFavoriteToolTipText(strName, strUrl, cchTextMax);
		return true;
	}

	bool OnCmdContextMenu(HTREEITEM	hTreeItem, int nID)
	{
		if (nID	!= s_nIDOpenAll)
			return false;

		MtlForEachFile(_GetItemIDList(hTreeItem), _Function_OpenFile(m_hWnd));
		return true;
	}

	struct _Function_OpenFile
	{
		HWND _hWnd;

		_Function_OpenFile(HWND	hWnd) :	_hWnd(hWnd)	{ }

		void operator()(IShellFolder* pFolder, const CItemIDList& idlFolder, const CItemIDList&	idlFile)
		{
			CItemIDList	idlFull	= idlFolder	+ idlFile;
			if (!idlFull.IsNull())
				DonutOpenFile(_hWnd, idlFull.GetPath());
		}
	};

	UINT OnPrepareMenuForContext(HTREEITEM hTreeItem, CMenuHandle menu,	int& nPos)
	{
		bool bFolder = _IsItemFolder(hTreeItem);
		UINT uFlags	= CMF_CANRENAME;

		if (bFolder)
			uFlags |= CMF_EXPLORE |	CMF_NODEFAULT;
		else
			uFlags |= CMF_NORMAL;

		if (!_IsNeedFavoritesFix())
			return uFlags;

		// set up for favorites
		if (bFolder) {
			if (_IsItemExpanded(hTreeItem))
				menu.AppendMenu(MF_ENABLED|MF_STRING, s_nIDCollapse, _T("܂肽(&A)"));
			else
				menu.AppendMenu(MF_ENABLED|MF_STRING, s_nIDExpand, _T("WJ(&A)"));

			menu.AppendMenu(MF_ENABLED|MF_STRING, s_nIDOpenAll,	_T("gׂĊJ(&I)"));
			menu.AppendMenu(MF_ENABLED|MF_STRING, s_nIDNewFolder, _T("VtH_쐬(&W)"));
			menu.AppendMenu(MF_SEPARATOR);
			nPos +=	4;
		}
		else {

		}

		return uFlags;
	}

	void OnPrepareMenuForPopup(HTREEITEM hTreeItem,	CMenuHandle	menu)
	{
		if (!_IsNeedFavoritesFix())
			return;

		int	nCmdID = MtlGetCmdIDFromAccessKey(menu,	_T("&S"));// remove	"create	shortcut" menu item
		if (nCmdID != -1)
			menu.RemoveMenu(nCmdID,	MF_BYCOMMAND);

		if (!_IsItemFolder(hTreeItem)) {
			int	nCmdID = MtlGetCmdIDFromAccessKey(menu,	_T("&O"), false);//	remove original	"open" menu	item
			if (nCmdID != -1)
				menu.RemoveMenu(nCmdID,	MF_BYCOMMAND);

			menu.InsertMenu(0, MF_BYPOSITION|MF_STRING,	s_nIDNewFolder,	_T("VtH_쐬(&W)"));
			menu.InsertMenu(0, MF_BYPOSITION|MF_STRING,	s_nIDOpen, _T("J(&O)"));

			menu.SetMenuDefaultItem(s_nIDOpen, FALSE);
		}
	}

	template <class	_This>
	struct _FavoritesTreeItemCompare : public std::binary_function<const TV_INSERTSTRUCT&, const TV_INSERTSTRUCT&, bool>
	{
		CFavoritesOrder& _order;
		_This* _pThis;

		_FavoritesTreeItemCompare(CFavoritesOrder& order, _This* pThis)	: _order(order), _pThis(pThis) { }

		bool operator()(const TV_INSERTSTRUCT& x, const	TV_INSERTSTRUCT& y)
		{
			CItemIDList	idlA = (LPCITEMIDLIST)x.item.lParam; ATLASSERT(!idlA.IsNull());
			CItemIDList	idlB = (LPCITEMIDLIST)y.item.lParam; ATLASSERT(!idlB.IsNull());

			const int enough = 10000;
			CString	strA = MtlGetFileName(idlA.GetPath());
			CString	strB = MtlGetFileName(idlB.GetPath());
			ATLASSERT(!strA.IsEmpty() && !strB.IsEmpty());

			int	itA	= _order.Lookup(strA);
			int	itB	= _order.Lookup(strB);
			if (itA	== -1 || itA ==	FAVORITESORDER_NOTFOUND)// fixed by	fub, thanks.
				itA	= enough;
			if (itB	== -1 || itB ==	FAVORITESORDER_NOTFOUND)
				itB	= enough;

			if (itA	== enough && itB ==	enough)	{
				bool bParentA =	(x.item.cChildren == 1);
				bool bParentB =	(y.item.cChildren == 1);
				if (bParentA ==	bParentB) {
					return strA	< strB;
				}
				else {
					if (bParentA)
						return true;
					else
						return false;
				}
			}
			else
				return itA < itB;
		}

		CString	_GetFileName(const TV_INSERTSTRUCT&	tvi)
		{
			bool bDir =	(tvi.item.cChildren	== 1);
			if (bDir) {
				return tvi.item.pszText;
			}

			CItemIDList	idl	= (LPCITEMIDLIST)tvi.item.lParam;
			CString	str	= idl.GetPath();

			if (str.IsEmpty())
				return CString();

			int	nIndex = str.ReverseFind(_T('\\'));
			str	= str.Right(str.GetLength()	- nIndex - 1);

			return str;
		}

		CString	_GetFilePath(const TV_INSERTSTRUCT&	tvi)
		{
			CItemIDList	idl	= (LPCITEMIDLIST)tvi.item.lParam;
			CString	str	= idl.GetPath();
			return str;
		}

		FILETIME _GetFileTime(const	CString& strPath_)
		{
			CString	strPath(strPath_);
			MtlRemoveTrailingBackSlash(strPath);
			WIN32_FIND_DATA	data;
			HANDLE h = ::FindFirstFile(strPath,	&data);
			ATLASSERT(h	!= INVALID_HANDLE_VALUE);
			::FindClose(h);

			return data.ftCreationTime;
		}
	};

	void _GetProfile()
	{
		CIniSection	pr;
		CString	strSection = _T("FavTree");

		pr.Open(_szIniFileName,	strSection);
		DWORD dwStyle =	ETV_EX_FAVORITES | ETV_EX_SINGLEEXPAND;// default
		pr.QueryValue(dwStyle, _T("Style"));
		pr.Close();

		SetExplorerTreeViewExtendedStyle(dwStyle);
	}

	void _WriteProfile()
	{
		CIniSection	pr;
		CString	strSection = _T("FavTree");

		pr.Open(_szIniFileName,	strSection);
		pr.SetValue(GetExplorerTreeViewExtendedStyle(),	_T("Style"));
		pr.Close();
	}
};


template <class	T, class TBase = CWindow, class	TWinTraits = CControlWinTraits>
class CDonutFavoritesBarImpl :
	public CWindowImpl<	T, TBase, TWinTraits >,
	//+++ public CChevronHandler<CDonutFavoritesBarImpl>,
	public CChevronHandler<CDonutFavoritesBarImpl<T, TBase,	TWinTraits>	>,
	//+++ public CUpdateCmdUI<CDonutFavoritesBarImpl>
	public CUpdateCmdUI<CDonutFavoritesBarImpl<T, TBase, TWinTraits> >
{
public:
	DECLARE_WND_CLASS_EX(NULL, 0, -1)
	typedef	CDonutFavoritesBarImpl<T, TBase, TWinTraits> thisClass;

// Constants
	enum
	{
		s_cxyBorder	= 2,
		s_cxyBtnOffset = 1,
		s_cxyViewGap = 1,
	};

// Data	members
	CToolBarCtrl m_wndToolBar;
	CReBarCtrl	m_wndReBar;
	CFavoritesTreeViewCtrl m_view;
	int	m_cxyHeader;
	CMenu m_menuPlacement;

// Ctor
	CDonutFavoritesBarImpl()
	{
		m_menuPlacement.LoadMenu(IDR_MENU_FAVTREE_BAR);
	}

// Overrides
	HMENU OnGetDropDownMenu(int	nCmdID,	HMENU& hMenuDestroy)
	{
		return m_menuPlacement.GetSubMenu(0);
	}

// Methods
	BYTE PreTranslateMessage(MSG* pMsg)
	{
		UINT msg = pMsg->message;
		int	vKey =	pMsg->wParam;

		if (msg	== WM_SYSKEYDOWN ||	msg	== WM_SYSKEYUP || msg == WM_KEYDOWN) {

			if (m_view.m_hWnd && pMsg->hwnd	== m_view.GetEditControl())
				return _MTL_TRANSLATE_WANT;// pass to rename edit ctrl

			if (pMsg->hwnd != m_view.m_hWnd	|| !m_view.IsWindowVisible())
				return _MTL_TRANSLATE_PASS;

			if (vKey ==	VK_LEFT	|| vKey	== VK_RIGHT	|| vKey	== VK_DOWN || vKey == VK_UP	||
				vKey ==	VK_RETURN || vKey == VK_SPACE) {
				return _MTL_TRANSLATE_WANT;// pass to control
			}
		}

		return _MTL_TRANSLATE_PASS;
	}

	// Message map and handlers
	BEGIN_MSG_MAP(CDonutFavoritesBarImpl)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
		MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
		MESSAGE_HANDLER(WM_DESTROY,	OnDestroy)
		MESSAGE_HANDLER(WM_PAINT, OnPaint)
		MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBackground)

		COMMAND_ID_HANDLER(ID_FAVORITE_PLACEMENT, OnFavoritePlacement)
		COMMAND_ID_HANDLER(ID_VIEW_REFRESH_FAVBAR, OnFavoritePlacement)

		COMMAND_ID_HANDLER(ID_FAVTREE_BAR_SCRIPT, OnFavTreeScript)
		COMMAND_ID_HANDLER(ID_FAVTREE_BAR_STANDARD,	OnFavTreeStandard)
		COMMAND_ID_HANDLER(ID_FAVTREE_BAR_GROUP, OnFavTreeGroup)
		COMMAND_ID_HANDLER(ID_FAVTREE_BAR_USER,	OnFavTreeUser)
		COMMAND_ID_HANDLER(ID_FAVTREE_BAR_MYCOMPUTER, OnFavTreeMyComputer)
		COMMAND_ID_HANDLER(ID_FAVTREE_BAR_SHELLEXECUTE,	OnFavTreeShellExecute)
		COMMAND_ID_HANDLER(ID_FAVTREE_BAR_LOADREMOTEICON, OnFavTreeLoadRemoteIcon)
		COMMAND_ID_HANDLER(ID_FAVTREE_BAR_SINGLEEXPAND,	OnFavTreeSingleExpand)
		COMMAND_ID_HANDLER(ID_FAVTREE_BAR_HISTORY, OnFavTreeHistory) //	UDT	DGSTR ꂫ
		COMMAND_ID_HANDLER(ID_FAVTREE_BAR_HISTORY_TIME,	OnFavTreeHistoryTime)

		NOTIFY_CODE_HANDLER(TBN_DROPDOWN, OnTbnDropDown)

		CHAIN_MSG_MAP(CChevronHandler<CDonutFavoritesBarImpl>)
		CHAIN_MSG_MAP(CUpdateCmdUI<CDonutFavoritesBarImpl>)
		FORWARD_NOTIFICATIONS()
	END_MSG_MAP()

	LRESULT	OnFavTreeStandard(WORD /*wNotifyCode*/,	WORD /*wID*/, HWND /*hWndCtl*/,	BOOL& /*bHandled*/)
	{
		BOOL bNowThis =	_check_flag(ETV_EX_FAVORITES, m_view.GetExplorerTreeViewExtendedStyle()) ;
		m_view.ModifyExplorerTreeViewExtendedStyle(ETV_EX_FOLDERS, ETV_EX_FAVORITES);

		SendMessage(GetTopLevelParent(), WM_UPDATE_EXPBAR, (WPARAM)_T("Cɓ"), (LPARAM)0); //	UDT	DGSTR ꂫ

		m_wndToolBar.UpdateWindow();
		if (!bNowThis) m_view.RefreshRootTree();

		return 0;
	}

	LRESULT	OnFavTreeGroup(WORD	/*wNotifyCode*/, WORD /*wID*/, HWND	/*hWndCtl*/, BOOL& /*bHandled*/)
	{
		BOOL bNowThis =	_check_flag(ETV_EX_FAVORITEGROUP, m_view.GetExplorerTreeViewExtendedStyle());
		m_view.ModifyExplorerTreeViewExtendedStyle(ETV_EX_FOLDERS, ETV_EX_FAVORITEGROUP);

		SendMessage(GetTopLevelParent(), WM_UPDATE_EXPBAR, (WPARAM)_T("CɓO[v"), (LPARAM)0); //	UDT	DGSTR ꂫ

		m_wndToolBar.UpdateWindow();
		if (!bNowThis) m_view.RefreshRootTree();

		return 0;
	}
	LRESULT	OnFavTreeUser(WORD /*wNotifyCode*/,	WORD /*wID*/, HWND /*hWndCtl*/,	BOOL& /*bHandled*/)
	{
		BOOL bNowThis =	_check_flag(ETV_EX_USERDEFINED,	m_view.GetExplorerTreeViewExtendedStyle());
		m_view.ModifyExplorerTreeViewExtendedStyle(ETV_EX_FOLDERS, ETV_EX_USERDEFINED);

		SendMessage(GetTopLevelParent(), WM_UPDATE_EXPBAR, (WPARAM)_T("[U`"), (LPARAM)0); //	UDT	DGSTR ꂫ

		m_wndToolBar.UpdateWindow();
		if (!bNowThis) m_view.RefreshRootTree();

		return 0;
	}
	LRESULT	OnFavTreeMyComputer(WORD /*wNotifyCode*/, WORD /*wID*/,	HWND /*hWndCtl*/, BOOL&	/*bHandled*/)
	{
		BOOL bNowThis =	_check_flag(ETV_EX_MYCOMPUTER, m_view.GetExplorerTreeViewExtendedStyle());
		m_view.ModifyExplorerTreeViewExtendedStyle(ETV_EX_FOLDERS, ETV_EX_MYCOMPUTER);

		SendMessage(GetTopLevelParent(), WM_UPDATE_EXPBAR, (WPARAM)_T("fXNgbv"), (LPARAM)0); // UDT DGSTR	ꂫ

		m_wndToolBar.UpdateWindow();
		if (!bNowThis) m_view.RefreshRootTree();

		return 0;
	}
	// UDT DGSTR ꂫ
	LRESULT	OnFavTreeHistory(WORD /*wNotifyCode*/, WORD	/*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		BOOL bNowThis =	_check_flag(ETV_EX_HISTORY,	m_view.GetExplorerTreeViewExtendedStyle());
		m_view.ModifyExplorerTreeViewExtendedStyle(ETV_EX_FOLDERS, ETV_EX_HISTORY);

		SendMessage(GetTopLevelParent(), WM_UPDATE_EXPBAR, (WPARAM)_T(""), (LPARAM)0); // UDT DGSTR

		m_wndToolBar.UpdateWindow();
		if (!bNowThis) m_view.RefreshRootTree();

		return 0;
	}
	// ENDE

	// U.H
	LRESULT	OnFavTreeHistoryTime(WORD /*wNotifyCode*/, WORD	/*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		if (_check_flag(ETV_EX_HISTORY_TIME, m_view.GetExplorerTreeViewExtendedStyle()))
			m_view.ModifyExplorerTreeViewExtendedStyle(ETV_EX_HISTORY_TIME,	0);
		else
			m_view.ModifyExplorerTreeViewExtendedStyle(0, ETV_EX_HISTORY_TIME);

		m_wndToolBar.UpdateWindow();
		m_view.RefreshRootTree();
		return 0;
	}

	LRESULT	OnFavTreeScript(WORD /*wNotifyCode*/, WORD /*wID*/,	HWND /*hWndCtl*/, BOOL&	/*bHandled*/)
	{
		BOOL bNowThis =	_check_flag(ETV_EX_SCRIPT, m_view.GetExplorerTreeViewExtendedStyle()) ;
		m_view.ModifyExplorerTreeViewExtendedStyle(ETV_EX_FOLDERS, ETV_EX_SCRIPT);

		SendMessage(GetTopLevelParent(), WM_UPDATE_EXPBAR, (WPARAM)_T("XNvg"), (LPARAM)0);

		m_wndToolBar.UpdateWindow();
		if (!bNowThis) m_view.RefreshRootTree();

		return 0;
	}
	// ^^^

	LRESULT	OnFavTreeShellExecute(WORD /*wNotifyCode*/,	WORD /*wID*/, HWND /*hWndCtl*/,	BOOL& /*bHandled*/)
	{
		if (_check_flag(ETV_EX_SHELLEXECUTE, m_view.GetExplorerTreeViewExtendedStyle()))
			m_view.ModifyExplorerTreeViewExtendedStyle(ETV_EX_SHELLEXECUTE,	0);
		else
			m_view.ModifyExplorerTreeViewExtendedStyle(0, ETV_EX_SHELLEXECUTE);

		return 0;
	}
	LRESULT	OnFavTreeLoadRemoteIcon(WORD /*wNotifyCode*/, WORD /*wID*/,	HWND /*hWndCtl*/, BOOL&	/*bHandled*/)
	{
		if (_check_flag(ETV_EX_LOADREMOTEICON, m_view.GetExplorerTreeViewExtendedStyle()))
			m_view.ModifyExplorerTreeViewExtendedStyle(ETV_EX_LOADREMOTEICON, 0);
		else
			m_view.ModifyExplorerTreeViewExtendedStyle(0, ETV_EX_LOADREMOTEICON);

		m_wndToolBar.UpdateWindow();
		m_view.RefreshRootTree();

		return 0;
	}
	LRESULT	OnFavoritePlacement(WORD /*wNotifyCode*/, WORD /*wID*/,	HWND /*hWndCtl*/, BOOL&	/*bHandled*/)
	{
		m_wndToolBar.UpdateWindow();
		m_view.RefreshRootTree();
		return 0;
	}
	LRESULT	OnFavTreeSingleExpand(WORD /*wNotifyCode*/,	WORD /*wID*/, HWND /*hWndCtl*/,	BOOL& /*bHandled*/)
	{
		if (_check_flag(ETV_EX_SINGLEEXPAND, m_view.GetExplorerTreeViewExtendedStyle()))
			m_view.ModifyExplorerTreeViewExtendedStyle(ETV_EX_SINGLEEXPAND,	0);
		else
			m_view.ModifyExplorerTreeViewExtendedStyle(0, ETV_EX_SINGLEEXPAND);

		m_wndToolBar.UpdateWindow();
		m_view.RefreshRootTree();

		return 0;
	}

	LRESULT	OnTbnDropDown(int /*idCtrl*/, LPNMHDR pnmh,	BOOL& bHandled)
	{
		LPNMTOOLBAR	lpnmtb = (LPNMTOOLBAR)pnmh;

		CRect rc; m_wndToolBar.GetItemRect(0, &rc);
		ClientToScreen(&rc);
		UINT uMenuFlags	= TPM_LEFTBUTTON | TPM_RIGHTBUTTON | TPM_VERTICAL |	TPM_LEFTALIGN |	TPM_TOPALIGN | (!AtlIsOldWindows() ? TPM_VERPOSANIMATION : 0);
		TPMPARAMS TPMParams;
		TPMParams.cbSize = sizeof(TPMPARAMS);
		TPMParams.rcExclude	= rc;

		::TrackPopupMenuEx(m_menuPlacement.GetSubMenu(0), uMenuFlags, rc.left +	1, rc.bottom + 2, m_hWnd, &TPMParams);

		return TBDDRET_DEFAULT;
	}

	LRESULT	OnPaint(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		CPaintDC dc(m_hWnd);

		T* pT =	static_cast<T*>(this);
		pT->DrawPaneTitle(dc.m_hDC);

		return 0;
	}

	LRESULT	OnEraseBackground(UINT /*uMsg*/, WPARAM	wParam,	LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		return 1;	// no background needed
	}

	LRESULT	OnDestroy(UINT /*uMsg*/, WPARAM	/*wParam*/,	LPARAM /*lParam*/, BOOL& bHandled)
	{
		bHandled = FALSE;
		MtlDestroyImageLists(m_hWnd);
		return 0;
	}

	LRESULT	OnCreate(UINT /*uMsg*/,	WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL&	/*bHandled*/)
	{
		DWORD dwStyle =	WS_CHILD | WS_VISIBLE |	WS_CLIPSIBLINGS	| WS_CLIPCHILDREN |
			TVS_INFOTIP	| TVS_EDITLABELS | TVS_SHOWSELALWAYS | TVS_SINGLEEXPAND	| TVS_FULLROWSELECT	| TVS_TRACKSELECT;

		if ((CMainOption::s_dwExplorerBarStyle&MAIN_EXPLORER_HSCROLL)!=MAIN_EXPLORER_HSCROLL)
			dwStyle	|= TVS_NOHSCROLL;
		m_view.Create(m_hWnd, rcDefault, NULL, dwStyle,	0);//WS_EX_STATICEDGE);


		m_wndReBar = _CreateSimpleReBarCtrl(m_hWnd,	ATL_SIMPLE_REBAR_NOBORDER_STYLE|CCS_NOPARENTALIGN);

		CFavoritesMenuOption::Add(m_hWnd);

		return 0;
	}

	LRESULT	OnSize(UINT	/*uMsg*/, WPARAM /*wParam*/, LPARAM	lParam,	BOOL& /*bHandled*/)
	{
		UpdateLayout(GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam));
		return 0;
	}

	LRESULT	OnSetFocus(UINT	/*uMsg*/, WPARAM /*wParam*/, LPARAM	/*lParam*/,	BOOL& /*bHandled*/)
	{
		if(m_view.m_hWnd !=	NULL)
			m_view.SetFocus();
		return 0;
	}

	CString	GetSkinFavBarPath(BOOL bHot)
	{
		CString	strBmp;
		if (bHot)	strBmp = _T("\\FavBarHot.bmp");
		else		strBmp = _T("\\FavBar.bmp");
		return _GetBtnSkinDir()+strBmp;
	}

	void InitToolBar(int nIDAdd, int nIDOrganize, int nIDSpecial,
					 UINT nImageBmpID, UINT	nHotImageBmpID,
					 int cx, int cy, COLORREF clrMask, UINT	nFlags = ILC_COLOR8)
	{
		CImageList imgs;
		MTLVERIFY(imgs.Create(cx, cy, nFlags | ILC_MASK, 1,	1));

		CBitmap	bmp;
		bmp.Attach(AtlLoadBitmapImage(GetSkinFavBarPath(FALSE).GetBuffer(0), LR_LOADFROMFILE));
		if (bmp.m_hBitmap==NULL)
			bmp.LoadBitmap(nImageBmpID);
		imgs.Add(bmp, clrMask);

		CImageList imgsHot;
		MTLVERIFY(imgsHot.Create(cx, cy, nFlags	| ILC_MASK,	1, 1));

		CBitmap	bmpHot;
		bmpHot.Attach(AtlLoadBitmapImage(GetSkinFavBarPath(TRUE).GetBuffer(0), LR_LOADFROMFILE));
		if (bmpHot.m_hBitmap==NULL)
			bmpHot.LoadBitmap(nHotImageBmpID);
		imgsHot.Add(bmpHot,	clrMask);

		m_wndToolBar.Create(m_hWnd,	rcDefault, NULL, ATL_SIMPLE_TOOLBAR_PANE_STYLE | TBSTYLE_LIST, 0);
		m_wndToolBar.SetExtendedStyle(TBSTYLE_EX_DRAWDDARROWS);
		ATLASSERT(m_wndToolBar.IsWindow());
		m_wndToolBar.SetButtonStructSize(sizeof(TBBUTTON));

		m_wndToolBar.SetImageList(imgs);
		m_wndToolBar.SetHotImageList(imgsHot);

		// add Add and Organize	button
		TBBUTTON btnSp = { 2, nIDSpecial, TBSTATE_ENABLED, TBSTYLE_BUTTON |	TBSTYLE_AUTOSIZE | TBSTYLE_DROPDOWN	| BTNS_WHOLEDROPDOWN, 0, 0 };
		MTLVERIFY(m_wndToolBar.InsertButton(-1,	&btnSp));
		TBBUTTON btnAdd	= {	0, nIDAdd, TBSTATE_ENABLED,	TBSTYLE_BUTTON | TBSTYLE_AUTOSIZE, 0, 0	};
		MTLVERIFY(m_wndToolBar.InsertButton(-1,	&btnAdd));
		TBBUTTON btnOrg	= {	1, nIDOrganize,	TBSTATE_ENABLED, TBSTYLE_BUTTON	| TBSTYLE_AUTOSIZE,	0, 0 };
		MTLVERIFY(m_wndToolBar.InsertButton(-1,	&btnOrg));

		CVersional<TBBUTTONINFO> bi;
		bi.dwMask =	TBIF_TEXT;
		bi.pszText = _T("ǉ...");
		MTLVERIFY(m_wndToolBar.SetButtonInfo(nIDAdd, &bi));
		bi.pszText = _T("...");
		MTLVERIFY(m_wndToolBar.SetButtonInfo(nIDOrganize, &bi));
		bi.pszText = _T("\");
		MTLVERIFY(m_wndToolBar.SetButtonInfo(nIDSpecial, &bi));

		m_wndToolBar.AddStrings(_T("NS\0"));	// for proper item height
		_AddSimpleReBarBandCtrl(m_wndReBar,	m_wndToolBar);

		CalcSize();
	}

	void UpdateLayout(int cxWidth, int cyHeight)
	{
		ATLASSERT(::IsWindow(m_hWnd));
		RECT rect;

		::SetRect(&rect, 0,	0, cxWidth,	m_cxyHeader);
		if(m_wndReBar.m_hWnd !=	NULL)
			m_wndReBar.SetWindowPos(NULL, rect.left	+ s_cxyBorder, s_cxyBorder,	rect.right - s_cxyBorder*2,	rect.bottom, SWP_NOZORDER);

		if(m_view.m_hWnd !=	NULL) {
			CRect rc(rect.left,	m_cxyHeader, cxWidth, cyHeight);
			rc.top += 1;
			rc.left	+= 1;
			rc.right -=	2;
			rc.bottom -= 2;
			m_view.SetWindowPos(NULL, rc, SWP_NOZORDER);
		}
		else
			rect.bottom	= cyHeight;

		// I can't get the reason why I	have to	update now without InvalidateRect.
//		InvalidateRect(&rect); can't update	a rect,	correctly.
		CClientDC dc(m_hWnd);
		T* pT =	static_cast<T*>(this);
		pT->DrawPaneTitle(dc.m_hDC);
	}

	void CalcSize()
	{
		CRect rcBtn;
		m_wndToolBar.GetItemRect(0,	&rcBtn);
		m_cxyHeader	= rcBtn.Height() + s_cxyBorder;
	}

	void DrawPaneTitle(CDCHandle dc)
	{
		CRect rect;
		GetClientRect(&rect);

//		CRect rc; m_view.GetWindowRect(&rc);
//		ScreenToClient(&rc);
		CPen pen; pen.CreatePen(PS_SOLID, 1, ::GetSysColor(COLOR_3DSHADOW));
		POINT pts[]	= {	{ rect.right - 3, rect.top + m_cxyHeader },	{ rect.left, rect.top +	m_cxyHeader	},
		{ rect.left, rect.bottom - 2 } };//, { rect.right -	3, rect.bottom - 1 } };

//		CRect rect_(rect);
//		rect_.top += m_cxyHeader;
//		dc.DrawEdge(&rect_,	BDR_RAISEDINNER, BF_RECT | BF_FLAT);

//		POINT pts[]	= {	{ rc.right - 1,	rc.top - 1}, { rc.left,	rc.top - 1},
//			{ rc.left, rc.bottom },	{ rc.right - 1,	rc.bottom }	};
		HPEN hOldPen = dc.SelectPen(pen);
		dc.Polyline(pts, _countof(pts));
		dc.SelectPen(hOldPen);

		dc.DrawEdge(CRect(rect.left, rect.top +	m_cxyHeader, rect.right, rect.bottom),
			EDGE_ETCHED, BF_RIGHT |	BF_BOTTOM);

//		dc.DrawEdge(CRect(rect.left, rect.bottom - 2, rect.right - 2, rect.bottom +	10), EDGE_ETCHED, BF_TOP);

		rect.bottom	= rect.top + m_cxyHeader;
		dc.DrawEdge(&rect, EDGE_ETCHED,	BF_LEFT	| BF_TOP | BF_RIGHT	| BF_ADJUST);
		dc.FillRect(&rect, (HBRUSH)LongToPtr(COLOR_3DFACE +	1));
	}


/*	static HWND	_CreateSimpleReBarCtrl(HWND	hWndParent,	DWORD dwStyle =	ATL_SIMPLE_REBAR_STYLE,	UINT nID = ATL_IDW_TOOLBAR)
	{
		// Ensure style	combinations for proper	rebar painting
		if(dwStyle & CCS_NODIVIDER && dwStyle &	WS_BORDER)
			dwStyle	&= ~WS_BORDER;
		else if(!(dwStyle &	WS_BORDER) && !(dwStyle	& CCS_NODIVIDER))
			dwStyle	|= CCS_NODIVIDER;

		// Create rebar	window
		HWND hWndReBar = ::CreateWindowEx(0, REBARCLASSNAME, NULL, dwStyle,	0, 0, 100, 100,	hWndParent,	(HMENU)LongToHandle(nID), _Module.GetModuleInstance(), NULL);
		if(hWndReBar ==	NULL)
		{
			ATLTRACE2(atlTraceUI, 0, _T("Failed	to create rebar.\n"));
			return NULL;
		}

		// Initialize and send the REBARINFO structure
		REBARINFO rbi;
		rbi.cbSize = sizeof(REBARINFO);
		rbi.fMask  = 0;
		if(!::SendMessage(hWndReBar, RB_SETBARINFO,	0, (LPARAM)&rbi))
		{
			ATLTRACE2(atlTraceUI, 0, _T("Failed	to initialize rebar.\n"));
			::DestroyWindow(hWndReBar);
			return NULL;
		}

		return hWndReBar;
	}
*/

	BEGIN_UPDATE_COMMAND_UI_MAP(CDonutFavoritesBarImpl)
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_FAVTREE_BAR_SCRIPT, ETV_EX_SCRIPT, m_view.GetExplorerTreeViewExtendedStyle())
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_FAVTREE_BAR_MYCOMPUTER, ETV_EX_MYCOMPUTER, m_view.GetExplorerTreeViewExtendedStyle())
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_FAVTREE_BAR_STANDARD, ETV_EX_FAVORITES, m_view.GetExplorerTreeViewExtendedStyle())
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_FAVTREE_BAR_GROUP, ETV_EX_FAVORITEGROUP,	m_view.GetExplorerTreeViewExtendedStyle())
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_FAVTREE_BAR_USER, ETV_EX_USERDEFINED, m_view.GetExplorerTreeViewExtendedStyle())
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_FAVTREE_BAR_SHELLEXECUTE, ETV_EX_SHELLEXECUTE, m_view.GetExplorerTreeViewExtendedStyle())
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_FAVTREE_BAR_LOADREMOTEICON, ETV_EX_LOADREMOTEICON, m_view.GetExplorerTreeViewExtendedStyle())
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_FAVTREE_BAR_SINGLEEXPAND, ETV_EX_SINGLEEXPAND, m_view.GetExplorerTreeViewExtendedStyle())
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_FAVTREE_BAR_HISTORY,	ETV_EX_HISTORY,	m_view.GetExplorerTreeViewExtendedStyle()) // UDT DGSTR	ꂫ
		UPDATE_COMMAND_UI_SETCHECK_FLAG(ID_FAVTREE_BAR_HISTORY_TIME, ETV_EX_HISTORY_TIME, m_view.GetExplorerTreeViewExtendedStyle()) //	U.H

	END_UPDATE_COMMAND_UI_MAP()
};

class CDonutFavoritesBar : public CDonutFavoritesBarImpl<CDonutFavoritesBar>
{
public:
	DECLARE_WND_CLASS_EX(_T("Donut_FavoritesBar"), 0, -1)
};
