#include "stdafx.h"
#include "resource.h"

#include "WtlFixed/atlmisc.h"
#include <atlframe.h>
#include <atlctrls.h>
#include <atlctrlw.h>
#include "WtlFixed/atlsplit.h"
#include <atldlgs.h>
#include <atlctrlx.h>
#include <atlcrack.h>
#include <atlddx.h>
#include <wininet.h>
#include <MsHTML.h>

#include "ChevronHandler.h"
#include "Mtl.h"

namespace MTL
{

bool __MtlIsMeaninglessCharInHttp(TCHAR	ch)
{
	return ch == _T('\\') || ch	== _T(':') ||
		ch == _T(',') || ch	== _T(';') ||
		ch == _T('*') || ch	== _T('\"')	||
		ch == _T('<') || ch	== _T('>') ||
		ch == _T('|') ||
		ch == _T(' ') || ch	== _T('\t')	||
		ch == _T('\r');
}

void MtlOpenHttpFiles(CSimpleArray<CString>& arrFiles, const CString& strCmdLine_)
{
//	ATLTRACE2(atlTraceUser,	4, _T("MtlOpenHttpFiles	:%s\n"), strCmdLine_.Left(100));
	CString	strCmdLine = strCmdLine_;

	if (strCmdLine.IsEmpty())
		return;

	int	nFirst = 0;
	int	nLast;
	CString	strFile;
	do {
//		ATLTRACE2(atlTraceUser,	4, _T("	step1\n"));

		nFirst = MTL::__MtlFind(strCmdLine,	nFirst,	_T("http:"));
		if (nFirst == -1)
			break;

//		ATLTRACE2(atlTraceUser,	4, _T("	step2\n"));

		nLast =	MTL::__MtlFindChar(strCmdLine, nFirst +	4, _T('\n'));
		if (nLast == -1) {
			strFile	= strCmdLine.Mid(nFirst);
		}
		else {
			ATLASSERT(strCmdLine.GetAt(nLast) == _T('\n'));
			strFile	= strCmdLine.Mid(nFirst, nLast - nFirst);
			ATLASSERT(strFile.Right(1) != _T('\n'));
		}

//		ATLTRACE2(atlTraceUser,	4, _T("	step3\n"));
		strFile	= MTL::__MtlRemoveTrailingMeaninglessChar(strFile);
//		ATLTRACE2(atlTraceUser,	4, _T("					:cleaned(%s)\n"), strFile);
		if (MTL::MtlIsInternetFileMaybe(strFile)) {
			ATLTRACE2(atlTraceUser,	4, _T("                 :open   (%s)\n"), strFile);
			arrFiles.Add(strFile);
		}

		if (nLast == -1)
			break;

//		ATLTRACE2(atlTraceUser,	4, _T("	step4\n"));
		nFirst = nLast;
	} while	(nFirst	< strCmdLine.GetLength());
}

void MtlDrawDragRectFixed(CDCHandle	dc,	LPCRECT	lpRect,	SIZE size, LPCRECT lpRectLast, SIZE	sizeLast, HBRUSH hBrush, HBRUSH	hBrushLast)
{
	// first, determine	the	update region and select it
	HRGN hRgnNew;
	HRGN hRgnOutside, hRgnInside;
	hRgnOutside	= ::CreateRectRgnIndirect(lpRect);
	RECT rect =	*lpRect;
	::InflateRect(&rect, -size.cx, -size.cy);
	::IntersectRect(&rect, &rect, lpRect);
	hRgnInside = ::CreateRectRgnIndirect(&rect);
	hRgnNew	= ::CreateRectRgn(0, 0,	0, 0);
	::CombineRgn(hRgnNew, hRgnOutside, hRgnInside, RGN_XOR);

	HBRUSH hBrushOld = NULL;
	if(hBrush == NULL)
		hBrush = CDCHandle::GetHalftoneBrush();
	if(hBrushLast == NULL)
		hBrushLast = hBrush;

	HRGN hRgnLast =	NULL, hRgnUpdate = NULL;
	if(lpRectLast != NULL)
	{
		// find	difference between new region and old region
		hRgnLast = ::CreateRectRgn(0, 0, 0,	0);
		::SetRectRgn(hRgnOutside, lpRectLast->left,	lpRectLast->top, lpRectLast->right,	lpRectLast->bottom);
		rect = *lpRectLast;
		::InflateRect(&rect, -sizeLast.cx, -sizeLast.cy);
		::IntersectRect(&rect, &rect, lpRectLast);
		::SetRectRgn(hRgnInside, rect.left,	rect.top, rect.right, rect.bottom);
		::CombineRgn(hRgnLast, hRgnOutside,	hRgnInside,	RGN_XOR);

		// only	diff them if brushes are the same
		if(hBrush == hBrushLast)
		{
			hRgnUpdate = ::CreateRectRgn(0,	0, 0, 0);
			::CombineRgn(hRgnUpdate, hRgnLast, hRgnNew,	RGN_XOR);
		}
	}
	if(hBrush != hBrushLast	&& lpRectLast != NULL)
	{
		// brushes are different --	erase old region first
		dc.SelectClipRgn(hRgnLast);
		dc.GetClipBox(&rect);
		hBrushOld =	dc.SelectBrush(hBrushLast);
		dc.PatBlt(rect.left, rect.top, rect.right -	rect.left, rect.bottom - rect.top, PATINVERT);
		dc.SelectBrush(hBrushOld);
		hBrushOld =	NULL;
	}

	// draw	into the update/new	region
	dc.SelectClipRgn(hRgnUpdate	!= NULL	? hRgnUpdate : hRgnNew);
	dc.GetClipBox(&rect);
	hBrushOld =	dc.SelectBrush(hBrush);
	dc.PatBlt(rect.left, rect.top, rect.right -	rect.left, rect.bottom - rect.top, PATINVERT);

	// cleanup DC ******************* fixed	************************
	if(hBrushOld !=	NULL)
		dc.SelectBrush(hBrushOld);
	dc.SelectClipRgn(NULL);
	if(NULL	!= hBrush)
		DeleteObject(hBrush); //Free our halftone brush
	DeleteObject(hRgnNew);
	DeleteObject(hRgnOutside);
	DeleteObject(hRgnInside);
	if (NULL !=	hRgnLast)
		DeleteObject(hRgnLast);
	if (NULL !=	hRgnUpdate)
		DeleteObject(hRgnUpdate);
}

}
