#pragma	once
#include <atlctrls.h>


#define	STS_ENG_CHANGE_GO		0x00000001
#define	STS_DROP_GO				0x00000002
#define	STS_HISTORY_SAVE		0x00000004
#define	STS_NO_REPOSITION		0x00000008
#define	STS_KEY_CHANGE_GO		0x00000010

#define	ENT_READ_ENG		1
#define	ENT_READ_HIST		2

extern bool	g_bNoReposition;
template <class	T>
class CSearchBarCtrlImpl:
	//+++ public CDialogImpl<CSearchBarCtrlImpl>,
	public CDialogImpl<CSearchBarCtrlImpl<T> >,
	public IDropTargetImpl<T>,
	public IDropSourceImpl<T>
{
public:
	typedef	CSearchBarCtrlImpl<T> thisClass;

	enum { IDD = IDD_SEARCHBAR_FORM	};
	CFlatComboBox m_cmbKeyword;
	CFlatComboBox m_cmbEngin;
	CToolBarCtrl m_wndToolBar;

	HANDLE m_hThreadEngin;
	HANDLE m_hThreadKeyword;
	HCURSOR	m_hCursor;
	CPoint m_ptDragHist;
	CPoint m_ptDragStart;
	CPoint m_ptDragEnd;
	CContainedWindow m_wndKeyword;
	CContainedWindow m_wndEngin;

	enum {m_nBarCX = 2,	m_nBmpCX=16, m_nBmpCY=16, s_kcxGap=2};

	bool m_bDragAccept;
	bool m_bDragFromItself;
	int	m_cxBtnsBtn;

	struct _ThreadParam
	{
		thisClass* pSearchBar;
		HANDLE _hExitEvent;
	};

	_ThreadParam	m_ThreadParams;
	HANDLE			m_hThread;


	CSearchBarCtrlImpl():
		m_wndKeyword(this, 1),
		m_wndEngin(this, 2)
	{
		m_hThreadEngin = NULL;
		m_hThreadKeyword = NULL;
		m_hCursor =	NULL;

		m_bDragAccept =	false;
		m_bDragFromItself =	false;
	}

// Message map and handlers
	BEGIN_MSG_MAP(CDonutSearchBarEx)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
		MSG_WM_MOUSEMOVE(OnMouseMove)
		MSG_WM_LBUTTONDOWN(OnLButtonDown)
		MSG_WM_LBUTTONUP(OnLButtonUp)
		MSG_WM_COMMAND(OnCommand)
		NOTIFY_CODE_HANDLER(TTN_GETDISPINFO, OnToolTipText)

		MESSAGE_HANDLER(WM_SIZE, OnSize)
		MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBkgnd)
		COMMAND_HANDLER_EX(IDC_CMB_ENGIN, CBN_SELCHANGE, OnSelChange)
		COMMAND_HANDLER_EX(IDC_CMB_KEYWORD,	CBN_SELCHANGE, OnSelChange)
	ALT_MSG_MAP(1)
		MSG_WM_CHAR(OnChar)
		MSG_WM_KEYDOWN(OnKeywordKeyDown)
	ALT_MSG_MAP(2)
		MSG_WM_KEYDOWN(OnEnginKeyDown)
		MESSAGE_HANDLER(WM_CTLCOLORLISTBOX,	OnCtlColor)
	END_MSG_MAP()

	LRESULT	OnEraseBkgnd(UINT uMsg,	WPARAM wParam, LPARAM lParam, BOOL&	bHandled)
	{
		bHandled = TRUE;
		::SendMessage(GetParent(), uMsg, wParam, lParam);
		return 1;
	}


	LRESULT	OnToolTipText(int idCtrl, LPNMHDR pnmh,	BOOL& /*bHandled*/)
	{
		LPNMTTDISPINFO pDispInfo = (LPNMTTDISPINFO)pnmh;
		pDispInfo->szText[0] = 0;
		if (pDispInfo->uFlags &	TTF_IDISHWND) return S_OK;

		CString	strKeyword = MtlGetWindowText(m_wndKeyword);

		CString	strHeader =	_T('\"');
		CString	strHelp	= _T("\" ");
		CString	strEngin = MtlGetWindowText(m_wndEngin);
		TCHAR szBuff[80];
		AtlCompactPathFixed(szBuff,	strKeyword,	80 - strHelp.GetLength() - strHeader.GetLength());
		strHeader += szBuff;
		strHeader += strHelp;
		switch (idCtrl)
		{
		case ID_SEARCH_WEB:
			strHeader += _T("\"") +	strEngin + _T("\"Ō");
			break;

		case ID_SEARCH_PAGE:
			strHeader += _T("̃y[WŌ(:Shift+Enter :Ctrl+Enter)");
			break;

		case ID_SEARCH_HILIGHT:
			strHeader += _T("nCCg");
			break;
		}

		::lstrcpyn(pDispInfo->szText, strHeader, 80);

		return S_OK;
	}

	void OnCommand(UINT, int nID, HWND hWndCtrl)
	{
		if (hWndCtrl ==	m_wndToolBar.m_hWnd)
		{
			CEdit edit = GetEditCtrl();
			CString	str	= MtlGetWindowText(edit);
			switch(nID)
			{
			case ID_SEARCH_WEB:
				{
					if (!str.IsEmpty())
					{
						T* pT =	static_cast<T*>(this);
						pT->OnItemSelected(str);
						_AddToSearchBoxUnique(str);
					}
				}
				break;

			case ID_SEARCH_HILIGHT:
				SendMessage(GetTopLevelParent(), WM_USER_HILIGHT, (WPARAM)str.GetBuffer(0),	0);
				break;

			case ID_SEARCH_PAGE:
				{
					str	= _GetSelectText(edit);
					SendMessage(GetTopLevelParent(), WM_USER_FIND_KEYWORD, (WPARAM)str.GetBuffer(0), (::GetKeyState(VK_SHIFT)<0)? FALSE:TRUE);
				}
				break;
			}
		}
		SetMsgHandled(FALSE);
	}

	LRESULT	OnSize(UINT	uMsg, WPARAM wParam, LPARAM	lParam,	BOOL& bHandled)
	{
		if (!m_wndToolBar.m_hWnd)
			return S_FALSE;

		CRect rcDlg;
		GetClientRect(&rcDlg);

		CRect rcToolbar(rcDlg);
		rcToolbar.left = rcDlg.right - m_cxBtnsBtn;
		m_wndToolBar.SetWindowPos(NULL,	rcToolbar, SWP_NOZORDER|SWP_NOSENDCHANGING);

		CRect rcEngin;
		m_cmbEngin.GetWindowRect(&rcEngin);
		int	nEnginCX = rcEngin.Width();
		int	nEnginCY = rcEngin.Height();
		rcEngin	= rcToolbar;
		rcEngin.right =	rcToolbar.left - s_kcxGap;
		rcEngin.left = rcEngin.right - nEnginCX;
		rcEngin.bottom = rcEngin.top + nEnginCY;
		m_cmbEngin.SetWindowPos(NULL, rcEngin, SWP_NOZORDER|SWP_NOSENDCHANGING);

		CRect rcKeyword(rcEngin);
		rcKeyword.left = 0;
		rcKeyword.right	= rcEngin.left - s_kcxGap;
		m_cmbKeyword.SetWindowPos(NULL,	rcKeyword, SWP_NOZORDER|SWP_NOSENDCHANGING);


		return S_OK;
	}

	void InitToolBar(UINT nImageBmpID, UINT	nHotImageBmpID,
					 int cx, int cy, COLORREF clrMask, UINT	nFlags = ILC_COLOR8)
	{
		CImageList imgs;
		MTLVERIFY(imgs.Create(cx, cy, nFlags | ILC_MASK, 1,	1));

		CBitmap	bmp;
		bmp.Attach(AtlLoadBitmapImage(GetSkinSeachBarPath(FALSE).GetBuffer(0), LR_LOADFROMFILE));
		if (bmp.m_hBitmap==NULL)
			bmp.LoadBitmap(nImageBmpID);
		imgs.Add(bmp, clrMask);

		CImageList imgsHot;
		MTLVERIFY(imgsHot.Create(cx, cy, nFlags	| ILC_MASK,	1, 1));

		CBitmap	bmpHot;
		bmpHot.Attach(AtlLoadBitmapImage(GetSkinSeachBarPath(TRUE).GetBuffer(0), LR_LOADFROMFILE));
		if (bmpHot.m_hBitmap==NULL)
			bmpHot.LoadBitmap(nHotImageBmpID);
		imgsHot.Add(bmpHot,	clrMask);

		m_wndToolBar = ::CreateWindowEx(0, TOOLBARCLASSNAME, NULL,
			ATL_SIMPLE_TOOLBAR_PANE_STYLE |	CCS_TOP,
			0, 0, 100, 100,	m_hWnd,	(HMENU)NULL, _Module.GetModuleInstance(), NULL);
		m_wndToolBar.SetButtonStructSize(sizeof(TBBUTTON));

		m_wndToolBar.SetImageList(imgs);
		m_wndToolBar.SetHotImageList(imgsHot);

		// add Add and Organize	button
		TBBUTTON btnWeb	= {	0, ID_SEARCH_WEB, TBSTATE_ENABLED, TBSTYLE_BUTTON|TBSTYLE_AUTOSIZE,	0, 0 };
		MTLVERIFY(m_wndToolBar.InsertButton(-1,	&btnWeb));
		TBBUTTON btnHilght = { 1, ID_SEARCH_HILIGHT, TBSTATE_ENABLED, TBSTYLE_BUTTON|TBSTYLE_AUTOSIZE, 0, 0	};
		MTLVERIFY(m_wndToolBar.InsertButton(-1,	&btnHilght));
		TBBUTTON btnPage = { 2,	ID_SEARCH_PAGE,	TBSTATE_ENABLED, TBSTYLE_BUTTON|TBSTYLE_AUTOSIZE, 0, 0 };
		MTLVERIFY(m_wndToolBar.InsertButton(1, &btnPage));

		m_wndToolBar.SetBitmapSize(14,14);
		m_cxBtnsBtn	= (20)*3+1;
	}

	CString	GetSkinSeachBarPath(BOOL bHot)
	{
		CString	strBmp;
		if (bHot)	strBmp = _T("\\SearchBarHot.bmp");
		else		strBmp = _T("\\SearchBar.bmp");
		return _GetBtnSkinDir()+strBmp;
	}

	LRESULT	OnInitDialog(HWND hWnd,	LPARAM lParam)
	{
		CRect rcDlg;
		GetWindowRect(&rcDlg);
		SetWindowPos(NULL, 0, 0, 1,	rcDlg.Height(),	0);

		DWORD dwEngWidth=0;
		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("SEARCH"));
		pr.QueryValue(dwEngWidth, _T("EngWidth"));
		pr.Close();

		m_cmbKeyword.FlatComboBox_Install(GetDlgItem(IDC_CMB_KEYWORD));
		m_cmbEngin.FlatComboBox_Install(GetDlgItem(IDC_CMB_ENGIN));
		m_cmbEngin.SetDroppedWidth(150);
		if (dwEngWidth!=0)
		{
			CRect rcEngin;
			m_cmbEngin.GetWindowRect(&rcEngin);
			rcEngin.right =	rcEngin.left + dwEngWidth;
			m_cmbEngin.SetWindowPos(NULL, rcEngin, SWP_NOZORDER|SWP_NOSENDCHANGING);
		}

		m_wndKeyword.SubclassWindow(m_cmbKeyword.GetDlgItem(1001));
		m_wndEngin.SubclassWindow(m_cmbEngin.m_hWnd);

		InitToolBar(IDB_SEARCHBUTTON, IDB_SEARCHBUTTON_HOT,	m_nBmpCX, m_nBmpCY,	RGB(255,0,255));

		RegisterDragDrop();

		// Thread Create
		m_ThreadParams._hExitEvent = ::CreateEvent(NULL, FALSE,	FALSE, NULL);
		m_ThreadParams.pSearchBar =	this;
		DWORD wThreadId=0;
		m_hThread =	::CreateThread(NULL, 0,	_SearchThread,
			(LPVOID)&m_ThreadParams, 0,	&wThreadId);
		::SetThreadPriority(m_hThread ,	THREAD_PRIORITY_IDLE);

		return S_OK;
	}

	static DWORD WINAPI	_SearchThread(LPVOID lpParam)
	{
		_ThreadParam* pParam = (_ThreadParam*)lpParam;
		_InitialEngin((LPVOID)pParam->pSearchBar->m_cmbEngin.m_hWnd);
		_InitialKeyword((LPVOID)pParam->pSearchBar->m_cmbKeyword.m_hWnd);
		_endthread();
		return 0;
	}


	void OnDestroy()
	{
		// Thread Remove
		::SetEvent(m_ThreadParams._hExitEvent);
		DWORD dwResult = ::WaitForSingleObject(m_hThread, INFINITE);
		::CloseHandle(m_ThreadParams._hExitEvent);
		::CloseHandle(m_hThread);

		CRect rcEngin;
		m_wndEngin.GetWindowRect(rcEngin);

		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("SEARCH"));
		pr.SetValue((DWORD)rcEngin.Width(),	_T("EngWidth"));
		pr.Close();

		m_wndKeyword.UnsubclassWindow();
		m_wndEngin.UnsubclassWindow();
		RevokeDragDrop();
		SaveHistory();
	}

	void OnEnginKeyDown(UINT nChar,	UINT nRepCnt, UINT nFlags)
	{
		if (nChar == VK_RETURN)	{
			_OnEnterKeyDown();
			SetMsgHandled(TRUE);
		}
		else
			SetMsgHandled(FALSE);
	}

	void OnChar(UINT nChar,	UINT nRepCnt, UINT nFlags)
	{
		if (nChar==VK_RETURN){
			SetMsgHandled(TRUE);
		}
		else
			SetMsgHandled(FALSE);
	}

	void OnKeywordKeyDown(UINT nChar, UINT nRepCnt,	UINT nFlags)
	{
		// if not dropped, eat VK_DOWN
		if (!m_cmbKeyword.GetDroppedState()
			&& (nChar == VK_DOWN ||	nChar == VK_UP))
		{
			int	nIndexEngin	= m_cmbEngin.GetCurSel();
			int	nIndexKeyword =	m_cmbKeyword.GetCurSel();

			SetMsgHandled(TRUE);
			if (nChar == VK_UP)
			{
				if (::GetKeyState(VK_CONTROL)<0)
				{
					if (0>nIndexEngin-1)
						m_cmbEngin.SetCurSel(m_cmbEngin.GetCount()-1);
					else
						m_cmbEngin.SetCurSel(nIndexEngin-1);
				}
				else
				{
					if (0>nIndexKeyword-1)
						m_cmbKeyword.SetCurSel(m_cmbKeyword.GetCount()-1);
					else
						m_cmbKeyword.SetCurSel(nIndexKeyword-1);
				}
			}
			else if	(nChar == VK_DOWN)
			{
				if (::GetKeyState(VK_CONTROL)<0)
				{
					int	nIndex = m_cmbEngin.GetCurSel();
					if (m_cmbEngin.GetCount()>nIndexEngin+1)
						m_cmbEngin.SetCurSel(nIndexEngin+1);
					else
						m_cmbEngin.SetCurSel(0);
				}
				else
				{
					if (m_cmbKeyword.GetCount()>nIndexKeyword+1)
						m_cmbKeyword.SetCurSel(nIndexKeyword+1);
					else
						m_cmbKeyword.SetCurSel(0);
				}
			}
		}
		else
		{
			if (nChar == VK_RETURN)	{
				_OnEnterKeyDown();
				SetMsgHandled(TRUE);
			}
			else
				SetMsgHandled(FALSE);
		}
	}

	void OnMouseMove(UINT nFlags, CPoint pt)
	{
		CRect rcKeyword;
		m_cmbKeyword.GetWindowRect(&rcKeyword);
		ScreenToClient(&rcKeyword);

		if (abs(rcKeyword.right-pt.x)>5
			&& ::GetCapture()!=m_hWnd) return;
		if (m_hCursor==NULL)
			m_hCursor =	::LoadCursor(NULL, IDC_SIZEWE);

		::SetCursor(m_hCursor);

		if ((nFlags&MK_LBUTTON))
		{
			UpdateLayout(pt);
		}
	}

	void OnSelChange(UINT code,	int	id,	HWND hWnd)
	{
		DWORD dwStatus=0;
		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("SEARCH"));
		pr.QueryValue(dwStatus,	_T("Status"));
		pr.Close();

		BOOL bSts =	0;
		if (id==IDC_CMB_ENGIN)
			bSts = dwStatus&STS_ENG_CHANGE_GO;
		else if	(id==IDC_CMB_KEYWORD)
			bSts = dwStatus&STS_KEY_CHANGE_GO;

		if (::GetKeyState(VK_SHIFT)<0) bSts	= !bSts;
		if (bSts)
			_OnEnterKeyDown();
	}

	void OnLButtonDown(UINT	nFlags,	CPoint pt)
	{
		CRect rcKeyword;
		m_cmbKeyword.GetWindowRect(&rcKeyword);
		ScreenToClient(&rcKeyword);

		if (abs(rcKeyword.right-pt.x)>5) return;
		SetCapture();
		::SetCursor(m_hCursor);
		m_ptDragStart =	pt;
		m_ptDragHist = pt;
	}

	void OnLButtonUp(UINT nFlags, CPoint pt)
	{
		if (::GetCapture()!=m_hWnd)	return;
		::ReleaseCapture();

		UpdateLayout(pt);
	}

	void UpdateLayout(CPoint pt)
	{
		int	nMoveX = m_ptDragStart.x-pt.x;

		CRect rcKeyword;
		m_cmbKeyword.GetWindowRect(&rcKeyword);
		ScreenToClient(&rcKeyword);
		rcKeyword.right	-= nMoveX;

		CRect rcEngin;
		m_cmbEngin.GetWindowRect(&rcEngin);
		ScreenToClient(&rcEngin);
		rcEngin.left -=	nMoveX;

		if (rcEngin.left>=rcEngin.right) return;
		if (rcKeyword.left>=rcKeyword.right) return;

		m_cmbKeyword.SetWindowPos(NULL,	rcKeyword, SWP_NOZORDER);
		m_cmbEngin.SetWindowPos(NULL, rcEngin, SWP_NOZORDER);

		m_ptDragStart =	pt;
		UpdateWindow();
	}

	void _AddToSearchBoxUnique(const CString& strURL)
	{
		// search the same string
		int	nCount = m_cmbKeyword.GetCount();
		for	(int n = 0;	n <	nCount;	++n) {
			CString	str;
			MtlGetLBTextFixed(m_cmbKeyword,	n, str);
			if (strURL == str) {
				m_cmbKeyword.DeleteString(n);
				break;
			}
		}

		m_cmbKeyword.InsertString(0, strURL);
		m_cmbKeyword.SetCurSel(0);
	}

	void _OnEnterKeyDown()
	{
		int	nIndexCmb =	m_cmbKeyword.GetCurSel();
		CString	str;
		if (nIndexCmb==-1)
			str	= MtlGetWindowText(m_cmbKeyword);
		else
			m_cmbKeyword.GetLBText(nIndexCmb, str);

		if (!str.IsEmpty())
		{
			SHORT sShift = ::GetKeyState(VK_SHIFT);
			SHORT sCtrl	= ::GetKeyState(VK_CONTROL);

			if (sShift>=0 && sCtrl>=0)
			{
				OnItemSelected(str);
				_AddToSearchBoxUnique(str);
			}
			else
			{
				str	= _GetSelectText(GetEditCtrl());

				if (sCtrl<0)
					SendMessage(GetTopLevelParent(), WM_USER_FIND_KEYWORD, (WPARAM)str.GetBuffer(0), TRUE);
				else if	(sShift<0)
					SendMessage(GetTopLevelParent(), WM_USER_FIND_KEYWORD, (WPARAM)str.GetBuffer(0), FALSE);
			}
		}
	}

	LRESULT	OnCtlColor(UINT	/*uMsg*/, WPARAM wParam, LPARAM	lParam,	BOOL& bHandled)
	{
		bHandled = FALSE;
		if (g_bNoReposition==true) return 0;

		CRect rcDesktop;
		::GetWindowRect(::GetDesktopWindow(), &rcDesktop);

		CRect rcWnd;
		::GetWindowRect((HWND)lParam, &rcWnd);

		if (rcDesktop.right<=rcWnd.right)
		{
			int	nDiff =	rcWnd.right-rcDesktop.right;
			rcWnd.left -= nDiff;	rcWnd.right	-= nDiff;
			::SetWindowPos((HWND)lParam, NULL, rcWnd.left, rcWnd.top, 0, 0,	SWP_NOSIZE);
		}

		return 0;
	}


	void OnItemSelected(const CString& str)
	{
		int	nTarCate = m_cmbEngin.GetCurSel();
		if (nTarCate==-1) return;

		CString	strSearchEng = MtlGetWindowText(m_cmbEngin);

		BOOL bFirst=TRUE;
		int	nLoopCtn=0;
		OpenSearch(str,	strSearchEng, nLoopCtn,	bFirst);
	}

	void OpenSearch(CString	strWord, CString strSearchEng, int &nLoopCnt, BOOL &bFirst)
	{
		CString	strSearchPath =	_GetFilePath(_T("Search.ini"));
		CIniSection	pr;
		pr.Open(strSearchPath, strSearchEng);

		DWORD dwGroup=0;
		pr.QueryValue(dwGroup, _T("Group"));
		BOOL bGroup	= (dwGroup!=0)?	TRUE:FALSE;

		if (bGroup==TRUE)
			OpenSearchGroup(strWord, strSearchEng, nLoopCnt, bFirst);
		else
		{
			DWORD dwEncode=0;
			pr.QueryValue(dwEncode,	_T("Encode"));
			if (dwEncode!=0)
				EncodeString(strWord);

			DWORD dwCount=MAX_PATH;
			TCHAR cBuff[MAX_PATH];
			memset(cBuff, 0, MAX_PATH);
			pr.QueryValue(cBuff, _T("FrontURL"), &dwCount);
			CString	strFrontURL(cBuff);
			if (strFrontURL.IsEmpty()) return;

			memset(cBuff, 0, MAX_PATH);
			pr.QueryValue(cBuff, _T("BackURL"),	&dwCount);
			CString	strBackURL(cBuff);

			CString	strOpenURL;
			strOpenURL.Format(_T("%s%s%s"),	strFrontURL, strWord, strBackURL);

			DWORD dwOpenFlags =	0;
			if (bFirst==TRUE)
			{
				dwOpenFlags	|= D_OPENFILE_ACTIVATE;
				bFirst=FALSE;
			}
			DonutOpenFile(m_hWnd, strOpenURL, dwOpenFlags);
		}

		pr.Close();
	}

	void OpenSearchGroup(CString strWord, CString strSearchEng,	int	&nLoopCnt, BOOL	&bFirst)
	{
		nLoopCnt++;
		if (nLoopCnt>10) return;

		CString	strSearchPath =	_GetFilePath(_T("Search.ini"));
		CIniSection	pr;
		pr.Open(strSearchPath, strSearchEng);

		DWORD dwListCnt	= 0;
		pr.QueryValue(dwListCnt, _T("ListCount"));
		for	(int ii=1; ii<=dwListCnt; ii++)
		{
			CString	strKey;
			strKey.Format(_T("%02d"), ii);
			TCHAR cBuff[MAX_PATH];
			DWORD dwCount=MAX_PATH;

			pr.QueryValue(cBuff, strKey, &dwCount);

			CString	strSearchEng2(cBuff);
			if (strSearchEng2.IsEmpty()) continue;

			OpenSearch(strWord,	strSearchEng2, nLoopCnt, bFirst);
		}
	}

	void EncodeString(CString &str)
	{
		CString	strRet;
		int	nStrLen	= str.GetLength();
		for	(int ii=0; ii<nStrLen; ii++)
		{
			CString	strOne;
			WCHAR cText	= str[ii];
			cText =	cText &	~0xff00;
			if (cText==0x20)
			{
				strRet += _T("+");
			}
			else if	((cText>=0x40 && cText<=0x5A) || (cText>=0x61 && cText<=0x7A)
				|| (cText>=0x30	&& cText<=0x39)	|| cText==0x2A || cText==0x2D || cText==0x2E ||	cText==0x5F)
			{
				strOne.Format(_T("%c"),	cText);
				strRet += strOne;
			}
			else
			{
				strOne.Format(_T("%%%x"), cText);
				strRet += strOne;
			}
		}
		str	= strRet;
	}

	static void	_InitialEngin(LPVOID lpV)
	{
		CComboBox cmb((HWND)lpV);

		CString	strSearchPath =	_GetFilePath(_T("Search.ini"));

		CIniSection	pr;
		pr.Open(strSearchPath, _T("Search-List"));
		DWORD dwListCnt	= 0;
		pr.QueryValue(dwListCnt, _T("ListCount"));

		CString	strKey;
		DWORD dwCount=MAX_PATH;
		for	(int ii=1; ii<=dwListCnt; ii++)
		{
			strKey.Format(_T("%02d"), ii);
			TCHAR cBuff[MAX_PATH];

			pr.QueryValue(cBuff, strKey, &dwCount);

			CString	strTitle(cBuff);
			if (strTitle.IsEmpty())	continue;

			cmb.AddString(strTitle);
		}
		cmb.SetCurSel(0);
	}

	static void	_InitialKeyword(LPVOID lpV)
	{
		CComboBox cmb((HWND)lpV);

		DWORD dwHistoryCnt=0;
		CIniSection	pr;
		DWORD dwStatus=0;
		pr.Open(_szIniFileName,	_T("SEARCH"));
		pr.QueryValue(dwStatus,	_T("Status"));
		pr.Close();

		if (dwStatus&STS_NO_REPOSITION)
			g_bNoReposition	= true;
		if ((dwStatus&STS_HISTORY_SAVE)!=STS_HISTORY_SAVE)
			return;

		pr.Open(_GetFilePath(_T("WordHistory.ini")), _T("SEARCH_HISTORY"));
		pr.QueryValue(dwHistoryCnt,	_T("HistorySaveCnt"));

		for	(int ii=0; ii<dwHistoryCnt;	ii++)
		{
			CString	strKey;
			strKey.Format(_T("KEYWORD%d"), ii);

			TCHAR cBuff[MAX_PATH];

			DWORD dwCount=MAX_PATH;
			pr.QueryValue(cBuff, strKey, &dwCount);

			CString	strKeyWord(cBuff);
			if (strKeyWord.IsEmpty()) continue;

			cmb.AddString(strKeyWord);
		}
		pr.Close();
	}

	BYTE PreTranslateMessage(MSG* pMsg)
	{
		UINT msg = pMsg->message;
		int	vKey =	pMsg->wParam;

		if (!m_hWnd || !IsWindowVisible() || !IsChild(pMsg->hwnd))	// ignore	//+++ !m_hWndǉ.
			return _MTL_TRANSLATE_PASS;

		if (msg	== WM_SYSKEYDOWN ||	msg	== WM_SYSKEYUP || msg == WM_KEYDOWN) {
			// left	or right pressed, check	shift and control key.
			if (vKey ==	VK_UP || vKey == VK_DOWN ||	vKey ==	VK_LEFT	|| vKey	== VK_RIGHT	|| vKey	== VK_HOME || vKey == VK_END
				|| vKey	== (0x41+'C'-'A') || vKey == (0x41+'V'-'A')	|| vKey	== (0x41+'X'-'A'))
						{
				if (::GetKeyState(VK_SHIFT)	< 0	|| ::GetKeyState(VK_CONTROL) < 0)
					return _MTL_TRANSLATE_WANT;// pass to edit control
			}

			// return key have to be passed
			if (vKey ==	VK_RETURN) {
				return _MTL_TRANSLATE_WANT;
			}

			// other key have to be	passed
			if (VK_LBUTTON <= vKey && vKey <= VK_HELP) {
				BOOL bAlt =	HIWORD(pMsg->lParam) & KF_ALTDOWN;
				if (!bAlt && ::GetKeyState(VK_SHIFT) >=	0 && ::GetKeyState(VK_CONTROL) >= 0)// not pressed
					return _MTL_TRANSLATE_WANT;// pass to edit control
			}
		}

		return _MTL_TRANSLATE_PASS;
	}

	CEdit GetEditCtrl()
	{
		return CEdit(m_cmbKeyword.GetDlgItem(1001));
	}


	void SaveHistory()
	{
		DWORD dwStatus=0;
		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("SEARCH"));
		pr.QueryValue(dwStatus,	_T("Status"));
		pr.Close();

		DWORD dwHistoryMaxCnt=10;
		pr.Open(_szIniFileName,	_T("SEARCH"));
		pr.QueryValue(dwHistoryMaxCnt, _T("HistoryCnt"));
		pr.Close();

		DWORD dwItemCount =	m_cmbKeyword.GetCount();
		if (dwItemCount>dwHistoryMaxCnt)
			dwItemCount	= dwHistoryMaxCnt;

		pr.Open(_GetFilePath(_T("WordHistory.ini")), _T("SEARCH_HISTORY"));
		pr.SetValue(dwItemCount, _T("HistorySaveCnt"));
		if (dwStatus&STS_HISTORY_SAVE)
		{
			for	(int ii=0; ii<dwItemCount; ii++)
			{
				CString	strKeyWord;
				MtlGetLBTextFixed(m_cmbKeyword.m_hWnd, ii, strKeyWord);

				CString	strKey;
				strKey.Format(_T("KEYWORD%d"), ii);
				pr.SetValue(strKeyWord,	strKey);
			}
		}
		pr.Close();
	}

	DROPEFFECT OnDragEnter(IDataObject*	pDataObject, DWORD dwKeyState, CPoint point)
	{
		if (m_bDragFromItself)
			return DROPEFFECT_NONE;

		_DrawDragEffect(false);

		m_bDragAccept =	_MtlIsHlinkDataObject(pDataObject);
		return _MtlStandardDropEffect(dwKeyState);
	}

	DROPEFFECT OnDragOver(IDataObject* pDataObject,	DWORD dwKeyState, CPoint point,	DROPEFFECT dropOkEffect)
	{
		if (m_bDragFromItself || !m_bDragAccept)
			return DROPEFFECT_NONE;

		return _MtlStandardDropEffect(dwKeyState) |	_MtlFollowDropEffect(dropOkEffect) | DROPEFFECT_COPY;
	}
	void OnDragLeave()
	{
		if (m_bDragFromItself)
			return;

		_DrawDragEffect(true);
	}

	void _DrawDragEffect(bool bRemove)
	{
		CClientDC dc(m_wndKeyword.m_hWnd);

		CRect rect;
		m_wndKeyword.GetClientRect(rect);

		if (bRemove)
			MtlDrawDragRectFixed(dc.m_hDC, &rect, CSize(0, 0), &rect, CSize(2, 2), NULL, NULL);
		else
			MtlDrawDragRectFixed(dc.m_hDC, &rect, CSize(2, 2), NULL, CSize(2, 2),	NULL, NULL);
	}

	DROPEFFECT OnDrop(IDataObject* pDataObject,	DROPEFFECT dropEffect,
		DROPEFFECT dropEffectList, CPoint point)
	{
		if (m_bDragFromItself)
			return DROPEFFECT_NONE;

		_DrawDragEffect(true);

		DWORD dwStatus=0;
		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("SEARCH"));
		pr.QueryValue(dwStatus,	_T("Status"));
		pr.Close();

		CString	strText;
		if (MtlGetHGlobalText(pDataObject, strText)	||	MtlGetHGlobalText(pDataObject, strText,	::RegisterClipboardFormat(CFSTR_SHELLURL)))
		{
			CEdit edit = GetEditCtrl();
			edit.SetWindowText(strText);

			BOOL bSts =	dwStatus&STS_DROP_GO;
			if (::GetKeyState(VK_SHIFT)<0) bSts	= !bSts;
			if (bSts)
			{
				OnItemSelected(strText);
				_AddToSearchBoxUnique(strText);
			}
			return DROPEFFECT_COPY;
		}

		return DROPEFFECT_NONE;
	}

	void SetFont(HFONT hFont, BOOL bRedraw=TRUE)
	{
		CDialogImpl<CSearchBarCtrlImpl>::SetFont(hFont,	bRedraw);
		m_cmbEngin.SetFont(hFont, bRedraw);
		m_cmbKeyword.SetFont(hFont,	bRedraw);
		m_wndKeyword.SetFont(hFont,	bRedraw);
	}
};

class CDonutSearchBar:
	public CSearchBarCtrlImpl<CDonutSearchBar>
{
};

class CSearchPropertyPage :	public CPropertyPageImpl<CSearchPropertyPage>,
public CWinDataExchange<CSearchPropertyPage>
{
public:
// Constants
	enum { IDD = IDD_PROPPAGE_SEARCHBAR};

// Data	members
	int	m_nEngChgGo, m_nDropGo,	m_nHistorySave,	m_nHistorySaveCnt;
	int	m_nNoReposition, m_nKeyChgGo;
	DWORD m_dwStatus;

// DDX map
	BEGIN_DDX_MAP(CSearchPropertyPage)
		DDX_CHECK(IDC_CHECK_ENG_CHG_GO,	m_nEngChgGo)
		DDX_CHECK(IDC_CHECK_KEY_CHG_GO,	m_nKeyChgGo)
		DDX_CHECK(IDC_CHECK_DROP_GO, m_nDropGo)
		DDX_CHECK(IDC_CHECK_HISTORY_SAVE, m_nHistorySave)
		DDX_CHECK(IDC_CHECK_NO_REPOSITION, m_nNoReposition)

		DDX_INT(IDC_ED_HISTORY_CNT,	m_nHistorySaveCnt)
	END_DDX_MAP()

	CSearchPropertyPage()
	{
		m_dwStatus =0;
		m_nEngChgGo	= 0;
		m_nDropGo =	0;
		m_nHistorySave = 0;
		m_nHistorySaveCnt =	0;
		m_nNoReposition	= 0;
		m_nKeyChgGo	= 0;

		_SetData();
	}

// Overrides
	BOOL OnSetActive()
	{
		SetModified(TRUE);

		return DoDataExchange(FALSE);
	}
	BOOL OnKillActive()
	{
		return DoDataExchange(TRUE);
	}
	BOOL OnApply()
	{
		if (DoDataExchange(TRUE)) {
			_GetData();
			return TRUE;
		}
		else
			return FALSE;
	}

// Constructor
	// f[^𓾂
	void _SetData()
	{
		DWORD dwEngWidth=100, dwHistoryCnt=10;
		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("SEARCH"));
		pr.QueryValue(m_dwStatus, _T("Status"));
		pr.QueryValue(dwHistoryCnt,	_T("HistoryCnt"));
		pr.Close();

		m_nHistorySaveCnt =	dwHistoryCnt;
		m_nEngChgGo	= (m_dwStatus&STS_ENG_CHANGE_GO)==STS_ENG_CHANGE_GO;
		m_nDropGo =	(m_dwStatus&STS_DROP_GO)==STS_DROP_GO;
		m_nHistorySave = (m_dwStatus&STS_HISTORY_SAVE)==STS_HISTORY_SAVE;
		m_nNoReposition	= (m_dwStatus&STS_NO_REPOSITION)==STS_NO_REPOSITION;
		m_nKeyChgGo	= (m_dwStatus&STS_KEY_CHANGE_GO)==STS_KEY_CHANGE_GO;
	}

	// f[^ۑ
	void _GetData()
	{
		m_dwStatus = 0;
		if (m_nEngChgGo)
			m_dwStatus |= STS_ENG_CHANGE_GO;
		if (m_nDropGo)
			m_dwStatus |= STS_DROP_GO;
		if (m_nHistorySave)
			m_dwStatus |= STS_HISTORY_SAVE;
		if (m_nNoReposition)
			m_dwStatus |= STS_NO_REPOSITION;
		if (m_nKeyChgGo)
			m_dwStatus |= STS_KEY_CHANGE_GO;


		CIniSection	pr;
		pr.Open(_szIniFileName,	_T("SEARCH"));
		pr.SetValue(m_dwStatus,	_T("Status"));
		pr.SetValue((DWORD)m_nHistorySaveCnt, _T("HistoryCnt"));
		pr.Close();
	}

// Message map and handlers
	BEGIN_MSG_MAP(CSearchPropertyPage)
		CHAIN_MSG_MAP(CPropertyPageImpl<CSearchPropertyPage>)
	END_MSG_MAP()
};